(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Circuit`"]


(* ::Input::Initialization:: *)
Circuit::usage="Circuit is a package to draw arbitrary circuits.  DrawCircuit is the main circuit-drawing function.  It contanins the following functions for Circuit Elements: Wire, Node, Resistor, Capacitor, Inductor, Diode, DCVoltage, ACVoltage and InlineMeter, and also GraphicsLayering, GraphicsLayer, UndershadeWrapper and UndershadeRectangle.  Options for all circuit elements are in Options[DrawCircuit].";
DrawCircuit::usage="DrawCircuit[\!\(\*
StyleBox[\"nodes\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"conn\",\nFontSlant->\"Italic\"]\) or {\!\(\*SubscriptBox[
StyleBox[\"conn\",\nFontSlant->\"Italic\"], \(1\)]\), \!\(\*SubscriptBox[
StyleBox[\"conn\",\nFontSlant->\"Italic\"], \(2\)]\), ...}, \!\(\*
StyleBox[\"extraElementList\",\nFontSlant->\"Italic\"]\):{}, \!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)] is the main circuit-drawing function.
   \!\(\*
StyleBox[\"nodes\",\nFontSlant->\"Italic\"]\) are specified as an association \[LeftAssociation]\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\)\[Rule]\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\)\[Rule]\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...\[RightAssociation], or as a list {{\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\)},{\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\)},... } or most simply {\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...}, where the labels are sequential integers.
   The second entry contains a list of connections where each connection has the form: {{\!\(\*SubscriptBox[
StyleBox[\"node\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"node\",\nFontSlant->\"Italic\"], \(2\)]\)},{\!\(\*SubscriptBox[
StyleBox[\"element\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"element\",\nFontSlant->\"Italic\"], \(2\)]\),...}}.
   \!\(\*
StyleBox[\"extraElementList\",\nFontSlant->\"Italic\"]\) is optional containing nodes to display and label. Each node has the form {\!\(\*
StyleBox[\"lbl\",\nFontSlant->\"Italic\"]\),Node[\!\(\*
StyleBox[\"string\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)]}.
   Options of all circuit elements are in Options[DrawCircuit]; this allows them to be specified for all elements in a graphic or for a specific element. Circuit elements have a size that is rescaled to fit the node positions. The scale of the elements is relative to a standard (8 turn) resistor having length 1 with a spacer of length 1/4 placed on each side of all elements.";
GraphicsLayering::usage="GraphicsLayering[expr] sorts the graphics labeled by GraphicsLayer and then removes the GraphicsLayer labels. Layers are ranked with higher on the top";
GraphicsLayer::usage="GraphicsLayer[layer,expr] places the graphics expr above or below other graphics.  Unlabeled graphics has level zero with the higher layers on top.";
Resistor::usage="Resistor[string,options] is a circuit element. Its specific options (in Options[DrawCircuit]) are ResistorFlipped, ResistorTurnNumber, ResistorDirectives. Other options are: BaseElementDirectives, TextOffsetScale, TextOffset, DefaultTextOffset, ExtraTextArgumentsList and WrapperFunction";
Wire::usage="Wire[x,opts] is a wire (line) of length x, where Wire[]=Wire[1/2]. The specific option is WireDirectives and other the other relevent option is WrapperFunction";
Node::usage="Node[string,opts] where opts are options from DrawCircuit.";
Diode::usage="Diode[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit.";
DCVoltage::usage="DCVoltage[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
DCCurrent::usage="DCCurrent[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. IT is a current source. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
Capacitor::usage="Capacitor[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
Inductor::usage="Inductor[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
ACVoltage::usage="ACVoltage[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
CurrentArrow::usage="CurrentArrow[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit]. ";
InlineMeter::usage="DCVoltage[\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
OffsetPoints::usage="OffsetPoints[{\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\)},\!\(\*
StyleBox[\"gap\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"fraction\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"offset\",\nFontSlant->\"Italic\"]\),\!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
Ground::usage="Ground[\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";
UnderShadeWrapper::usage="UnderShadeWrapper[directives,opts][expr] is an option for a circuit element to wrap the element with a copy of itself but with the specified directives. It is placed below the element because Options[UnderShadeWrapper]={GraphicsLayer\[Rule]-1}";
UnderRectangleWrapper::usage="UnderRectangleWrapper[directives,opts][expr]is an option for a circuit element to put a recatangle with the specified directives below the element. Options[UnderRectangleWrapper]={GraphicsLayer\[Rule]-1,OverLength\[Rule]0,OverWidth\[Rule]0}";
CircuitSwitch::usage="CircuitSwitch[\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in Options[DrawCircuit].";


(* ::Input::Initialization:: *)
BaseElementDirectives::usage="BaseElementDirectives is an option for DrawCircuit.";
TextOffsetScale::usage="TextOffsetScale is an option for DrawCircuit.";
DefaultTextOffset::usage="DefaultTextOffset is an option for DrawCircuit.";
ExtraTextArgumentsList::usage="ExtraTextArgumentsList is an option for DrawCircuit.";
DefaultDiagonalTextOffset::usage="DefaultDiagonalTextOffset is an option for DrawCircuit.";
BaseElementDirectives::usage="BaseElementDirectives is an option for DrawCircuit.";
ResistorFlipped::usage="ResistorFlipped is an option for DrawCircuit.";
ResistorTurnNumber::usage="ResistorTurnNumber is an option for DrawCircuit.";
ResistorDirectives::usage="ResistorDirectives is an option for DrawCircuit.";
WrapperFunction::usage="WrapperFunction is an option for DrawCircuit.";
WireDirectives::usage="WireDirectives is an option for DrawCircuit.";
NodeDirectives::usage="NodeDirectives is an option for DrawCircuit.";
NodeReplacementRules::usage="NodeReplacementRules is an option for DrawCircuit.";
DCVoltageDirectives::usage="DCVoltageDirectives is an option for DrawCircuit.";
DCVoltageNegativeTerminalDirectives::usage="DCVoltageNegativeTerminalDirectives is an option for DrawCircuit.";
DCVoltageNegativeTerminalScale::usage="DCVoltageNegativeTerminalScale is an option for DrawCircuit.";
DCVoltageFlipped::usage="DCVoltageFlipped is an option for DrawCircuit.";
DCVoltageShowPolarity::usage="DCVoltageShowPolarity is an option for DrawCircuit.";
DCVoltagePolarityOffset::usage="DCVoltagePolarityOffset is an option for DrawCircuit.";
DCVoltagePolarityStyle::usage="DCVoltagePolarityStyle is an option for DrawCircuit.";
DCVoltageWidth::usage="DCVoltageWidth is an option for DrawCircuit.";
DCVoltageGap::usage="DCVoltageGap is an option for DrawCircuit.";
DCVoltageNumberCells::usage="DCVoltageNumberCells is an option for DrawCircuit.";
CapacitorGap::usage="CapacitorGap is an option for DrawCircuit.";
CapacitorWidth::usage="CapacitorWidth is an option for DrawCircuit.";
CapacitorDirectives::usage="CapacitorDirectives is an option for DrawCircuit.";
InductorFlipped::usage="InductorFlipped is an option for DrawCircuit.";
InductorTurnNumber::usage="InductorTurnNumber is an option for DrawCircuit.";
InductorDirectives::usage="InductorDirectives is an option for DrawCircuit.";
InductorTurnSegments::usage="InductorTurnSegments is an option for DrawCircuit.";
InductorTurnTightness::usage="InductorTurnTightness is an option for DrawCircuit.";
CurrentArrowScale::usage="CurrentArrowScale is an option for DrawCircuit.";
CurrentArrowFlipped::usage="CurrentArrowFlipped is an option for DrawCircuit.";
CurrentArrowDirectives::usage="CurrentArrowDirectives is an option for DrawCircuit.";
CurrentArrowType::usage="CurrentArrowType is an option for DrawCircuit.";
InlinePolygonalArrowLength::usage="InlinePolygonalArrowLength is an option for DrawCircuit.";
OffsetArrowLength::usage="OffsetArrowLength is an option for DrawCircuit.";
OffsetArrowOffset::usage="OffsetArrowOffset is an option for DrawCircuit.";
DiodeSize::usage="DiodeSize is an option for DrawCircuit.";
DiodeFlipped::usage="DiodeFlipped is an option for DrawCircuit.";
DiodeFilled::usage="DiodeFilled is an option for DrawCircuit.";
DiodeWidthRatio::usage="DiodeWidthRatio is an option for DrawCircuit.";
DiodeBarDirectives::usage="DiodeBarDirectives is an option for DrawCircuit.";
DiodeDirectives::usage="DiodeDirectives is an option for DrawCircuit.";
ACVoltageRadius::usage="ACVoltageRadius is an option for DrawCircuit.";
ACVoltageDirectives::usage="ACVoltageDirectives is an option for DrawCircuit.";
ACVoltageImageRatio::usage="ACVoltageImageRatio is an option for DrawCircuit.";
DCCurrentRadius::usage="DCCurrentRadius is an option for DrawCircuit.";
DCCurrentDirectives::usage="DCCurrentDirectives is an option for DrawCircuit.";
DCCurrentFlipped::usage="DCCurrentFlipped is an option for DrawCircuit.";
DCCurrentArrowBaseDirectives::usage="DCCurrentArrowBaseDirectives is an option for DrawCircuit.";
DCCurrentArrowDirectives::usage="DCCurrentArrowDirectives is an option for DrawCircuit.";
DCCurrentImageRatio::usage="DCCurrentImageRatio is an option for DrawCircuit.";
DCCurrentArrowTipLengthRatio::usage="DCCurrentArrowTipLengthRatio is an option for DrawCircuit.";
DCCurrentArrowTipWidthRatio::usage="DCCurrentArrowTipWidthRatio is an option for DrawCircuit.";
InlineMeterRadius::usage="InlineMeterRadius is an option for DrawCircuit.";
InlineMeterDirectives::usage="InlineMeterDirectives is an option for DrawCircuit.";
GroundScale::usage="GroundScale is an option for DrawCircuit.";
GroundHeightRatio::usage="GroundHeightRatio is an option for DrawCircuit.";
GroundLineNumber::usage="GroundLineNumber is an option for DrawCircuit.";
GroundMinWidthRatio::usage="GroundMinWidthRatio is an option for DrawCircuit.";
GroundHeightRatio::usage="GroundHeightRatio is an option for DrawCircuit.";
GroundOffsetRatio::usage="GroundOffsetRatio is an option for DrawCircuit.";
GroundOffsetDirectives::usage="GroundOffsetDirectives is an option for DrawCircuit"
GroundDirectives::usage="GroundDirectives is an option for DrawCircuit.";
GroundOrientation::usage"GroundOrientation is an option for DrawCircuit."
GraphicsLayer::usage="GraphicsLayer is an option for UnderShadeWrapper and UnderRectangleWrapper.";OverLength::usage="OverLength is an option for UnderRectangleWrapper.";OverWidth::usage="OverWidth is an option for UnderRectangleWrapper.";
CircuitSwitchSize::usage="CircuitSwitchSize is an option for DrawCircuit";
CircuitSwitchPosition::usage="CircuitSwitchPosition is an option for DrawCircuit";
CircuitSwitchOpenAngle::usage="CircuitSwitchOpenAngle is an option for DrawCircuit";
CircuitSwitchOpenSense::usage="CircuitSwitchOpenSense is an option for DrawCircuit";
CircuitSwitchPointSize::usage="CircuitSwitchPointSize is an option for DrawCircuit";CircuitSwitchDirectives::usage="CircuitSwitchDirectives is an option for DrawCircuit";


(* ::Input::Initialization:: *)
Begin["Global`"]
TextOffset::usage="TextOffset is an option for DrawCircuit.";
End[]


(* ::Input::Initialization:: *)
Begin["`Private`"]


(* ::Input::Initialization:: *)
DrawCircuit::nodes = "The first argument `1` should be of the form \[LeftAssociation]\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\)\[Rule]\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\)\[Rule]\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...\[RightAssociation], {{\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\)},{\!\(\*SubscriptBox[
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\)},... } or {\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...}";
DrawCircuit::nodematch = "`1` contains an undefined node.";
DrawCircuit::connection = "`1` is not a properly formed connection.";


(* ::Input::Initialization:: *)
Options[DrawCircuit]={TextOffsetScale->1,TextOffset->Automatic,DefaultTextOffset->{0,1},ExtraTextArgumentsList->None,DefaultDiagonalTextOffset->{-1,1},
BaseElementDirectives->{AbsoluteThickness[2]},
ResistorFlipped->False,ResistorTurnNumber->6,ResistorDirectives->{},WrapperFunction->Identity,WireDirectives->{},NodeDirectives->AbsolutePointSize[3],NodeReplacementRules->{},DCVoltageDirectives->{},DCVoltageNegativeTerminalDirectives->{AbsoluteThickness[3]},DCVoltageNegativeTerminalScale->1/3,DCVoltageFlipped->False,DCVoltageShowPolarity->False,DCVoltagePolarityOffset->{1/8,1/8},DCVoltagePolarityStyle->{},DCVoltageWidth->1/4,DCVoltageGap->1/8,DCVoltageNumberCells->1,CapacitorGap->1/8,CapacitorWidth->1/4,CapacitorDirectives->{},InductorFlipped->False,InductorTurnNumber->3,InductorDirectives->{},InductorTurnSegments->12,InductorTurnTightness->.5,CurrentArrowScale->1,CurrentArrowFlipped->False,CurrentArrowDirectives->{GrayLevel[.25]},CurrentArrowType->"Simple Line",
InlinePolygonalArrowLength->.25,OffsetArrowLength->.5,OffsetArrowOffset->.5,DiodeSize->1/4,DiodeFlipped->False,DiodeFilled->False,DiodeWidthRatio->2/Sqrt[3],DiodeBarDirectives->AbsoluteThickness[2],DiodeDirectives->{},ACVoltageRadius->1/4,ACVoltageDirectives->{},ACVoltageImageRatio->.7,DCCurrentRadius->1/4,DCCurrentDirectives->{},DCCurrentFlipped->False,DCCurrentArrowBaseDirectives->{AbsoluteThickness[3]},DCCurrentArrowDirectives->{},DCCurrentImageRatio->.6,DCCurrentArrowTipLengthRatio->.4,DCCurrentArrowTipWidthRatio->.3,InlineMeterRadius->1/4,InlineMeterDirectives->{},GroundScale->1,GroundHeightRatio->.4,GroundLineNumber->3,GroundMinWidthRatio->.4,GroundHeightRatio->.4,GroundOffsetRatio->1/2,GroundDirectives->{AbsoluteThickness[2]},GroundOffsetDirectives->{},GroundOrientation->"Down",CircuitSwitchSize->1/2,CircuitSwitchPosition->"Open",CircuitSwitchOpenAngle->25\[Degree],CircuitSwitchOpenSense->"Counterclockwise",CircuitSwitchDirectives->{AbsolutePointSize[5]}};


(* ::Input::Initialization:: *)
DrawCircuit[nodePositionList_List,connectionList_List,extraElementList_List:{},opts:OptionsPattern[]]:=
If[Or[And@@((pair\[Function]MatchQ[pair,{_?NumericQ,_?NumericQ}])/@nodePositionList),And@@((labelAndPair\[Function]MatchQ[labelAndPair,{_,{_?NumericQ,_?NumericQ}}])/@nodePositionList)],
DrawCircuit[Association@@Rule@@@If[MatrixQ[nodePositionList],MapIndexed[{#2[[1]],#1}&,nodePositionList],nodePositionList],connectionList,extraElementList,opts],
Message[DrawCircuit::nodes,nodePositionList];Null];


(* ::Input::Initialization:: *)
DrawCircuit[xyTemp_Association,connectionList_List,extraElementList_List:{},opts:OptionsPattern[]]:=
Module[{ScaleFactor,tempSF,xy=xyTemp,offsetNodeLabel},
If[\[Not]And[And@@((assocRule\[Function]MatchQ[assocRule,_->{_?NumericQ,_?NumericQ}])/@Normal[xy]),Head[xy]===Association],
Message[DrawCircuit::nodes,xy];Null,
Do[With[{nodeList=Keys[xy],nodePair=
Switch[conn,
{{_,_},_},First[conn],
{OffsetPoints[{_,_},__],_},conn[[1,1]],
_,Message[DrawCircuit::connection,conn];{}]},
If[\[Not]SubsetQ[nodeList,nodePair],
Message[DrawCircuit::nodematch,nodePair]]],{conn,connectionList}];
GraphicsLayering[
With[{modifiedConnectionList={#[[1]],#[[2]]//ToList}&/@(With[{OffsetPointsRule={before___,{OffsetPoints[{a_,b_},\[Lambda]_,OS_,OptionsPattern[DrawCircuit]],blah_},after___}:>With[{wireDirs=With[{ov=OptionValue[OffsetPoints,WireDirectives]},If[MatrixQ[ov],ov,{ov,ov}]],
uPerp=With[{u=Normalize[xy[b]-xy[a]]},{-u[[2]],u[[1]]}/tempSF]},
With[
{r1=xy[a]+\[Lambda] (xy[b]-xy[a])+uPerp OS,
r2=xy[b]+\[Lambda] (xy[a]-xy[b])+uPerp OS,
label1=offsetNodeLabel[Length[xy]+1],label2=offsetNodeLabel[Length[xy]+2]},
AssociateTo[xy,{label1->r1,label2->r2}];
{before,{{a,label1},{Wire[0,WireDirectives->wireDirs[[1]]]}},{{label1,label2},Join[{Wire[0,WireDirectives->wireDirs[[1]]]},blah//ToList,{Wire[0,WireDirectives->wireDirs[[2]]]}]},{{label2,b},{Wire[0,WireDirectives->wireDirs[[2]]]}},after}]]},
connectionList//.OffsetPointsRule])},
With[{LinePolygonMappingRules=
f\[Function]{Line[y_List]:>Line[f/@y],
Point[r_List]:>Point[f[r]],
Circle[x_List,R_,z___]:>Circle[f[x],Norm[f[{R,0}]-f[{0,0}]],z],
Arrow[y_List]:>Arrow[f/@y],
Polygon[y_List]:>Polygon[f/@y],
Text[str_,x_,ext___]:>Text[str,f[x],ext],
Rectangle[{x1_,y1_},{x2_,y2_}]:>Polygon[f/@{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}],
GraphicsComplex[y_List,unchanged___]:>GraphicsComplex[f/@y,unchanged],
SinePeriod[r0_List,T_]:>SinePeriod[f[r0],Norm[f[{T,0}]-f[{0,0}]]]}},
ScaleFactor=
If[modifiedConnectionList==={},1,Max@@(((Plus@@Size/@#[[2]]+(Length[#[[2]]]-Count[#[[2]],Wire[___]])/2)/Norm[Subtract@@xy/@#[[1]]]&)/@modifiedConnectionList/.tempSF->1)];
{(With[{r=xy/@#[[1]],
ElementList=#[[2]]/.f_[exprs__]/;f=!=List:>f[exprs,opts]},
With[
{ShiftRight=Function[{ShiftBy,Elem},Draw[Elem]/.LinePolygonMappingRules[#1+{ShiftBy,0}&]],
\[Gamma]=Norm[r[[2]]-r[[1]]] ScaleFactor,
NumberOfElements=Length[ElementList]-Count[ElementList,Wire[___]]},
With[
{AlignElements=Function[{SpacerWidth,EL},With[{SpacedElementList=Flatten[(If[#[[0]]===Wire,{#},{Wire[SpacerWidth],#}]&)/@Append[EL,Wire[SpacerWidth]]/.
CurrentArrow[x___]:>With[{s=Size[CurrentArrow[x]]/2},{Wire[s],CurrentArrow[x],Wire[s]}]]//.{x___,Wire[a_,u___],Wire[b_,v___],y___}:>{x,Wire[a+b,u,v],y}/.Wire[x___]:>Wire[x,opts]},
ShiftRight@@@
(Transpose[{FoldList[Plus,0,Size/@Delete[SpacedElementList,-1]],
SpacedElementList}]//.{x___,{u1_,f_[v1___]},{u2_,Wire[v2___]},y___}/;f=!=Wire:>{x,{u2,Wire[v2]},{u1,f[v1]},y})]],
\[Alpha]=(r[[2]]-r[[1]])[[1]]/\[Gamma],
\[Beta]=(r[[2]]-r[[1]])[[2]]/\[Gamma],
SpacerWidth=(\[Gamma]-Plus@@Size/@ElementList)/(1+NumberOfElements)},
AlignElements[SpacerWidth,ElementList]/.LinePolygonMappingRules[{{\[Alpha],-\[Beta]},{\[Beta],\[Alpha]}}.#1+r[[1]]&]]]]&)/@modifiedConnectionList/.SineReplacementRule/.tempSF->ScaleFactor,
(nodeSingleElementList\[Function](Draw/@ToList[nodeSingleElementList[[2]]])/.LinePolygonMappingRules[#/ScaleFactor+xy[nodeSingleElementList[[1]]]&])/@extraElementList
}]]]]]


(* ::Input::Initialization:: *)
ToList=If[Head[#]===List,#,{#}]&;


(* ::Input::Initialization:: *)
GraphicsLayering[expr_]:=With[{belowLayers=Cases[expr,GraphicsLayer[_?(NumericQ[#]\[And]#<=0&),_],\[Infinity]],aboveLayers=Cases[expr,GraphicsLayer[_?(NumericQ[#]\[And]#>0&),_],\[Infinity]],middleLayer=DeleteCases[expr,GraphicsLayer[_?NumericQ,_],\[Infinity]],
sortGL=#1[[1]]<#2[[1]]&},
{Sort[belowLayers,sortGL],middleLayer,Sort[aboveLayers,sortGL]}/.GraphicsLayer[_,stuff_]:> stuff]


(* ::Input::Initialization:: *)
Options[UnderShadeWrapper]={GraphicsLayer->-1};
UnderShadeWrapper[dirs_,OptionsPattern[]][expr_]:=expr/.(Line[x_]:>{Line[x],GraphicsLayer[OptionValue[GraphicsLayer],If[Head[dirs]===List,dirs,{dirs}]~Join~{Line[x]}]})


(* ::Input::Initialization:: *)
Options[UnderRectangleWrapper]={GraphicsLayer->-1,OverLength->0,OverWidth->0};UnderRectangleWrapper[dirs_,OptionsPattern[]][expr_]:=expr/.(Line[x_]:>{Line[x],GraphicsLayer[OptionValue[GraphicsLayer],If[Head[dirs]===List,dirs,{dirs}]~Join~With[{x0=x[[1,1]],x1=x[[-1,1]],w=Max[Last/@x]},With[{width=w+OptionValue[OverWidth]},{Rectangle[{x0-OptionValue[OverLength],-width},{x1+OptionValue[OverLength],width}]}]]]})


(* ::Input::Initialization:: *)
Size[CircuitSwitch[opts:OptionsPattern[DrawCircuit]]]:=OptionValue[CircuitSwitch,CircuitSwitchSize]
Draw[CircuitSwitch[opts:OptionsPattern[DrawCircuit]]]:=
With[{L=OptionValue[CircuitSwitch,CircuitSwitchSize],
\[Theta]=If[OptionValue[CircuitSwitch,CircuitSwitchPosition]==="Open",If[OptionValue[CircuitSwitch,CircuitSwitchOpenSense]==="Counterclockwise",1,-1]*OptionValue[CircuitSwitch,CircuitSwitchOpenAngle],
0]},
Join[OptionValue[CircuitSwitch,BaseElementDirectives]//ToList,OptionValue[CircuitSwitch,CircuitSwitchDirectives]//ToList,{Line[{{0,0},L{Cos[\[Theta]],Sin[\[Theta]]}}],Point[{0,0}],Point[{L,0}]}]
]


(* ::Input::Initialization:: *)
Resistor[opts:OptionsPattern[DrawCircuit]]:=Resistor["",opts];
Size[Resistor[_,OptionsPattern[DrawCircuit]]]:=OptionValue[Resistor,ResistorTurnNumber]/8;
Draw[Resistor[str_,OptionsPattern[DrawCircuit]]]:=
With[{TO=Switch[OptionValue[Resistor,TextOffset],
Automatic,OptionValue[Resistor,DefaultTextOffset],
_List,OptionValue[Resistor,TextOffset],
_,{0,OptionValue[Resistor,TextOffset]}],
TD=OptionValue[Resistor,TextOffsetScale]/4,
s=If[OptionValue[Resistor,ResistorFlipped],-1,+1],
n=OptionValue[Resistor,ResistorTurnNumber],
extraTextList=Switch[OptionValue[Resistor,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[Resistor,ExtraTextArgumentsList]],{OptionValue[Resistor,ExtraTextArgumentsList]},
_,{OptionValue[Resistor,ExtraTextArgumentsList]}]},{Join[OptionValue[Resistor,BaseElementDirectives]//ToList,OptionValue[Resistor,ResistorDirectives]//ToList,{Line[Join[{{0,0}},Table[{2 i-1,-s (-1)^i}/16,{i,n}],{{n/8,0}}]]//OptionValue[Resistor,WrapperFunction]},{If[str==="",{},Text@@Join[{str,{n/16,0}+TD TO},extraTextList]]}]}
]


(* ::Input::Initialization:: *)
Size[Diode[OptionsPattern[DrawCircuit]]]:=OptionValue[Diode,DiodeSize];
Draw[Diode[OptionsPattern[DrawCircuit]]]:=
With[{x1=If[OptionValue[Diode,DiodeFlipped],OptionValue[Diode,DiodeSize],0],
x2=If[OptionValue[Diode,DiodeFlipped],0,OptionValue[Diode,DiodeSize]],
a=OptionValue[Diode,DiodeSize],
W=OptionValue[Diode,DiodeWidthRatio]},{Join[OptionValue[Diode,BaseElementDirectives]//ToList,OptionValue[Diode,DiodeDirectives]//ToList,{{Join[OptionValue[Diode,DiodeBarDirectives]//ToList,{Line[{{x2,a W/2},{x2,-a W/2}}]}],{If[OptionValue[Diode,DiodeFilled],Polygon,Line][{{x2,0},{x1,a W/2},{x1,-a W/2},{x2,0}}]}}//OptionValue[Diode,WrapperFunction]}]}
]


(* ::Input::Initialization:: *)
DCVoltage[opts:OptionsPattern[DrawCircuit]]:=DCVoltage["",opts]
Size[DCVoltage[_,OptionsPattern[DrawCircuit]]]:=OptionValue[DCVoltage,DCVoltageGap]*(2 OptionValue[DCVoltage,DCVoltageNumberCells]-1);
Draw[DCVoltage[str_,OptionsPattern[DrawCircuit]]]:=
With[{s=If[OptionValue[DCVoltage,DCVoltageFlipped],-1,+1],
a=OptionValue[DCVoltage,DCVoltageGap],
n=OptionValue[DCVoltage,DCVoltageNumberCells],
negScale=OptionValue[DCVoltage,DCVoltageNegativeTerminalScale],
W=OptionValue[DCVoltage,DCVoltageWidth]},{Join[OptionValue[DCVoltage,BaseElementDirectives]//ToList,OptionValue[DCVoltage,DCVoltageDirectives]//ToList,{Table[{Join[OptionValue[DCVoltage,DCVoltageNegativeTerminalDirectives]//ToList,{Line[{{(1-s)/2 a+2 i a,negScale W},{(1-s)/2 a+2 i a,-negScale W}}]}],{Line[{{(1+s)/2 a+2 i a,W},{(1+s)/2 a+2 i a,-W}}]}},{i,0,n-1}]//OptionValue[DCVoltage,WrapperFunction]},
If[OptionValue[DCVoltage,DCVoltageShowPolarity],
With[{positions={{-1,1}OptionValue[DCVoltage,DCVoltagePolarityOffset],{1,1}OptionValue[DCVoltage,DCVoltagePolarityOffset]+{(2 n-1) a,0}}//If[OptionValue[DCVoltage,DCVoltageFlipped],Identity,Reverse]},
{Style@@{{{Text["+",positions[[1]]],Text["-",positions[[2]]]}},OptionValue[DCVoltage,DCVoltagePolarityStyle]//ToList}}],
{}],
With[{TO=With[{defaultTO=If[OptionValue[DCVoltage,DCVoltageShowPolarity],1.5OptionValue[DCVoltage,DefaultTextOffset],MapAt[s #&,OptionValue[DCVoltage,DefaultDiagonalTextOffset],1]]},
Switch[OptionValue[DCVoltage,TextOffset],
Automatic,defaultTO,
_List,OptionValue[DCVoltage,TextOffset],
_,OptionValue[DCVoltage,TextOffset] defaultTO]],
TD=OptionValue[DCVoltage,TextOffsetScale]/4,
extraTextList=Switch[OptionValue[DCVoltage,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[DCVoltage,ExtraTextArgumentsList]],{OptionValue[DCVoltage,ExtraTextArgumentsList]},
_,{OptionValue[DCVoltage,ExtraTextArgumentsList]}]},If[str==="",{},{Text@@Join[{str,{(n-1/2) a,0}+TD TO},extraTextList]}]]]}
]


(* ::Input::Initialization:: *)
Capacitor[opts:OptionsPattern[DrawCircuit]]:=Capacitor["",opts];
Size[Capacitor[_,OptionsPattern[DrawCircuit]]]:=OptionValue[Capacitor,CapacitorGap];
Draw[Capacitor[str_,OptionsPattern[DrawCircuit]]]:=
With[
{a=OptionValue[Capacitor,CapacitorGap],
W=OptionValue[Capacitor,CapacitorWidth]},{Join[OptionValue[Capacitor,BaseElementDirectives]//ToList,OptionValue[Capacitor,CapacitorDirectives]//ToList,{Line[{{0,W},{0,-W}}],Line[{{a,W},{a,-W}}]}//OptionValue[Capacitor,WrapperFunction],With[{TO=With[{defaultTO=OptionValue[Capacitor,DefaultDiagonalTextOffset]},Switch[OptionValue[Capacitor,TextOffset],
Automatic,defaultTO,
_List,OptionValue[Capacitor,TextOffset],
_,OptionValue[Capacitor,TextOffset] defaultTO]],
TD=OptionValue[Capacitor,TextOffsetScale]/4,
extraTextList=Switch[OptionValue[Capacitor,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[Capacitor,ExtraTextArgumentsList]],{OptionValue[Capacitor,ExtraTextArgumentsList]},
_,{OptionValue[Capacitor,ExtraTextArgumentsList]}]},If[str==="",{},{Text@@Join[{str,{a/2,0}+TD TO},extraTextList]}]]]}
]


(* ::Input::Initialization:: *)
Inductor[opts:OptionsPattern[DrawCircuit]]:=Inductor["",opts];
Size[Inductor[_,OptionsPattern[DrawCircuit]]]:=((1.25-.5 OptionValue[Inductor,InductorTurnTightness])(2 OptionValue[Inductor,InductorTurnNumber]+1)+2)/11;
Draw[Inductor[str_,OptionsPattern[DrawCircuit]]]:=
With[{TO=Switch[OptionValue[Inductor,TextOffset],
Automatic,OptionValue[Inductor,DefaultTextOffset],
_List,OptionValue[Inductor,TextOffset],
_,{0,OptionValue[Inductor,TextOffset]}],
TD=OptionValue[Inductor,TextOffsetScale]/4,
s=If[OptionValue[Inductor,InductorFlipped],-1,+1],
n=OptionValue[Inductor,InductorTurnNumber],
p=OptionValue[Inductor,InductorTurnSegments],
tightness=OptionValue[Inductor,InductorTurnTightness],
extraTextList=Switch[OptionValue[Inductor,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[Inductor,ExtraTextArgumentsList]],{OptionValue[Inductor,ExtraTextArgumentsList]},
_,{OptionValue[Inductor,ExtraTextArgumentsList]}]},{Join[OptionValue[Inductor,BaseElementDirectives]//ToList,OptionValue[Inductor,InductorDirectives]//ToList,{Line[Table[1/11 {(1.25-.5 tightness) t+1-Cos[t \[Pi]],s Sin[t \[Pi]]},{t,0,2 n+1,1/p}]]//OptionValue[Inductor,WrapperFunction]},{If[str==="",{},Text@@Join[{str,{((1.25-.5 tightness) (2 n+1)+2)/22,0}+TD TO},extraTextList]]}]}]


(* ::Input::Initialization:: *)
CurrentArrow[opts:OptionsPattern[DrawCircuit]]:=CurrentArrow["",opts];
Size[CurrentArrow[_,OptionsPattern[DrawCircuit]]]=Switch[OptionValue[CurrentArrowType],
"Inline Polygon",OptionValue[InlinePolygonalArrowLength],
"Offset Arrow",OptionValue[OffsetArrowLength],_,0];
Draw[CurrentArrow[str_,OptionsPattern[DrawCircuit]]]:=
With[
{W=OptionValue[CurrentArrow,CurrentArrowScale]/2,
s=If[OptionValue[CurrentArrow,CurrentArrowFlipped],-1,+1],
extraOS=1/4 {0,If[OptionValue[CurrentArrow,CurrentArrowType]==="Offset Arrow",
OptionValue[CurrentArrow,OffsetArrowOffset],0]}},{Join[OptionValue[CurrentArrow,BaseElementDirectives]//ToList,OptionValue[CurrentArrow,CurrentArrowDirectives]//ToList,Switch[OptionValue[CurrentArrow,CurrentArrowType],
"Simple Line",{Line[{{-(1/8) s W,W/8},{1/8 s W,0},{-(1/8) s W,-(W/8)}}]},
"Simple Polygon",{Polygon[{{-(1/8) s W,W/8},{1/8 s W,0},{-(1/8) s W,-(W/8)}}]},
"Inline Polygon",
With[{length=OptionValue[CurrentArrow,InlinePolygonalArrowLength],wRatio=2/3,arrowWidthRatio=1},
{Polygon[
{s length{-1/2,-wRatio/2},
s length{(1-arrowWidthRatio)/2 ,-wRatio/2},
s length{(1-arrowWidthRatio)/2 ,-arrowWidthRatio/2},
s {length/2,0},
s length{(1-arrowWidthRatio)/2 ,arrowWidthRatio/2},
s length{(1-arrowWidthRatio)/2 ,wRatio/2},
s length{-1/2,wRatio/2}}]}],
"Offset Arrow",{With[{L=OptionValue[CurrentArrow,OffsetArrowLength]},Arrow[{{-s L/2,0}+extraOS,{s L/2,0}+extraOS}]]}],
With[{TO=Switch[OptionValue[CurrentArrow,TextOffset],
Automatic,OptionValue[CurrentArrow,DefaultTextOffset],
_List,OptionValue[CurrentArrow,TextOffset],
_,{0,OptionValue[CurrentArrow,TextOffset]}],
TD=OptionValue[CurrentArrow,TextOffsetScale]/4,
extraTextList=Switch[OptionValue[CurrentArrow,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[CurrentArrow,ExtraTextArgumentsList]],{OptionValue[CurrentArrow,ExtraTextArgumentsList]},
_,{OptionValue[CurrentArrow,ExtraTextArgumentsList]}]},If[str==="",{},{Text@@Join[{str,TD TO+extraOS},extraTextList]}]]]}
]


(* ::Input::Initialization:: *)
ACVoltage[opts:OptionsPattern[DrawCircuit]]:=ACVoltage["",opts];
Size[ACVoltage[_,OptionsPattern[DrawCircuit]]]:=2 OptionValue[ACVoltage,ACVoltageRadius];
SineReplacementRule=SinePeriod[r0_List,T_]:>With[{A=.35 T},Line[Table[r0+{t,-A Sin[(2 \[Pi])/T t]},{t,-T/2,T/2,T/20}]]];
Draw[ACVoltage[str_,OptionsPattern[DrawCircuit]]]:=
With[{R=OptionValue[ACVoltage,ACVoltageRadius],
T=2 OptionValue[ACVoltage,ACVoltageImageRatio] OptionValue[ACVoltage,ACVoltageRadius],TO=Switch[OptionValue[ACVoltage,TextOffset],
Automatic,OptionValue[ACVoltage,DefaultTextOffset],
_List,OptionValue[ACVoltage,TextOffset],
_,{0,OptionValue[ACVoltage,TextOffset]}],
TD=OptionValue[ACVoltage,TextOffsetScale]/8,
extraTextList=Switch[OptionValue[ACVoltage,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[ACVoltage,ExtraTextArgumentsList]],{OptionValue[ACVoltage,ExtraTextArgumentsList]},
_,{OptionValue[ACVoltage,ExtraTextArgumentsList]}]},{Join[OptionValue[ACVoltage,BaseElementDirectives]//ToList,OptionValue[ACVoltage,ACVoltageDirectives]//ToList,
{Circle[{R,0},R],SinePeriod[{R,0},T]}],
{If[str==="",{},Text@@Join[{str,{R,0}+TD TO+Sign[TO[[2]]] {0,R}},extraTextList]]}}
]


(* ::Input::Initialization:: *)
DCCurrent[opts:OptionsPattern[DrawCircuit]]:=DCCurrent["",opts];
Size[DCCurrent[_,OptionsPattern[DrawCircuit]]]:=2 OptionValue[DCCurrent,DCCurrentRadius];
Draw[DCCurrent[str_,OptionsPattern[DrawCircuit]]]:=
With[{R=OptionValue[DCCurrent,DCCurrentRadius],
sgn=If[OptionValue[DCCurrent,DCCurrentFlipped],-1,1],
tipL=OptionValue[DCCurrent,DCCurrentArrowTipLengthRatio] OptionValue[DCCurrent,DCCurrentRadius],
tipW=OptionValue[DCCurrent,DCCurrentArrowTipWidthRatio] OptionValue[DCCurrent,DCCurrentRadius],
AL=2  OptionValue[DCCurrent,DCCurrentImageRatio] OptionValue[DCCurrent,DCCurrentRadius],TO=Switch[OptionValue[DCCurrent,TextOffset],
Automatic,OptionValue[DCCurrent,DefaultTextOffset],
_List,OptionValue[DCCurrent,TextOffset],
_,{0,OptionValue[DCCurrent,TextOffset]}],
TD=OptionValue[DCCurrent,TextOffsetScale]/8,
extraTextList=Switch[OptionValue[DCCurrent,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[DCCurrent,ExtraTextArgumentsList]],{OptionValue[DCCurrent,ExtraTextArgumentsList]},
_,{OptionValue[DCCurrent,ExtraTextArgumentsList]}]},{Join[OptionValue[DCCurrent,BaseElementDirectives]//ToList,OptionValue[DCCurrent,DCCurrentDirectives]//ToList,
{Circle[{R,0},R],Join[OptionValue[DCCurrent,DCCurrentArrowDirectives]//ToList,OptionValue[DCCurrent,DCCurrentArrowDirectives]//ToList,With[{tail={R-sgn AL/2,0},tip={R+sgn AL/2,0},\[CapitalDelta]x=-sgn tipL},{Line[{tail,tip}],Line[{tip+{\[CapitalDelta]x,tipW},tip,tip+{\[CapitalDelta]x,-tipW}}]}]]}],
{If[str==="",{},Text@@Join[{str,{R,0}+TD TO+Sign[TO[[2]]] {0,R}},extraTextList]]}}
]


(* ::Input::Initialization:: *)
Size[InlineMeter[_,OptionsPattern[DrawCircuit]]]:=2 OptionValue[InlineMeter,InlineMeterRadius];
Draw[InlineMeter[str_,OptionsPattern[DrawCircuit]]]:=
With[{R=OptionValue[InlineMeter,InlineMeterRadius],TO=Switch[OptionValue[InlineMeter,TextOffset],
_List,OptionValue[InlineMeter,TextOffset],
_,{0,0}],
extraTextList=Switch[OptionValue[InlineMeter,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[InlineMeter,ExtraTextArgumentsList]],{OptionValue[InlineMeter,ExtraTextArgumentsList]},
_,{OptionValue[InlineMeter,ExtraTextArgumentsList]}]},{Join[OptionValue[InlineMeter,BaseElementDirectives]//ToList,OptionValue[InlineMeter,InlineMeterDirectives]//ToList,
{Circle[{R,0},R]}],
{If[str==="",{},Text@@Join[{str,{R,0}+TO},extraTextList]]}}
]


(* ::Input::Initialization:: *)
Size[Wire[x_,___]]:=x;
Wire[opts:OptionsPattern[DrawCircuit]]=Wire[1/2,opts];
Draw[Wire[x_,OptionsPattern[DrawCircuit]]]:=
With[
{L=Line[{{0,0},{x,0}}]},
OptionValue[Wire,WrapperFunction][Join[OptionValue[Wire,WireDirectives]//ToList,{L}]]]


(* ::Input::Initialization:: *)
Size[Node[___]]:=0;
Node[opts:OptionsPattern[DrawCircuit]]:=Node["",opts];
Draw[Node[str_,OptionsPattern[DrawCircuit]]]:=
With[
{TO=Switch[OptionValue[Node,TextOffset],
Automatic,OptionValue[Node,DefaultTextOffset],
_List,OptionValue[Node,TextOffset],
_,{0,-OptionValue[Node,TextOffset]}],
TD=OptionValue[Node,TextOffsetScale]/4,
extraTextList=Switch[OptionValue[Node,ExtraTextArgumentsList],
None,{},
_?MatrixQ[OptionValue[Node,ExtraTextArgumentsList]],{OptionValue[Node,ExtraTextArgumentsList]},
_,{OptionValue[Node,ExtraTextArgumentsList]}]},
{Join[OptionValue[Node,NodeDirectives]//ToList,{Point[{0,0}]},If[str==="",{},{Text@@Join[{str,{0,0}+TD TO},extraTextList]}]]/.OptionValue[Node,NodeReplacementRules]}]


(* ::Input::Initialization:: *)
Size[Ground[___]]=0;
Ground[opts:OptionsPattern[DrawCircuit]]:=Ground["",opts];
Draw[Ground[str_,OptionsPattern[DrawCircuit]]]:=
With[{W=OptionValue[Ground,GroundScale]/2,
TO=Switch[OptionValue[Ground,TextOffset],
Automatic,OptionValue[Ground,DefaultTextOffset],
_List,OptionValue[Ground,TextOffset],
_,{0,OptionValue[Ground,TextOffset]}],
TD=OptionValue[Ground,TextOffsetScale]/4,
extraTextList=Switch[OptionValue[Ground,ExtraTextArgumentsList],
None,{},
_,{OptionValue[Ground,ExtraTextArgumentsList]}]},
With[
{yInterpolate=\[Lambda]\[Function]\[Lambda] (-OptionValue[Ground,GroundOffsetRatio] W)+(1-\[Lambda])(-OptionValue[Ground,GroundOffsetRatio] W-OptionValue[Ground,GroundHeightRatio] W),
wInterpolate=\[Lambda]\[Function]\[Lambda] W+(1-\[Lambda])OptionValue[Ground,GroundMinWidthRatio] W },With[{downGround=Join[If[OptionValue[Ground,GroundOffsetRatio]===0,{},{Join[OptionValue[Ground,GroundOffsetDirectives]//ToList,{Line[{{0,0},-{0,W OptionValue[Ground,GroundOffsetRatio]}}]}]}],{Join[OptionValue[Ground,BaseElementDirectives],OptionValue[Ground,GroundDirectives]//ToList,Table[Line[{{-wInterpolate[\[Lambda]]/2,yInterpolate[\[Lambda]]},{wInterpolate[\[Lambda]]/2,yInterpolate[\[Lambda]]}}],{\[Lambda],0,1,1/(OptionValue[Ground,GroundLineNumber]-1)}]]}]},
{With[{\[Theta]=OptionValue[Ground,GroundOrientation]},
If[\[Theta]==="Down",
downGround,
With[{A=RotationMatrix[Switch[\[Theta],"Right",\[Pi]/2,"Up",\[Pi],"Left",-\[Pi]/2,_,\[Theta]+\[Pi]/2]]},downGround/.(Line[{r__}]:>Line[A.#&/@{r}])]]],
{If[str==="",{},{Text@@Join[{str,{0,(-OptionValue[Ground,GroundOffsetRatio] W-OptionValue[Ground,GroundHeightRatio] W)}+-TD TO},extraTextList]}]}}
]]]


(* ::Input::Initialization:: *)
End[]


(* ::Input::Initialization:: *)
EndPackage[]
