(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    256032,       5463]
NotebookOptionsPosition[    251403,       5369]
NotebookOutlinePosition[    252019,       5391]
CellTagsIndexPosition[    251976,       5388]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Circuit`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.501452538737896*^9, 3.501452548269908*^9}, {
  3.623241242552278*^9, 3.623241243920878*^9}, {3.623241324234869*^9, 
  3.623241342813883*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"ceabb2dd-a544-4b44-b965-2ef051224719"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DrawCircuit"}]], "Input",
 CellChangeTimes->{{3.623250163590591*^9, 3.623250167572749*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"599ed61a-d255-4608-b5cd-57bacfb6375f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DrawCircuit[\\!\\(\\*\\nStyleBox[\\\"nodes\\\",\\\
nFontSlant->\\\"Italic\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"]\\) or {\\!\\(\
\\*SubscriptBox[\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\), \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(2\\)]\\), ...}, \
\\!\\(\\*\\nStyleBox[\\\"extraElementList\\\",\\nFontSlant->\\\"Italic\\\"]\\)\
:{}, \\!\\(\\*\\nStyleBox[\\\"opts\\\",\\nFontSlant->\\\"Italic\\\"]\\)] is \
the main circuit-drawing function.\\n   \
\\!\\(\\*\\nStyleBox[\\\"nodes\\\",\\nFontSlant->\\\"Italic\\\"]\\) are \
specified as an association \
\[LeftAssociation]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\
\\\"Italic\\\"], \\(1\\)]\\)\[Rule]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\
\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\)\[Rule]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\
\\\"Italic\\\"], \\(2\\)]\\),...\[RightAssociation], or as a list \
{{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"Italic\\\"],\
 \\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(1\\)]\\)},{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\)},... } or most simply \
{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\),...}, where the labels are sequential integers.\\n   \
The second entry contains a list of connections where each connection has the \
form: {{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"node\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"node\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\)},{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"element\\\",\
\\nFontSlant->\\\"Italic\\\"], \\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\
\\\"element\\\",\\nFontSlant->\\\"Italic\\\"], \\(2\\)]\\),...}}.\\n   \\!\\(\
\\*\\nStyleBox[\\\"extraElementList\\\",\\nFontSlant->\\\"Italic\\\"]\\) is \
optional containing nodes to display and label. Each node has the form \
{\\!\\(\\*\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"Italic\\\"]\\),Node[\\!\\(\
\\*\\nStyleBox[\\\"string\\\",\\nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\\
nStyleBox[\\\"opts\\\",\\nFontSlant->\\\"Italic\\\"]\\)]}.\\n   Options of \
all circuit elements are in Options[DrawCircuit]; this allows them to be \
specified for all elements in a graphic or for a specific element. Circuit \
elements have a size that is rescaled to fit the node positions. The scale of \
the elements is relative to a standard (8 turn) resistor having length 1 with \
a spacer of length 1/4 placed on each side of all elements.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[
           TagBox[GridBox[{
              {
               StyleBox[
                TagBox[
                 TooltipBox[
                  StyleBox["\<\" Definitions\"\>", "InformationRowLabel",
                   StripOnInput->False],
                  "\"Definitions\"",
                  TooltipStyle->"TextStyling"],
                 Annotation[#, "Definitions", "Tooltip"]& ], "DialogStyle",
                StripOnInput->False]},
              {
               TemplateBox[{"\"\[ThinSpace]\"", 
                 GridBox[{{
                    RowBox[{
                    RowBox[{"DrawCircuit", "[", 
                    
                    RowBox[{
                    "Circuit`Private`nodePositionList_List", ",", 
                    "Circuit`Private`connectionList_List", ",", 
                    RowBox[{"Circuit`Private`extraElementList_List", ":", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"Circuit`Private`opts", ":", 
                    RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"And", "@@", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"Circuit`Private`pair", ",", 
                    RowBox[{"MatchQ", "[", 
                    RowBox[{"Circuit`Private`pair", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"_", "?", "NumericQ"}], ",", 
                    RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}]}], "]"}],
                     "/@", "Circuit`Private`nodePositionList"}]}], "||", 
                    RowBox[{"And", "@@", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"Circuit`Private`labelAndPair", ",", 
                    RowBox[{"MatchQ", "[", 
                    RowBox[{"Circuit`Private`labelAndPair", ",", 
                    RowBox[{"{", 
                    RowBox[{"_", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"_", "?", "NumericQ"}], ",", 
                    RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], 
                    "]"}]}], "]"}], "/@", 
                    "Circuit`Private`nodePositionList"}]}]}], ",", 
                    RowBox[{"DrawCircuit", "[", 
                    RowBox[{
                    RowBox[{"Association", "@@", 
                    RowBox[{"Rule", "@@@", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    
                    RowBox[{"MatrixQ", "[", 
                    "Circuit`Private`nodePositionList", "]"}], ",", 
                    RowBox[{"MapIndexed", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    
                    RowBox[{"#2", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", "#1"}], "}"}], "&"}], ",",
                     "Circuit`Private`nodePositionList"}], "]"}], ",", 
                    "Circuit`Private`nodePositionList"}], "]"}]}]}], ",", 
                    "Circuit`Private`connectionList", ",", 
                    "Circuit`Private`extraElementList", ",", 
                    "Circuit`Private`opts"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"DrawCircuit", "::", "nodes"}], "MessageName"], 
                    ",", "Circuit`Private`nodePositionList"}], "]"}], ";"}]}],
                     "]"}]}]}, {" "}, {
                    RowBox[{
                    RowBox[{"DrawCircuit", "[", 
                    
                    RowBox[{
                    "Circuit`Private`xyTemp_Association", ",", 
                    "Circuit`Private`connectionList_List", ",", 
                    RowBox[{"Circuit`Private`extraElementList_List", ":", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"Circuit`Private`opts", ":", 
                    RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
                    RowBox[{"Module", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`ScaleFactor", ",", 
                    "Circuit`Private`tempSF", ",", 
                    
                    RowBox[{"Circuit`Private`xy", "=", 
                    "Circuit`Private`xyTemp"}], ",", 
                    "Circuit`Private`offsetNodeLabel"}], "}"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"And", "@@", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"Circuit`Private`assocRule", ",", 
                    RowBox[{"MatchQ", "[", 
                    RowBox[{"Circuit`Private`assocRule", ",", 
                    RowBox[{"_", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"_", "?", "NumericQ"}], ",", 
                    RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "]"}]}], 
                    "]"}], "/@", 
                    RowBox[{"Normal", "[", "Circuit`Private`xy", "]"}]}]}], 
                    "&&", 
                    RowBox[{
                    RowBox[{"Head", "[", "Circuit`Private`xy", "]"}], "===", 
                    "Association"}]}], ")"}]}], ",", 
                    RowBox[{
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"DrawCircuit", "::", "nodes"}], "MessageName"], 
                    ",", "Circuit`Private`xy"}], "]"}], ";"}], ",", 
                    RowBox[{
                    RowBox[{"Do", "[", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`nodeList", "=", 
                    RowBox[{"Keys", "[", "Circuit`Private`xy", "]"}]}], ",", 
                    RowBox[{"Circuit`Private`nodePair", "=", 
                    RowBox[{"Switch", "[", 
                    RowBox[{"Circuit`Private`conn", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"_", ",", "_"}], "}"}], ",", "_"}], "}"}], ",", 
                    RowBox[{"First", "[", "Circuit`Private`conn", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"OffsetPoints", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"_", ",", "_"}], "}"}], ",", "__"}], "]"}], ",", 
                    "_"}], "}"}], ",", 
                    RowBox[{"Circuit`Private`conn", "\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
                    "_", ",", 
                    RowBox[{
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"DrawCircuit", "::", "connection"}], 
                    "MessageName"], ",", "Circuit`Private`conn"}], "]"}], ";", 
                    RowBox[{"{", "}"}]}]}], "]"}]}]}], "}"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", 
                    RowBox[{"SubsetQ", "[", 
                    
                    RowBox[{"Circuit`Private`nodeList", ",", 
                    "Circuit`Private`nodePair"}], "]"}]}], ",", 
                    RowBox[{"Message", "[", 
                    RowBox[{
                    StyleBox[
                    RowBox[{"DrawCircuit", "::", "nodematch"}], 
                    "MessageName"], ",", "Circuit`Private`nodePair"}], 
                    "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`conn", ",", 
                    "Circuit`Private`connectionList"}], "}"}]}], "]"}], ";", 
                    RowBox[{"GraphicsLayering", "[", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`modifiedConnectionList", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"Circuit`Private`ToList", "[", 
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "]"}]}], "}"}], "&"}], ")"}], 
                    "/@", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`OffsetPointsRule", "=", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`before___", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"OffsetPoints", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`a_", ",", "Circuit`Private`b_"}],
                     "}"}], ",", "Circuit`Private`\[Lambda]_", ",", 
                    "Circuit`Private`OS_", ",", 
                    RowBox[{"OptionsPattern", "[", "DrawCircuit", "]"}]}], 
                    "]"}], ",", "Circuit`Private`blah_"}], "}"}], ",", 
                    "Circuit`Private`after___"}], "}"}], "\[RuleDelayed]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`wireDirs", "=", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`ov", "=", 
                    RowBox[{"OptionValue", "[", 
                    RowBox[{"OffsetPoints", ",", "WireDirectives"}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"MatrixQ", "[", "Circuit`Private`ov", "]"}], ",", 
                    "Circuit`Private`ov", ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`ov", ",", "Circuit`Private`ov"}],
                     "}"}]}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"Circuit`Private`uPerp", "=", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`u", "=", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`b", 
                    "]"}], "-", 
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`a", 
                    "]"}]}], "]"}]}], "}"}], ",", 
                    FractionBox[
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", 
                    
                    RowBox[{"Circuit`Private`u", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ",", 
                    
                    RowBox[{"Circuit`Private`u", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "}"}], 
                    "Circuit`Private`tempSF"]}], "]"}]}]}], "}"}], ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`r1", "=", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`a", 
                    "]"}], "+", 
                    RowBox[{"Circuit`Private`\[Lambda]", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`b", 
                    "]"}], "-", 
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`a", 
                    "]"}]}], ")"}]}], "+", 
                    RowBox[{
                    "Circuit`Private`uPerp", " ", "Circuit`Private`OS"}]}]}], 
                    ",", 
                    RowBox[{"Circuit`Private`r2", "=", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`b", 
                    "]"}], "+", 
                    RowBox[{"Circuit`Private`\[Lambda]", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`a", 
                    "]"}], "-", 
                    RowBox[{"Circuit`Private`xy", "[", "Circuit`Private`b", 
                    "]"}]}], ")"}]}], "+", 
                    RowBox[{
                    "Circuit`Private`uPerp", " ", "Circuit`Private`OS"}]}]}], 
                    ",", 
                    RowBox[{"Circuit`Private`label1", "=", 
                    RowBox[{"Circuit`Private`offsetNodeLabel", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "Circuit`Private`xy", "]"}], "+", 
                    "1"}], "]"}]}], ",", 
                    RowBox[{"Circuit`Private`label2", "=", 
                    RowBox[{"Circuit`Private`offsetNodeLabel", "[", 
                    RowBox[{
                    RowBox[{"Length", "[", "Circuit`Private`xy", "]"}], "+", 
                    "2"}], "]"}]}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"AssociateTo", "[", 
                    RowBox[{"Circuit`Private`xy", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`label1", "\[Rule]", 
                    "Circuit`Private`r1"}], ",", 
                    RowBox[{
                    "Circuit`Private`label2", "\[Rule]", 
                    "Circuit`Private`r2"}]}], "}"}]}], "]"}], ";", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`before", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`a", ",", 
                    "Circuit`Private`label1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"WireDirectives", "\[Rule]", 
                    
                    RowBox[{"Circuit`Private`wireDirs", 
                    "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`label1", ",", 
                    "Circuit`Private`label2"}], "}"}], ",", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"WireDirectives", "\[Rule]", 
                    
                    RowBox[{"Circuit`Private`wireDirs", 
                    "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}], ",", 
                    
                    RowBox[{"Circuit`Private`ToList", "[", 
                    "Circuit`Private`blah", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"WireDirectives", "\[Rule]", 
                    
                    RowBox[{"Circuit`Private`wireDirs", 
                    "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}]}], "]"}]}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`label2", ",", 
                    "Circuit`Private`b"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Wire", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"WireDirectives", "\[Rule]", 
                    
                    RowBox[{"Circuit`Private`wireDirs", 
                    "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "]"}], "}"}]}], "}"}], ",",
                     "Circuit`Private`after"}], "}"}]}]}], "]"}]}], "]"}]}]}],
                     "}"}], ",", 
                    
                    RowBox[{"Circuit`Private`connectionList", "//.", 
                    "\[VeryThinSpace]", 
                    "Circuit`Private`OffsetPointsRule"}]}], "]"}]}]}], "}"}], 
                    ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`LinePolygonMappingRules", "=", 
                    RowBox[{"Function", "[", 
                    RowBox[{"Circuit`Private`f", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Line", "[", "Circuit`Private`y_List", "]"}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Line", "[", 
                    RowBox[{"Circuit`Private`f", "/@", "Circuit`Private`y"}], 
                    "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Point", "[", "Circuit`Private`r_List", "]"}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Point", "[", 
                    
                    RowBox[{"Circuit`Private`f", "[", "Circuit`Private`r", 
                    "]"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Circle", "[", 
                    
                    RowBox[{"Circuit`Private`x_List", ",", 
                    "Circuit`Private`R_", ",", "Circuit`Private`z___"}], 
                    "]"}], "\[RuleDelayed]", 
                    RowBox[{"Circle", "[", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`f", "[", "Circuit`Private`x", 
                    "]"}], ",", 
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Circuit`Private`f", "[", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`R", ",", "0"}], "}"}], "]"}], 
                    "-", 
                    RowBox[{"Circuit`Private`f", "[", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "]"}]}], "]"}], ",", 
                    "Circuit`Private`z"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Arrow", "[", "Circuit`Private`y_List", "]"}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Arrow", "[", 
                    RowBox[{"Circuit`Private`f", "/@", "Circuit`Private`y"}], 
                    "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Polygon", "[", "Circuit`Private`y_List", "]"}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Polygon", "[", 
                    RowBox[{"Circuit`Private`f", "/@", "Circuit`Private`y"}], 
                    "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Text", "[", 
                    
                    RowBox[{"Circuit`Private`str_", ",", "Circuit`Private`x_",
                     ",", "Circuit`Private`ext___"}], "]"}], "\[RuleDelayed]", 
                    RowBox[{"Text", "[", 
                    RowBox[{"Circuit`Private`str", ",", 
                    
                    RowBox[{"Circuit`Private`f", "[", "Circuit`Private`x", 
                    "]"}], ",", "Circuit`Private`ext"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`x1_", ",", 
                    "Circuit`Private`y1_"}], "}"}], ",", 
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`x2_", ",", 
                    "Circuit`Private`y2_"}], "}"}]}], "]"}], "\[RuleDelayed]", 
                    RowBox[{"Polygon", "[", 
                    RowBox[{"Circuit`Private`f", "/@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x1", ",", "Circuit`Private`y1"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x2", ",", "Circuit`Private`y1"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x2", ",", "Circuit`Private`y2"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x1", ",", "Circuit`Private`y2"}],
                     "}"}]}], "}"}]}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"GraphicsComplex", "[", 
                    
                    RowBox[{"Circuit`Private`y_List", ",", 
                    "Circuit`Private`unchanged___"}], "]"}], "\[RuleDelayed]", 
                    RowBox[{"GraphicsComplex", "[", 
                    RowBox[{
                    RowBox[{"Circuit`Private`f", "/@", "Circuit`Private`y"}], 
                    ",", "Circuit`Private`unchanged"}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"Circuit`Private`SinePeriod", "[", 
                    
                    RowBox[{"Circuit`Private`r0_List", ",", 
                    "Circuit`Private`T_"}], "]"}], "\[RuleDelayed]", 
                    RowBox[{"Circuit`Private`SinePeriod", "[", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`f", "[", "Circuit`Private`r0", 
                    "]"}], ",", 
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    RowBox[{"Circuit`Private`f", "[", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`T", ",", "0"}], "}"}], "]"}], 
                    "-", 
                    RowBox[{"Circuit`Private`f", "[", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "]"}]}], "]"}]}], 
                    "]"}]}]}], "}"}]}], "]"}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"Circuit`Private`ScaleFactor", "=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"Circuit`Private`modifiedConnectionList", "===", 
                    RowBox[{"{", "}"}]}], ",", "1", ",", 
                    RowBox[{"Max", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    RowBox[{"Plus", "@@", 
                    RowBox[{"Circuit`Private`Size", "/@", 
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}]}], "+", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "]"}], "-", 
                    RowBox[{"Count", "[", 
                    RowBox[{
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"Wire", "[", "___", "]"}]}], "]"}]}], ")"}]}]}], 
                    RowBox[{"Norm", "[", 
                    RowBox[{"Subtract", "@@", 
                    RowBox[{"Circuit`Private`xy", "/@", 
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}]}], "]"}]], "&"}], ")"}], "/@",
                     "Circuit`Private`modifiedConnectionList"}], "/.", 
                    "\[VeryThinSpace]", 
                    RowBox[{"Circuit`Private`tempSF", "\[Rule]", "1"}]}], 
                    ")"}]}]}], "]"}]}], ";", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`r", "=", 
                    RowBox[{"Circuit`Private`xy", "/@", 
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}]}], ",", 
                    RowBox[{"Circuit`Private`ElementList", "=", 
                    RowBox[{
                    RowBox[{"#1", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "/.", "\[VeryThinSpace]", 
                    RowBox[{
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`f_", "[", 
                    "Circuit`Private`exprs__", "]"}], "/;", 
                    RowBox[{"Circuit`Private`f", "=!=", "List"}]}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Circuit`Private`f", "[", 
                    
                    RowBox[{"Circuit`Private`exprs", ",", 
                    "Circuit`Private`opts"}], "]"}]}]}]}]}], "}"}], ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`ShiftRight", "=", 
                    RowBox[{"Function", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`ShiftBy", ",", 
                    "Circuit`Private`Elem"}], "}"}], ",", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`Draw", "[", 
                    "Circuit`Private`Elem", "]"}], "/.", "\[VeryThinSpace]", 
                    RowBox[{"Circuit`Private`LinePolygonMappingRules", "[", 
                    RowBox[{
                    RowBox[{"#1", "+", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`ShiftBy", ",", "0"}], "}"}]}], 
                    "&"}], "]"}]}]}], "]"}]}], ",", 
                    RowBox[{"Circuit`Private`\[Gamma]", "=", 
                    RowBox[{
                    RowBox[{"Norm", "[", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", 
                    RowBox[{
                    "Circuit`Private`r", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "]"}], " ", 
                    "Circuit`Private`ScaleFactor"}]}], ",", 
                    RowBox[{"Circuit`Private`NumberOfElements", "=", 
                    RowBox[{
                    
                    RowBox[{"Length", "[", "Circuit`Private`ElementList", 
                    "]"}], "-", 
                    RowBox[{"Count", "[", 
                    RowBox[{"Circuit`Private`ElementList", ",", 
                    RowBox[{"Wire", "[", "___", "]"}]}], "]"}]}]}]}], "}"}], 
                    ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Circuit`Private`AlignElements", "=", 
                    RowBox[{"Function", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`SpacerWidth", ",", 
                    "Circuit`Private`EL"}], "}"}], ",", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`SpacedElementList", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    
                    RowBox[{"#1", "\[LeftDoubleBracket]", "0", 
                    "\[RightDoubleBracket]"}], "===", "Wire"}], ",", 
                    RowBox[{"{", "#1", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Wire", "[", "Circuit`Private`SpacerWidth", "]"}],
                     ",", "#1"}], "}"}]}], "]"}], "&"}], ")"}], "/@", 
                    RowBox[{"Append", "[", 
                    RowBox[{"Circuit`Private`EL", ",", 
                    
                    RowBox[{"Wire", "[", "Circuit`Private`SpacerWidth", 
                    "]"}]}], "]"}]}], "/.", "\[VeryThinSpace]", 
                    RowBox[{
                    
                    RowBox[{"CurrentArrow", "[", "Circuit`Private`x___", 
                    "]"}], "\[RuleDelayed]", 
                    RowBox[{"With", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`s", "=", 
                    RowBox[{
                    FractionBox["1", "2"], " ", 
                    RowBox[{"Circuit`Private`Size", "[", 
                    RowBox[{"CurrentArrow", "[", "Circuit`Private`x", "]"}], 
                    "]"}]}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Wire", "[", "Circuit`Private`s", "]"}], ",", 
                    RowBox[{"CurrentArrow", "[", "Circuit`Private`x", "]"}], 
                    ",", 
                    RowBox[{"Wire", "[", "Circuit`Private`s", "]"}]}], 
                    "}"}]}], "]"}]}]}], "]"}], "//.", "\[VeryThinSpace]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x___", ",", 
                    RowBox[{"Wire", "[", 
                    
                    RowBox[{"Circuit`Private`a_", ",", 
                    "Circuit`Private`u___"}], "]"}], ",", 
                    RowBox[{"Wire", "[", 
                    
                    RowBox[{"Circuit`Private`b_", ",", 
                    "Circuit`Private`v___"}], "]"}], ",", 
                    "Circuit`Private`y___"}], "}"}], "\[RuleDelayed]", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x", ",", 
                    RowBox[{"Wire", "[", 
                    RowBox[{
                    RowBox[{"Circuit`Private`a", "+", "Circuit`Private`b"}], 
                    ",", "Circuit`Private`u", ",", "Circuit`Private`v"}], 
                    "]"}], ",", "Circuit`Private`y"}], "}"}]}]}], "/.", 
                    "\[VeryThinSpace]", 
                    RowBox[{
                    RowBox[{"Wire", "[", "Circuit`Private`x___", "]"}], 
                    "\[RuleDelayed]", 
                    RowBox[{"Wire", "[", 
                    
                    RowBox[{"Circuit`Private`x", ",", 
                    "Circuit`Private`opts"}], "]"}]}]}]}], "}"}], ",", 
                    RowBox[{"Circuit`Private`ShiftRight", "@@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Transpose", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FoldList", "[", 
                    RowBox[{"Plus", ",", "0", ",", 
                    RowBox[{"Circuit`Private`Size", "/@", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"Circuit`Private`SpacedElementList", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}]}], "]"}], ",", 
                    "Circuit`Private`SpacedElementList"}], "}"}], "]"}], 
                    "//.", "\[VeryThinSpace]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x___", ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`u1_", ",", 
                    
                    RowBox[{"Circuit`Private`f_", "[", 
                    "Circuit`Private`v1___", "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`u2_", ",", 
                    RowBox[{"Wire", "[", "Circuit`Private`v2___", "]"}]}], 
                    "}"}], ",", "Circuit`Private`y___"}], "}"}], "/;", 
                    RowBox[{"Circuit`Private`f", "=!=", "Wire"}]}], 
                    "\[RuleDelayed]", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`x", ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`u2", ",", 
                    RowBox[{"Wire", "[", "Circuit`Private`v2", "]"}]}], "}"}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`u1", ",", 
                    
                    RowBox[{"Circuit`Private`f", "[", "Circuit`Private`v1", 
                    "]"}]}], "}"}], ",", "Circuit`Private`y"}], "}"}]}]}], 
                    ")"}]}]}], "]"}]}], "]"}]}], ",", 
                    RowBox[{"Circuit`Private`\[Alpha]", "=", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", 
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], ")"}], 
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
                    "Circuit`Private`\[Gamma]"]}], ",", 
                    RowBox[{"Circuit`Private`\[Beta]", "=", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", 
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], ")"}], 
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                    "Circuit`Private`\[Gamma]"]}], ",", 
                    RowBox[{"Circuit`Private`SpacerWidth", "=", 
                    FractionBox[
                    RowBox[{"Circuit`Private`\[Gamma]", "-", 
                    RowBox[{"Plus", "@@", 
                    
                    RowBox[{"Circuit`Private`Size", "/@", 
                    "Circuit`Private`ElementList"}]}]}], 
                    
                    RowBox[{"1", "+", 
                    "Circuit`Private`NumberOfElements"}]]}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"Circuit`Private`AlignElements", "[", 
                    
                    RowBox[{"Circuit`Private`SpacerWidth", ",", 
                    "Circuit`Private`ElementList"}], "]"}], "/.", 
                    "\[VeryThinSpace]", 
                    RowBox[{"Circuit`Private`LinePolygonMappingRules", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Circuit`Private`\[Alpha]", ",", 
                    RowBox[{"-", "Circuit`Private`\[Beta]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    
                    RowBox[{"Circuit`Private`\[Beta]", ",", 
                    "Circuit`Private`\[Alpha]"}], "}"}]}], "}"}], ".", "#1"}],
                     "+", 
                    RowBox[{"Circuit`Private`r", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]}], "&"}], "]"}]}]}], "]"}]}], 
                    "]"}]}], "]"}], "&"}], ")"}], "/@", 
                    "Circuit`Private`modifiedConnectionList"}], "/.", 
                    "\[VeryThinSpace]", 
                    "Circuit`Private`SineReplacementRule"}], "/.", 
                    "\[VeryThinSpace]", 
                    
                    RowBox[{"Circuit`Private`tempSF", "\[Rule]", 
                    "Circuit`Private`ScaleFactor"}]}], ",", 
                    RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"Circuit`Private`nodeSingleElementList", ",", 
                    RowBox[{
                    RowBox[{"Circuit`Private`Draw", "/@", 
                    RowBox[{"Circuit`Private`ToList", "[", 
                    
                    RowBox[{"Circuit`Private`nodeSingleElementList", 
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                    "]"}]}], "/.", "\[VeryThinSpace]", 
                    RowBox[{"Circuit`Private`LinePolygonMappingRules", "[", 
                    RowBox[{
                    RowBox[{
                    FractionBox["#1", "Circuit`Private`ScaleFactor"], "+", 
                    RowBox[{"Circuit`Private`xy", "[", 
                    
                    RowBox[{"Circuit`Private`nodeSingleElementList", 
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
                    "]"}]}], "&"}], "]"}]}]}], "]"}], "/@", 
                    "Circuit`Private`extraElementList"}]}], "}"}]}]}], 
                    "]"}]}], "]"}], "]"}]}]}], "]"}]}], "]"}]}]}, {" "}}, 
                  GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                  DefaultBaseStyle -> "Column", 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]},
                "RowDefault"]}
             },
             DefaultBaseStyle->"Column",
             GridBoxAlignment->{"Columns" -> {{Left}}},
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
            "Column"],
           FrameMargins->{{6, 0}, {3, 6}}], "\<\"\"\>"},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   PaneSelectorBox[{True->
                    ButtonBox[
                    PaneSelectorBox[{False->
                    TemplateBox[{"\[ThickSpace]", "\"\[ThickSpace]\"", 
                    StyleBox[
                    "\"Options\"", "InformationRowLabel", StripOnInput -> 
                    False], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "DownPointerOpener"]]},
                    "RowWithSeparators"], True->
                    TemplateBox[{"\[ThickSpace]", "\"\[ThickSpace]\"", 
                    StyleBox[
                    "\"Options\"", "InformationRowLabel", StripOnInput -> 
                    False], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "DownPointerOpenerHot"]]},
                    "RowWithSeparators"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                    FrameMargins->0,
                    ImageSize->Automatic],
                    Appearance->None,
                    BaseStyle->None,
                    
                    ButtonFunction:>(Part[System`InformationDump`open$$, 3] = 
                    False),
                    Evaluator->Automatic,
                    FrameMargins->0,
                    ImageMargins->0,
                    Method->"Preemptive"], False->
                    ButtonBox[
                    PaneSelectorBox[{False->
                    TemplateBox[{"\[ThickSpace]", "\"\[ThickSpace]\"", 
                    StyleBox[
                    "\"Options\"", "InformationRowLabel", StripOnInput -> 
                    False], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "RightPointerOpener"]]},
                    "RowWithSeparators"], True->
                    TemplateBox[{"\[ThickSpace]", "\"\[ThickSpace]\"", 
                    StyleBox[
                    "\"Options\"", "InformationRowLabel", StripOnInput -> 
                    False], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "RightPointerOpenerHot"]]},
                    "RowWithSeparators"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                    FrameMargins->0,
                    ImageSize->Automatic],
                    Appearance->None,
                    BaseStyle->None,
                    
                    ButtonFunction:>(Part[System`InformationDump`open$$, 3] = 
                    True),
                    Evaluator->Automatic,
                    FrameMargins->0,
                    ImageMargins->0,
                    Method->"Preemptive"]}, Dynamic[
                    FEPrivate`Part[System`InformationDump`open$$, 3]]], 
                   PaneSelectorBox[{True->GridBox[{
                    {
                    RowBox[{"TextOffsetScale", "\[Rule]", "1"}]},
                    {
                    RowBox[{
                    "Circuit`Private`TextOffset", "\[Rule]", "Automatic"}]},
                    {
                    RowBox[{"DefaultTextOffset", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}]},
                    {
                    RowBox[{"ExtraTextArgumentsList", "\[Rule]", "None"}]},
                    {
                    RowBox[{"DefaultDiagonalTextOffset", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}]},
                    {
                    RowBox[{"BaseElementDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}]},
                    {
                    RowBox[{"ResistorFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"ResistorTurnNumber", "\[Rule]", "6"}]},
                    {
                    RowBox[{"ResistorDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"WrapperFunction", "\[Rule]", "Identity"}]},
                    {
                    RowBox[{"WireDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"NodeDirectives", "\[Rule]", 
                    RowBox[{"AbsolutePointSize", "[", "3", "]"}]}]},
                    {
                    RowBox[{"NodeReplacementRules", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"DCVoltageDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"DCVoltageNegativeTerminalDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"AbsoluteThickness", "[", "3", "]"}], "}"}]}]},
                    {
                    RowBox[{"DCVoltageNegativeTerminalScale", "\[Rule]", 
                    FractionBox["1", "3"]}]},
                    {
                    RowBox[{"DCVoltageFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"DCVoltageShowPolarity", "\[Rule]", "False"}]},
                    {
                    RowBox[{"DCVoltagePolarityOffset", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    FractionBox["1", "8"], ",", 
                    FractionBox["1", "8"]}], "}"}]}]},
                    {
                    RowBox[{"DCVoltagePolarityStyle", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"DCVoltageWidth", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"DCVoltageGap", "\[Rule]", 
                    FractionBox["1", "8"]}]},
                    {
                    RowBox[{"DCVoltageNumberCells", "\[Rule]", "1"}]},
                    {
                    RowBox[{"CapacitorGap", "\[Rule]", 
                    FractionBox["1", "8"]}]},
                    {
                    RowBox[{"CapacitorWidth", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"CapacitorDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"InductorFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"InductorTurnNumber", "\[Rule]", "3"}]},
                    {
                    RowBox[{"InductorDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"InductorTurnSegments", "\[Rule]", "12"}]},
                    {
                    RowBox[{"InductorTurnTightness", "\[Rule]", "0.5`"}]},
                    {
                    RowBox[{"CurrentArrowScale", "\[Rule]", "1"}]},
                    {
                    RowBox[{"CurrentArrowFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"CurrentArrowDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    TemplateBox[<|"color" -> GrayLevel[0.25]|>,
                    "GrayLevelColorSwatchTemplate"], "}"}]}]},
                    {
                    RowBox[{
                    "CurrentArrowType", "\[Rule]", "\<\"Simple Line\"\>"}]},
                    {
                    RowBox[{
                    "InlinePolygonalArrowLength", "\[Rule]", "0.25`"}]},
                    {
                    RowBox[{"OffsetArrowLength", "\[Rule]", "0.5`"}]},
                    {
                    RowBox[{"OffsetArrowOffset", "\[Rule]", "0.5`"}]},
                    {
                    RowBox[{"DiodeSize", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"DiodeFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"DiodeFilled", "\[Rule]", "False"}]},
                    {
                    RowBox[{"DiodeWidthRatio", "\[Rule]", 
                    FractionBox["2", 
                    SqrtBox["3"]]}]},
                    {
                    RowBox[{"DiodeBarDirectives", "\[Rule]", 
                    RowBox[{"AbsoluteThickness", "[", "2", "]"}]}]},
                    {
                    RowBox[{"DiodeDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"ACVoltageRadius", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"ACVoltageDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"ACVoltageImageRatio", "\[Rule]", "0.7`"}]},
                    {
                    RowBox[{"DCCurrentRadius", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"DCCurrentDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"DCCurrentFlipped", "\[Rule]", "False"}]},
                    {
                    RowBox[{"DCCurrentArrowBaseDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"AbsoluteThickness", "[", "3", "]"}], "}"}]}]},
                    {
                    RowBox[{"DCCurrentArrowDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"DCCurrentImageRatio", "\[Rule]", "0.6`"}]},
                    {
                    RowBox[{
                    "DCCurrentArrowTipLengthRatio", "\[Rule]", "0.4`"}]},
                    {
                    RowBox[{
                    "DCCurrentArrowTipWidthRatio", "\[Rule]", "0.3`"}]},
                    {
                    RowBox[{"InlineMeterRadius", "\[Rule]", 
                    FractionBox["1", "4"]}]},
                    {
                    RowBox[{"InlineMeterDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"GroundScale", "\[Rule]", "1"}]},
                    {
                    RowBox[{"GroundHeightRatio", "\[Rule]", "0.4`"}]},
                    {
                    RowBox[{"GroundLineNumber", "\[Rule]", "3"}]},
                    {
                    RowBox[{"GroundMinWidthRatio", "\[Rule]", "0.4`"}]},
                    {
                    RowBox[{"GroundHeightRatio", "\[Rule]", "0.4`"}]},
                    {
                    RowBox[{"GroundOffsetRatio", "\[Rule]", 
                    FractionBox["1", "2"]}]},
                    {
                    RowBox[{"GroundDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}]},
                    {
                    RowBox[{"GroundOffsetDirectives", "\[Rule]", 
                    RowBox[{"{", "}"}]}]},
                    {
                    RowBox[{"GroundOrientation", "\[Rule]", "\<\"Down\"\>"}]},
                    {
                    RowBox[{"CircuitSwitchSize", "\[Rule]", 
                    FractionBox["1", "2"]}]},
                    {
                    RowBox[{
                    "CircuitSwitchPosition", "\[Rule]", "\<\"Open\"\>"}]},
                    {
                    RowBox[{"CircuitSwitchOpenAngle", "\[Rule]", 
                    RowBox[{"25", " ", "\[Degree]"}]}]},
                    {
                    RowBox[{
                    "CircuitSwitchOpenSense", 
                    "\[Rule]", "\<\"Counterclockwise\"\>"}]},
                    {
                    RowBox[{"CircuitSwitchDirectives", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"AbsolutePointSize", "[", "5", "]"}], "}"}]}]},
                    {
                    StyleBox[
                    
                    TemplateBox[{
                    "\"(\"", "\"\[InvisibleSpace]\"", "71", "\" total)\""},
                    "RowDefault"], "InformationRowOpener",
                    StripOnInput->False]}
                    },
                    BaselinePosition->{Baseline, {1, 1}},
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{1.}}}], False->
                    RowBox[{
                    RowBox[{"TextOffsetScale", "\[Rule]", "1"}], 
                    "\[ThinSpace]", 
                    StyleBox["\<\"\[Ellipsis]\"\>", "InformationRowOpener",
                    StripOnInput->False], "\[ThinSpace]", 
                    StyleBox[
                    
                    TemplateBox[{
                    "\"(\"", "\"\[InvisibleSpace]\"", "71", "\" total)\""},
                    "RowDefault"], "InformationRowOpener",
                    StripOnInput->False]}]}, Dynamic[
                    FEPrivate`Part[System`InformationDump`open$$, 3]],
                    BaselinePosition->Baseline,
                    ImageSize->Automatic]},
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Circuit`DrawCircuit\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->{{6, 6}, {6, 3}}], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"DrawCircuit[\\!\\(\\*\\nStyleBox[\\\"nodes\\\",\\\
nFontSlant->\\\"Italic\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"]\\) or {\\!\\(\
\\*SubscriptBox[\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\), \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"conn\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(2\\)]\\), ...}, \
\\!\\(\\*\\nStyleBox[\\\"extraElementList\\\",\\nFontSlant->\\\"Italic\\\"]\\)\
:{}, \\!\\(\\*\\nStyleBox[\\\"opts\\\",\\nFontSlant->\\\"Italic\\\"]\\)] is \
the main circuit-drawing function.\\n   \
\\!\\(\\*\\nStyleBox[\\\"nodes\\\",\\nFontSlant->\\\"Italic\\\"]\\) are \
specified as an association \
\[LeftAssociation]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\
\\\"Italic\\\"], \\(1\\)]\\)\[Rule]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\
\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\)\[Rule]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\
\\\"Italic\\\"], \\(2\\)]\\),...\[RightAssociation], or as a list \
{{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"Italic\\\"],\
 \\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(1\\)]\\)},{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\)},... } or most simply \
{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"pt\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\),...}, where the labels are sequential integers.\\n   \
The second entry contains a list of connections where each connection has the \
form: {{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"node\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"node\\\",\\nFontSlant->\\\"\
Italic\\\"], \\(2\\)]\\)},{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"element\\\",\
\\nFontSlant->\\\"Italic\\\"], \\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\
\\\"element\\\",\\nFontSlant->\\\"Italic\\\"], \\(2\\)]\\),...}}.\\n   \\!\\(\
\\*\\nStyleBox[\\\"extraElementList\\\",\\nFontSlant->\\\"Italic\\\"]\\) is \
optional containing nodes to display and label. Each node has the form \
{\\!\\(\\*\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"Italic\\\"]\\),Node[\\!\\(\
\\*\\nStyleBox[\\\"string\\\",\\nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\\
nStyleBox[\\\"opts\\\",\\nFontSlant->\\\"Italic\\\"]\\)]}.\\n   Options of \
all circuit elements are in Options[DrawCircuit]; this allows them to be \
specified for all elements in a graphic or for a specific element. Circuit \
elements have a size that is rescaled to fit the node positions. The scale of \
the elements is relative to a standard (8 turn) resistor having length 1 with \
a spacer of length 1/4 placed on each side of all elements.\"\>", 
             "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{13., {2., 11.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{13., {2., 11.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[<|
   "ObjectType" -> "Symbol", "Usage" -> 
    "DrawCircuit[\!\(\*\nStyleBox[\"nodes\",\nFontSlant->\"Italic\"]\), \
\!\(\*\nStyleBox[\"conn\",\nFontSlant->\"Italic\"]\) or {\!\(\*SubscriptBox[\n\
StyleBox[\"conn\",\nFontSlant->\"Italic\"], \(1\)]\), \!\(\*SubscriptBox[\n\
StyleBox[\"conn\",\nFontSlant->\"Italic\"], \(2\)]\), ...}, \!\(\*\nStyleBox[\
\"extraElementList\",\nFontSlant->\"Italic\"]\):{}, \!\(\*\n\
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)] is the main circuit-drawing \
function.\n   \!\(\*\nStyleBox[\"nodes\",\nFontSlant->\"Italic\"]\) are \
specified as an association \[LeftAssociation]\!\(\*SubscriptBox[\n\
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(1\)]\)\[Rule]\!\(\*SubscriptBox[\
\nStyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\n\
StyleBox[\"lbl\",\nFontSlant->\"Italic\"], \(2\)]\)\[Rule]\!\(\*SubscriptBox[\
\nStyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...\[RightAssociation], \
or as a list {{\!\(\*SubscriptBox[\nStyleBox[\"lbl\",\n\
FontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\nStyleBox[\"pt\",\n\
FontSlant->\"Italic\"], \(1\)]\)},{\!\(\*SubscriptBox[\nStyleBox[\"lbl\",\n\
FontSlant->\"Italic\"], \(2\)]\),\!\(\*SubscriptBox[\nStyleBox[\"pt\",\n\
FontSlant->\"Italic\"], \(2\)]\)},... } or most simply {\!\(\*SubscriptBox[\n\
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\n\
StyleBox[\"pt\",\nFontSlant->\"Italic\"], \(2\)]\),...}, where the labels are \
sequential integers.\n   The second entry contains a list of connections \
where each connection has the form: {{\!\(\*SubscriptBox[\nStyleBox[\"node\",\
\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\nStyleBox[\"node\",\n\
FontSlant->\"Italic\"], \(2\)]\)},{\!\(\*SubscriptBox[\nStyleBox[\"element\",\
\nFontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\nStyleBox[\"element\",\
\nFontSlant->\"Italic\"], \(2\)]\),...}}.\n   \!\(\*\n\
StyleBox[\"extraElementList\",\nFontSlant->\"Italic\"]\) is optional \
containing nodes to display and label. Each node has the form {\!\(\*\n\
StyleBox[\"lbl\",\nFontSlant->\"Italic\"]\),Node[\!\(\*\nStyleBox[\"string\",\
\nFontSlant->\"Italic\"]\),\!\(\*\nStyleBox[\"opts\",\nFontSlant->\"Italic\"]\
\)]}.\n   Options of all circuit elements are in Options[DrawCircuit]; this \
allows them to be specified for all elements in a graphic or for a specific \
element. Circuit elements have a size that is rescaled to fit the node \
positions. The scale of the elements is relative to a standard (8 turn) \
resistor having length 1 with a spacer of length 1/4 placed on each side of \
all elements.", "Documentation" -> None, "OwnValues" -> None, "UpValues" -> 
    None, "DownValues" -> 
    Information`InformationValueForm[
     DownValues, Circuit`DrawCircuit, {Circuit`DrawCircuit[
         Pattern[Circuit`Private`nodePositionList, 
          Blank[List]], 
         Pattern[Circuit`Private`connectionList, 
          Blank[List]], 
         Optional[
          Pattern[Circuit`Private`extraElementList, 
           Blank[List]], {}], 
         Pattern[Circuit`Private`opts, 
          OptionsPattern[]]] :> If[
         Or[
          Apply[And, 
           Map[
            Function[Circuit`Private`pair, 
             MatchQ[Circuit`Private`pair, {
               PatternTest[
                Blank[], NumericQ], 
               PatternTest[
                Blank[], NumericQ]}]], Circuit`Private`nodePositionList]], 
          Apply[And, 
           Map[
            Function[Circuit`Private`labelAndPair, 
             MatchQ[Circuit`Private`labelAndPair, {
               Blank[], {
                PatternTest[
                 Blank[], NumericQ], 
                PatternTest[
                 Blank[], NumericQ]}}]], Circuit`Private`nodePositionList]]], 
         Circuit`DrawCircuit[
          Apply[Association, 
           MapApply[Rule, 
            If[
             MatrixQ[Circuit`Private`nodePositionList], 
             MapIndexed[{
               Part[#2, 1], #}& , Circuit`Private`nodePositionList], 
             Circuit`Private`nodePositionList]]], 
          Circuit`Private`connectionList, Circuit`Private`extraElementList, 
          Circuit`Private`opts], Message[
           MessageName[Circuit`DrawCircuit, "nodes"], 
           Circuit`Private`nodePositionList]; Null], Circuit`DrawCircuit[
         Pattern[Circuit`Private`xyTemp, 
          Blank[Association]], 
         Pattern[Circuit`Private`connectionList, 
          Blank[List]], 
         Optional[
          Pattern[Circuit`Private`extraElementList, 
           Blank[List]], {}], 
         Pattern[Circuit`Private`opts, 
          OptionsPattern[]]] :> 
       Module[{Circuit`Private`ScaleFactor, Circuit`Private`tempSF, 
          Circuit`Private`xy = Circuit`Private`xyTemp, 
          Circuit`Private`offsetNodeLabel}, 
         If[
          Not[
           And[
            Apply[And, 
             Map[
              Function[Circuit`Private`assocRule, 
               MatchQ[Circuit`Private`assocRule, Blank[] -> {
                  PatternTest[
                   Blank[], NumericQ], 
                  PatternTest[
                   Blank[], NumericQ]}]], 
              Normal[Circuit`Private`xy]]], Head[Circuit`Private`xy] === 
            Association]], Message[
            MessageName[Circuit`DrawCircuit, "nodes"], Circuit`Private`xy]; 
          Null, Do[
            
            With[{Circuit`Private`nodeList = Keys[Circuit`Private`xy], 
              Circuit`Private`nodePair = Switch[Circuit`Private`conn, {{
                  Blank[], 
                  Blank[]}, 
                 Blank[]}, 
                First[Circuit`Private`conn], {
                 Circuit`OffsetPoints[{
                   Blank[], 
                   Blank[]}, 
                  BlankSequence[]], 
                 Blank[]}, 
                Part[Circuit`Private`conn, 1, 1], 
                Blank[], Message[
                  MessageName[Circuit`DrawCircuit, "connection"], 
                  Circuit`Private`conn]; {}]}, 
             If[
              Not[
               SubsetQ[Circuit`Private`nodeList, Circuit`Private`nodePair]], 
              Message[
               MessageName[Circuit`DrawCircuit, "nodematch"], 
               Circuit`Private`nodePair]]], {
            Circuit`Private`conn, Circuit`Private`connectionList}]; 
          Circuit`GraphicsLayering[
            With[{Circuit`Private`modifiedConnectionList = Map[{
                 Part[#, 1], 
                 Circuit`Private`ToList[
                  Part[#, 2]]}& , 
                With[{Circuit`Private`OffsetPointsRule = {
                    Pattern[Circuit`Private`before, 
                    BlankNullSequence[]], {
                    Circuit`OffsetPoints[{
                    Pattern[Circuit`Private`a, 
                    Blank[]], 
                    Pattern[Circuit`Private`b, 
                    Blank[]]}, 
                    Pattern[Circuit`Private`\[Lambda], 
                    Blank[]], 
                    Pattern[Circuit`Private`OS, 
                    Blank[]], 
                    OptionsPattern[Circuit`DrawCircuit]], 
                    Pattern[Circuit`Private`blah, 
                    Blank[]]}, 
                    Pattern[Circuit`Private`after, 
                    BlankNullSequence[]]} :> 
                   With[{Circuit`Private`wireDirs = 
                    With[{Circuit`Private`ov = 
                    OptionValue[
                    Circuit`OffsetPoints, Circuit`WireDirectives]}, 
                    If[
                    MatrixQ[Circuit`Private`ov], Circuit`Private`ov, {
                    Circuit`Private`ov, Circuit`Private`ov}]], 
                    Circuit`Private`uPerp = 
                    With[{Circuit`Private`u = 
                    Normalize[
                    Circuit`Private`xy[Circuit`Private`b] - 
                    Circuit`Private`xy[Circuit`Private`a]]}, {-
                    Part[Circuit`Private`u, 2], 
                    Part[Circuit`Private`u, 1]}/Circuit`Private`tempSF]}, 
                    
                    With[{Circuit`Private`r1 = 
                    Circuit`Private`xy[Circuit`Private`a] + 
                    Circuit`Private`\[Lambda] (
                    Circuit`Private`xy[Circuit`Private`b] - 
                    Circuit`Private`xy[Circuit`Private`a]) + 
                    Circuit`Private`uPerp Circuit`Private`OS, 
                    Circuit`Private`r2 = 
                    Circuit`Private`xy[Circuit`Private`b] + 
                    Circuit`Private`\[Lambda] (
                    Circuit`Private`xy[Circuit`Private`a] - 
                    Circuit`Private`xy[Circuit`Private`b]) + 
                    Circuit`Private`uPerp Circuit`Private`OS, 
                    Circuit`Private`label1 = 
                    Circuit`Private`offsetNodeLabel[
                    Length[Circuit`Private`xy] + 1], Circuit`Private`label2 = 
                    Circuit`Private`offsetNodeLabel[
                    Length[Circuit`Private`xy] + 2]}, 
                    AssociateTo[
                    Circuit`Private`xy, {
                    Circuit`Private`label1 -> Circuit`Private`r1, 
                    Circuit`Private`label2 -> Circuit`Private`r2}]; {
                    Circuit`Private`before, {{
                    Circuit`Private`a, Circuit`Private`label1}, {
                    Circuit`Wire[
                    0, Circuit`WireDirectives -> 
                    Part[Circuit`Private`wireDirs, 1]]}}, {{
                    Circuit`Private`label1, Circuit`Private`label2}, 
                    Join[{
                    Circuit`Wire[
                    0, Circuit`WireDirectives -> 
                    Part[Circuit`Private`wireDirs, 1]]}, 
                    Circuit`Private`ToList[Circuit`Private`blah], {
                    Circuit`Wire[
                    0, Circuit`WireDirectives -> 
                    Part[Circuit`Private`wireDirs, 2]]}]}, {{
                    Circuit`Private`label2, Circuit`Private`b}, {
                    Circuit`Wire[
                    0, Circuit`WireDirectives -> 
                    Part[Circuit`Private`wireDirs, 2]]}}, 
                    Circuit`Private`after}]]}, 
                 ReplaceRepeated[
                 Circuit`Private`connectionList, 
                  Circuit`Private`OffsetPointsRule]]]}, 
             
             With[{Circuit`Private`LinePolygonMappingRules = 
               Function[Circuit`Private`f, {Line[
                    Pattern[Circuit`Private`y, 
                    Blank[List]]] :> Line[
                    Map[Circuit`Private`f, Circuit`Private`y]], Point[
                    Pattern[Circuit`Private`r, 
                    Blank[List]]] :> Point[
                    Circuit`Private`f[Circuit`Private`r]], Circle[
                    Pattern[Circuit`Private`x, 
                    Blank[List]], 
                    Pattern[Circuit`Private`R, 
                    Blank[]], 
                    Pattern[Circuit`Private`z, 
                    BlankNullSequence[]]] :> Circle[
                    Circuit`Private`f[Circuit`Private`x], 
                    Norm[
                    Circuit`Private`f[{Circuit`Private`R, 0}] - 
                    Circuit`Private`f[{0, 0}]], Circuit`Private`z], Arrow[
                    Pattern[Circuit`Private`y, 
                    Blank[List]]] :> Arrow[
                    Map[Circuit`Private`f, Circuit`Private`y]], Polygon[
                    Pattern[Circuit`Private`y, 
                    Blank[List]]] :> Polygon[
                    Map[Circuit`Private`f, Circuit`Private`y]], Text[
                    Pattern[Circuit`Private`str, 
                    Blank[]], 
                    Pattern[Circuit`Private`x, 
                    Blank[]], 
                    Pattern[Circuit`Private`ext, 
                    BlankNullSequence[]]] :> Text[Circuit`Private`str, 
                    Circuit`Private`f[Circuit`Private`x], 
                    Circuit`Private`ext], Rectangle[{
                    Pattern[Circuit`Private`x1, 
                    Blank[]], 
                    Pattern[Circuit`Private`y1, 
                    Blank[]]}, {
                    Pattern[Circuit`Private`x2, 
                    Blank[]], 
                    Pattern[Circuit`Private`y2, 
                    Blank[]]}] :> Polygon[
                    Map[
                    Circuit`Private`f, {{
                    Circuit`Private`x1, Circuit`Private`y1}, {
                    Circuit`Private`x2, Circuit`Private`y1}, {
                    Circuit`Private`x2, Circuit`Private`y2}, {
                    Circuit`Private`x1, Circuit`Private`y2}}]], 
                  GraphicsComplex[
                    Pattern[Circuit`Private`y, 
                    Blank[List]], 
                    Pattern[Circuit`Private`unchanged, 
                    BlankNullSequence[]]] :> GraphicsComplex[
                    Map[Circuit`Private`f, Circuit`Private`y], 
                    Circuit`Private`unchanged], Circuit`Private`SinePeriod[
                    Pattern[Circuit`Private`r0, 
                    Blank[List]], 
                    Pattern[Circuit`Private`T, 
                    Blank[]]] :> Circuit`Private`SinePeriod[
                    Circuit`Private`f[Circuit`Private`r0], 
                    Norm[
                    Circuit`Private`f[{Circuit`Private`T, 0}] - 
                    Circuit`Private`f[{0, 0}]]]}]}, 
              Circuit`Private`ScaleFactor = 
               If[Circuit`Private`modifiedConnectionList === {}, 1, 
                 Apply[Max, 
                  ReplaceAll[
                   Map[(Apply[Plus, 
                    Map[Circuit`Private`Size, 
                    Part[#, 2]]] + (Length[
                    Part[#, 2]] - Count[
                    Part[#, 2], 
                    Circuit`Wire[
                    BlankNullSequence[]]])/2)/Norm[
                    Apply[Subtract, 
                    Map[Circuit`Private`xy, 
                    Part[#, 1]]]]& , Circuit`Private`modifiedConnectionList], 
                   Circuit`Private`tempSF -> 1]]]; {
                ReplaceAll[
                 ReplaceAll[
                  Map[With[{Circuit`Private`r = Map[Circuit`Private`xy, 
                    Part[#, 1]], Circuit`Private`ElementList = ReplaceAll[
                    Part[#, 2], Condition[
                    Pattern[Circuit`Private`f, 
                    Blank[]][
                    Pattern[Circuit`Private`exprs, 
                    BlankSequence[]]], Circuit`Private`f =!= List] :> 
                    Circuit`Private`f[
                    Circuit`Private`exprs, Circuit`Private`opts]]}, 
                    
                    With[{Circuit`Private`ShiftRight = 
                    Function[{Circuit`Private`ShiftBy, Circuit`Private`Elem}, 
                    ReplaceAll[
                    Circuit`Private`Draw[Circuit`Private`Elem], 
                    
                    Circuit`Private`LinePolygonMappingRules[# + {
                    Circuit`Private`ShiftBy, 0}& ]]], 
                    Circuit`Private`\[Gamma] = 
                    Norm[Part[Circuit`Private`r, 2] - Part[
                    Circuit`Private`r, 1]] Circuit`Private`ScaleFactor, 
                    Circuit`Private`NumberOfElements = 
                    Length[Circuit`Private`ElementList] - Count[
                    Circuit`Private`ElementList, 
                    Circuit`Wire[
                    BlankNullSequence[]]]}, 
                    
                    With[{Circuit`Private`AlignElements = 
                    Function[{
                    Circuit`Private`SpacerWidth, Circuit`Private`EL}, 
                    With[{Circuit`Private`SpacedElementList = ReplaceAll[
                    ReplaceRepeated[
                    Flatten[
                    ReplaceAll[
                    Map[If[Part[#, 0] === Circuit`Wire, {#}, {
                    Circuit`Wire[Circuit`Private`SpacerWidth], #}]& , 
                    Append[Circuit`Private`EL, 
                    Circuit`Wire[Circuit`Private`SpacerWidth]]], 
                    Circuit`CurrentArrow[
                    Pattern[Circuit`Private`x, 
                    BlankNullSequence[]]] :> 
                    With[{Circuit`Private`s = Circuit`Private`Size[
                    Circuit`CurrentArrow[Circuit`Private`x]]/2}, {
                    Circuit`Wire[Circuit`Private`s], 
                    Circuit`CurrentArrow[Circuit`Private`x], 
                    Circuit`Wire[Circuit`Private`s]}]]], {
                    Pattern[Circuit`Private`x, 
                    BlankNullSequence[]], 
                    Circuit`Wire[
                    Pattern[Circuit`Private`a, 
                    Blank[]], 
                    Pattern[Circuit`Private`u, 
                    BlankNullSequence[]]], 
                    Circuit`Wire[
                    Pattern[Circuit`Private`b, 
                    Blank[]], 
                    Pattern[Circuit`Private`v, 
                    BlankNullSequence[]]], 
                    Pattern[Circuit`Private`y, 
                    BlankNullSequence[]]} :> {Circuit`Private`x, 
                    Circuit`Wire[
                    Circuit`Private`a + Circuit`Private`b, Circuit`Private`u, 
                    Circuit`Private`v], Circuit`Private`y}], Circuit`Wire[
                    Pattern[Circuit`Private`x, 
                    BlankNullSequence[]]] :> 
                    Circuit`Wire[Circuit`Private`x, Circuit`Private`opts]]}, 
                    MapApply[Circuit`Private`ShiftRight, 
                    ReplaceRepeated[
                    Transpose[{
                    FoldList[Plus, 0, 
                    Map[Circuit`Private`Size, 
                    Delete[Circuit`Private`SpacedElementList, -1]]], 
                    Circuit`Private`SpacedElementList}], Condition[{
                    Pattern[Circuit`Private`x, 
                    BlankNullSequence[]], {
                    Pattern[Circuit`Private`u1, 
                    Blank[]], 
                    Pattern[Circuit`Private`f, 
                    Blank[]][
                    Pattern[Circuit`Private`v1, 
                    BlankNullSequence[]]]}, {
                    Pattern[Circuit`Private`u2, 
                    Blank[]], 
                    Circuit`Wire[
                    Pattern[Circuit`Private`v2, 
                    BlankNullSequence[]]]}, 
                    Pattern[Circuit`Private`y, 
                    BlankNullSequence[]]}, Circuit`Private`f =!= 
                    Circuit`Wire] :> {Circuit`Private`x, {Circuit`Private`u2, 
                    Circuit`Wire[Circuit`Private`v2]}, {Circuit`Private`u1, 
                    Circuit`Private`f[Circuit`Private`v1]}, 
                    Circuit`Private`y}]]]], Circuit`Private`\[Alpha] = 
                    Part[Part[Circuit`Private`r, 2] - Part[
                    Circuit`Private`r, 1], 1]/Circuit`Private`\[Gamma], 
                    Circuit`Private`\[Beta] = 
                    Part[Part[Circuit`Private`r, 2] - Part[
                    Circuit`Private`r, 1], 2]/Circuit`Private`\[Gamma], 
                    Circuit`Private`SpacerWidth = (Circuit`Private`\[Gamma] - 
                    Apply[Plus, 
                    Map[Circuit`Private`Size, Circuit`Private`ElementList]])/(
                    1 + Circuit`Private`NumberOfElements)}, 
                    ReplaceAll[
                    Circuit`Private`AlignElements[
                    Circuit`Private`SpacerWidth, Circuit`Private`ElementList], 
                    Circuit`Private`LinePolygonMappingRules[
                    Dot[{{Circuit`Private`\[Alpha], -
                    Circuit`Private`\[Beta]}, {
                    Circuit`Private`\[Beta], Circuit`Private`\[Alpha]}}, #] + 
                    Part[Circuit`Private`r, 1]& ]]]]]& , 
                   Circuit`Private`modifiedConnectionList], 
                  Circuit`Private`SineReplacementRule], 
                 Circuit`Private`tempSF -> Circuit`Private`ScaleFactor], 
                Map[
                 Function[Circuit`Private`nodeSingleElementList, 
                  ReplaceAll[
                   Map[Circuit`Private`Draw, 
                    Circuit`Private`ToList[
                    Part[Circuit`Private`nodeSingleElementList, 2]]], 
                   
                   Circuit`Private`LinePolygonMappingRules[#/
                    Circuit`Private`ScaleFactor + Circuit`Private`xy[
                    Part[Circuit`Private`nodeSingleElementList, 1]]& ]]], 
                 Circuit`Private`extraElementList]}]]]]]}], "SubValues" -> 
    None, "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> {
     Circuit`TextOffsetScale -> 1, Circuit`Private`TextOffset -> Automatic, 
      Circuit`DefaultTextOffset -> {0, 1}, Circuit`ExtraTextArgumentsList -> 
      None, Circuit`DefaultDiagonalTextOffset -> {-1, 1}, 
      Circuit`BaseElementDirectives -> {
        AbsoluteThickness[2]}, Circuit`ResistorFlipped -> False, 
      Circuit`ResistorTurnNumber -> 6, Circuit`ResistorDirectives -> {}, 
      Circuit`WrapperFunction -> Identity, Circuit`WireDirectives -> {}, 
      Circuit`NodeDirectives -> AbsolutePointSize[3], 
      Circuit`NodeReplacementRules -> {}, Circuit`DCVoltageDirectives -> {}, 
      Circuit`DCVoltageNegativeTerminalDirectives -> {
        AbsoluteThickness[3]}, Circuit`DCVoltageNegativeTerminalScale -> 
      Rational[1, 3], Circuit`DCVoltageFlipped -> False, 
      Circuit`DCVoltageShowPolarity -> False, Circuit`DCVoltagePolarityOffset -> {
        Rational[1, 8], 
        Rational[1, 8]}, Circuit`DCVoltagePolarityStyle -> {}, 
      Circuit`DCVoltageWidth -> Rational[1, 4], Circuit`DCVoltageGap -> 
      Rational[1, 8], Circuit`DCVoltageNumberCells -> 1, Circuit`CapacitorGap -> 
      Rational[1, 8], Circuit`CapacitorWidth -> Rational[1, 4], 
      Circuit`CapacitorDirectives -> {}, Circuit`InductorFlipped -> False, 
      Circuit`InductorTurnNumber -> 3, Circuit`InductorDirectives -> {}, 
      Circuit`InductorTurnSegments -> 12, Circuit`InductorTurnTightness -> 
      0.5, Circuit`CurrentArrowScale -> 1, Circuit`CurrentArrowFlipped -> 
      False, Circuit`CurrentArrowDirectives -> {
        GrayLevel[0.25]}, Circuit`CurrentArrowType -> "Simple Line", 
      Circuit`InlinePolygonalArrowLength -> 0.25, Circuit`OffsetArrowLength -> 
      0.5, Circuit`OffsetArrowOffset -> 0.5, Circuit`DiodeSize -> 
      Rational[1, 4], Circuit`DiodeFlipped -> False, Circuit`DiodeFilled -> 
      False, Circuit`DiodeWidthRatio -> 2 3^Rational[-1, 2], 
      Circuit`DiodeBarDirectives -> AbsoluteThickness[2], 
      Circuit`DiodeDirectives -> {}, Circuit`ACVoltageRadius -> 
      Rational[1, 4], Circuit`ACVoltageDirectives -> {}, 
      Circuit`ACVoltageImageRatio -> 0.7, Circuit`DCCurrentRadius -> 
      Rational[1, 4], Circuit`DCCurrentDirectives -> {}, 
      Circuit`DCCurrentFlipped -> False, Circuit`DCCurrentArrowBaseDirectives -> 
      {
        AbsoluteThickness[3]}, Circuit`DCCurrentArrowDirectives -> {}, 
      Circuit`DCCurrentImageRatio -> 0.6, 
      Circuit`DCCurrentArrowTipLengthRatio -> 0.4, 
      Circuit`DCCurrentArrowTipWidthRatio -> 0.3, Circuit`InlineMeterRadius -> 
      Rational[1, 4], Circuit`InlineMeterDirectives -> {}, 
      Circuit`GroundScale -> 1, Circuit`GroundHeightRatio -> 0.4, 
      Circuit`GroundLineNumber -> 3, Circuit`GroundMinWidthRatio -> 0.4, 
      Circuit`GroundHeightRatio -> 0.4, Circuit`GroundOffsetRatio -> 
      Rational[1, 2], Circuit`GroundDirectives -> {
        AbsoluteThickness[2]}, Circuit`GroundOffsetDirectives -> {}, 
      Circuit`GroundOrientation -> "Down", Circuit`CircuitSwitchSize -> 
      Rational[1, 2], Circuit`CircuitSwitchPosition -> "Open", 
      Circuit`CircuitSwitchOpenAngle -> 25 Degree, 
      Circuit`CircuitSwitchOpenSense -> "Counterclockwise", 
      Circuit`CircuitSwitchDirectives -> {
        AbsolutePointSize[5]}}, "Attributes" -> {}, "FullName" -> 
    "Circuit`DrawCircuit"|>, False]]], "Output",
 CellChangeTimes->{
  3.813272627419735*^9, {3.880664982036354*^9, 3.8806649898950987`*^9}},
 CellLabel->"Out[3]=",ExpressionUUID->"2f848f44-6ce6-41a6-bb31-b88327a7f9d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "DrawCircuit", "]"}]], "Input",
 CellChangeTimes->{{3.6238035307088423`*^9, 3.623803541333736*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"d576547a-6d9c-4d8b-a6eb-077a7955079d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TextOffsetScale", "\[Rule]", "1"}], ",", 
   RowBox[{"Circuit`Private`TextOffset", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"DefaultTextOffset", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], ",", 
   RowBox[{"ExtraTextArgumentsList", "\[Rule]", "None"}], ",", 
   RowBox[{"DefaultDiagonalTextOffset", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"BaseElementDirectives", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], ",", 
   RowBox[{"ResistorFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"ResistorTurnNumber", "\[Rule]", "6"}], ",", 
   RowBox[{"ResistorDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"WrapperFunction", "\[Rule]", "Identity"}], ",", 
   RowBox[{"WireDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"NodeDirectives", "\[Rule]", 
    RowBox[{"AbsolutePointSize", "[", "3", "]"}]}], ",", 
   RowBox[{"NodeReplacementRules", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DCVoltageDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DCVoltageNegativeTerminalDirectives", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"AbsoluteThickness", "[", "3", "]"}], "}"}]}], ",", 
   RowBox[{"DCVoltageNegativeTerminalScale", "\[Rule]", 
    FractionBox["1", "3"]}], ",", 
   RowBox[{"DCVoltageFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"DCVoltageShowPolarity", "\[Rule]", "False"}], ",", 
   RowBox[{"DCVoltagePolarityOffset", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["1", "8"], ",", 
      FractionBox["1", "8"]}], "}"}]}], ",", 
   RowBox[{"DCVoltagePolarityStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DCVoltageWidth", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"DCVoltageGap", "\[Rule]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{"DCVoltageNumberCells", "\[Rule]", "1"}], ",", 
   RowBox[{"CapacitorGap", "\[Rule]", 
    FractionBox["1", "8"]}], ",", 
   RowBox[{"CapacitorWidth", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"CapacitorDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"InductorFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"InductorTurnNumber", "\[Rule]", "3"}], ",", 
   RowBox[{"InductorDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"InductorTurnSegments", "\[Rule]", "12"}], ",", 
   RowBox[{"InductorTurnTightness", "\[Rule]", "0.5`"}], ",", 
   RowBox[{"CurrentArrowScale", "\[Rule]", "1"}], ",", 
   RowBox[{"CurrentArrowFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"CurrentArrowDirectives", "\[Rule]", 
    RowBox[{"{", 
     TemplateBox[<|"color" -> GrayLevel[0.25]|>,
      "GrayLevelColorSwatchTemplate"], "}"}]}], ",", 
   RowBox[{"CurrentArrowType", "\[Rule]", "\<\"Simple Line\"\>"}], ",", 
   RowBox[{"InlinePolygonalArrowLength", "\[Rule]", "0.25`"}], ",", 
   RowBox[{"OffsetArrowLength", "\[Rule]", "0.5`"}], ",", 
   RowBox[{"OffsetArrowOffset", "\[Rule]", "0.5`"}], ",", 
   RowBox[{"DiodeSize", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"DiodeFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"DiodeFilled", "\[Rule]", "False"}], ",", 
   RowBox[{"DiodeWidthRatio", "\[Rule]", 
    FractionBox["2", 
     SqrtBox["3"]]}], ",", 
   RowBox[{"DiodeBarDirectives", "\[Rule]", 
    RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
   RowBox[{"DiodeDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"ACVoltageRadius", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"ACVoltageDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"ACVoltageImageRatio", "\[Rule]", "0.7`"}], ",", 
   RowBox[{"DCCurrentRadius", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"DCCurrentDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DCCurrentFlipped", "\[Rule]", "False"}], ",", 
   RowBox[{"DCCurrentArrowBaseDirectives", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"AbsoluteThickness", "[", "3", "]"}], "}"}]}], ",", 
   RowBox[{"DCCurrentArrowDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DCCurrentImageRatio", "\[Rule]", "0.6`"}], ",", 
   RowBox[{"DCCurrentArrowTipLengthRatio", "\[Rule]", "0.4`"}], ",", 
   RowBox[{"DCCurrentArrowTipWidthRatio", "\[Rule]", "0.3`"}], ",", 
   RowBox[{"InlineMeterRadius", "\[Rule]", 
    FractionBox["1", "4"]}], ",", 
   RowBox[{"InlineMeterDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GroundScale", "\[Rule]", "1"}], ",", 
   RowBox[{"GroundHeightRatio", "\[Rule]", "0.4`"}], ",", 
   RowBox[{"GroundLineNumber", "\[Rule]", "3"}], ",", 
   RowBox[{"GroundMinWidthRatio", "\[Rule]", "0.4`"}], ",", 
   RowBox[{"GroundHeightRatio", "\[Rule]", "0.4`"}], ",", 
   RowBox[{"GroundOffsetRatio", "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{"GroundDirectives", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], ",", 
   RowBox[{"GroundOffsetDirectives", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GroundOrientation", "\[Rule]", "\<\"Down\"\>"}], ",", 
   RowBox[{"CircuitSwitchSize", "\[Rule]", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{"CircuitSwitchPosition", "\[Rule]", "\<\"Open\"\>"}], ",", 
   RowBox[{"CircuitSwitchOpenAngle", "\[Rule]", 
    RowBox[{"25", " ", "\[Degree]"}]}], ",", 
   RowBox[{"CircuitSwitchOpenSense", "\[Rule]", "\<\"Counterclockwise\"\>"}], 
   ",", 
   RowBox[{"CircuitSwitchDirectives", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"AbsolutePointSize", "[", "5", "]"}], "}"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.623803543053626*^9, 3.62380535407976*^9, 
  3.81327682133961*^9, 3.880664999693565*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"77a1d490-f690-4492-be25-3955b9ce44fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Circuit Elements: Resistor, Capacitor, Inductor, DCVoltage, ACVoltage, \
CurrentArrow, InlineMeter, Diode, DCCurrent, CircuitSwitch, Node and Ground\
\>", "Subsection",
 CellChangeTimes->{{3.623028277843174*^9, 3.623028299990061*^9}, {
  3.623149595941812*^9, 3.62314959752387*^9}, {3.6237604100532923`*^9, 
  3.623760501741789*^9}, {3.623791406427711*^9, 3.6237914265116577`*^9}, {
  3.813291525994526*^9, 
  3.813291536840535*^9}},ExpressionUUID->"95527c75-13c7-49a4-97ae-\
daa15e7a6f3e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{
   RowBox[{"DrawCircuit", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", ".15"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", ".15"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Resistor", "[", "\"\<R\>\"", "]"}], ",", 
           RowBox[{"Capacitor", "[", "\"\<C\>\"", "]"}], ",", 
           RowBox[{"Inductor", "[", "\"\<L\>\"", "]"}], ",", 
           RowBox[{"DCVoltage", "[", "\"\<V\>\"", "]"}], ",", 
           RowBox[{"ACVoltage", "[", "\"\<V\>\"", "]"}]}], "}"}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"CurrentArrow", "[", "\"\<I\>\"", "]"}], ",", 
           RowBox[{"CurrentArrow", "[", 
            RowBox[{"\"\<I\>\"", ",", 
             RowBox[{"CurrentArrowType", "\[Rule]", "\"\<Offset Arrow\>\""}], 
             ",", 
             RowBox[{"CurrentArrowDirectives", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Arrowheads", "[", ".03", "]"}], "}"}]}]}], "]"}], ",", 
           RowBox[{"InlineMeter", "[", "\"\<A\>\"", "]"}], ",", 
           RowBox[{"Diode", "[", "]"}], ",", 
           RowBox[{"DCCurrent", "[", "\"\<I\>\"", "]"}], ",", 
           RowBox[{"CircuitSwitch", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"4", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Node", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<node\>\"", ",", 
              RowBox[{"FontSlant", "\[Rule]", "Plain"}]}], "]"}], ",", 
            RowBox[{"NodeDirectives", "\[Rule]", 
             RowBox[{"AbsolutePointSize", "[", "5", "]"}]}]}], "]"}], ",", 
          RowBox[{"Ground", "[", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<Ground\>\"", ",", 
             RowBox[{"FontSlant", "\[Rule]", "Plain"}]}], "]"}], "]"}]}], 
         "}"}]}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TextOffsetScale", "\[Rule]", ".75"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", "Italic", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6230237658279676`*^9, 3.623023936797209*^9}, {
   3.623024063876627*^9, 3.6230241258135633`*^9}, {3.623024156642076*^9, 
   3.623024172533514*^9}, {3.6230242109416513`*^9, 3.623024217925869*^9}, {
   3.623024329239182*^9, 3.623024334325494*^9}, {3.623024418795701*^9, 
   3.623024547876183*^9}, {3.623024588612722*^9, 3.623024705728088*^9}, {
   3.623024769929529*^9, 3.623024804697796*^9}, 3.623024860463031*^9, {
   3.6230249845963573`*^9, 3.623025052501376*^9}, {3.6230252732453527`*^9, 
   3.623025292146042*^9}, {3.6230253244577303`*^9, 3.6230253273821983`*^9}, {
   3.623025374874374*^9, 3.62302539611751*^9}, {3.623025426293641*^9, 
   3.623025464015665*^9}, {3.623025496860428*^9, 3.6230255904024153`*^9}, {
   3.623027799053014*^9, 3.6230277995239143`*^9}, {3.623070356675365*^9, 
   3.623070370266931*^9}, {3.623070434800761*^9, 3.623070483536914*^9}, {
   3.623070515479555*^9, 3.623070618619205*^9}, {3.6230706577122707`*^9, 
   3.623070700314619*^9}, 3.623073242860038*^9, 3.62311261348435*^9, {
   3.623461122701416*^9, 3.62346113734912*^9}, {3.6234628211167927`*^9, 
   3.62346282485885*^9}, {3.623713307120637*^9, 3.6237134480052347`*^9}, {
   3.623794112690295*^9, 3.623794116383546*^9}, {3.623798832504471*^9, 
   3.623798833623139*^9}, {3.623798935137885*^9, 3.623798940825108*^9}, {
   3.8132915513011227`*^9, 3.8132915606156273`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"9cf7a07d-efe3-43a0-98a9-7d6fd16dec29"],

Cell[BoxData[
 GraphicsBox[{{}, {{{LineBox[{{0., 0.}, {0.08647798742138363, 0.}}], 
      LineBox[{{0.24213836477987416`, 0.}, {0.3286163522012578, 0.}}], 
      LineBox[{{0.35455974842767285`, 0.}, {0.4410377358490565, 0.}}], 
      LineBox[{{0.6108490566037734, 0.}, {0.6973270440251571, 0.}}], 
      LineBox[{{0.7232704402515722, 0.}, {0.8097484276729557, 0.}}], 
      LineBox[{{0.9135220125786161, 0.}, {0.9999999999999998, 0.}}], 
      {AbsoluteThickness[2], 
       LineBox[{{0.08647798742138363, 0.}, {0.09944968553459117, 
        0.012971698113207546`}, {
        0.12539308176100628`, -0.012971698113207546`}, {0.15133647798742136`, 
        0.012971698113207546`}, {
        0.17727987421383645`, -0.012971698113207546`}, {0.20322327044025154`, 
        0.012971698113207546`}, {
        0.2291666666666666, -0.012971698113207546`}, {0.24213836477987416`, 
        0.}}], InsetBox["\<\"R\"\>", \
{0.16430817610062892, 0.03891509433962264}]}, 
      {AbsoluteThickness[2], 
       LineBox[{{0.3286163522012578, 0.051886792452830184`}, {
        0.3286163522012578, -0.051886792452830184`}}], 
       LineBox[{{0.35455974842767285`, 0.051886792452830184`}, {
        0.35455974842767285`, -0.051886792452830184`}}], 
       InsetBox["\<\"C\"\>", {0.3026729559748427, 0.03891509433962264}]}, 
      {AbsoluteThickness[2], LineBox[CompressedData["
1:eJxdlAlIFGEUx1fFPPLWSNMCUUyNNCkhi/zyrGzLZb0w0UQ0LW098tpUBNey
1DbxytSUTXNbIUHzSI0+TRSvjMI8cHd2ZjdUos3CKzbKXNE3sAPDwPz5v/f7
/u/N2MYks+M0GQxGyPateiYU/Ard8BAjxu7V2JDV7RUlRq5p3gtPGOloKS+a
s1gtRoPZx/7YsHlIlFrwZowSo/HhKS8xuwR1pOwrLD8rQYpgy7aM/jLEEg5K
5I0SlLLVc7BSVI76qvKMRHrErr8C2RV6IM4dAvTBvrUaPEuAf7I3O/aBmxTq
81/VtiXmSqH/TCnvhkmXFPgMRXojEfNS4LcMtdWrXgYdm56fWc2Ugx+XH2Az
rSahPh6TJtrNvJDu9ce3064m6WdI9/iw35UTxLjnnr8CH3Y0Y5Xo0roaP1YW
GqXkthNQP+da8eiRWgL6p/ui11uVBPDlq+JvJoC/21AScm8UdLT1fdjQWYM+
/wC5FGbIpPNR40enSiremWuTkO/NnfmSkH8DN3BljkPrCovj9RoCEvxpFisa
ix9IqB9kxBCGrZLQfzNvTbPVmAI+s9Kejo+2FPDXxPhMJzmBjitnn12SOFBw
/pD3Cxku1hTkkypMoAx0Kchv6Oe8tnAF+LDrdvpF08CP6yb6s+J7aV2NH+sr
e3XIR8CPx79unnQrAH48Es4WCfJJ4GOqxltEAn+8p+Bu7FPQkUFb1Ux3F31+
hbAlx3GBzkeNHw14+/Pdz1CQ77pHs4NlMgX5O7tpYmUTrXMnVQOk/f8mBJ90
tGRQnxjuyOQ6yqA/z134ecJXBnwNPre2JywDfvtDG038KNCx7WOW1VYE+DHJ
5fuxWFAf/42ybnc5J4P8Al+Wfhm1l0G+/TvfrwzyP8rjXHj4A/ixGj+uak+a
1Rii5xta36oV1EPPn22qzR3qpPdjbqmsNvotvT+r60EB96fo/aqJu9gy9w38
KPt6+OUAEzofNX7EVP6ODEsGfrSz/s3Aj7qXO/k287Su+nv57ZeDv5gXLHA6
LYf6iXlx/nWRcuhvrAh/ruDKgc95+615qRz4/wMVfp2U
        "]], InsetBox["\<\"L\"\>", {0.525943396226415, 0.03891509433962264}]}, 
      {AbsoluteThickness[2], {
        {AbsoluteThickness[3], 
         LineBox[{{0.6973270440251571, 0.017295597484276726`}, {
          0.6973270440251571, -0.017295597484276726`}}]}, 
        LineBox[{{0.7232704402515722, 0.051886792452830184`}, {
         0.7232704402515722, -0.051886792452830184`}}]}, 
       InsetBox["\<\"V\"\>", {0.671383647798742, 0.03891509433962264}]}, {
       {AbsoluteThickness[2], 
        CircleBox[{0.8616352201257859, 0.}, 0.051886792452830094], 
        LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQfUts98OfGa/sOWZaHz+93cfmzM20p7vaXtmblSS3
Kog32O+fI/Syeskr+291IZO5Z/fZb4zf98bm0Ct7aZbrdxkFptovVsr68Pf+
K3vVllle6w/NsJ/2VPTLvr+v7BmmeJk95phl37Hi4Pd66df2KlD5quzc3w6W
r+2loPpz9CT/M4a/tv8ENT/+4xGmwyWv7Q2h9gduKWBrmfTangEKnMtluFw3
vLa3hMjvN7M6wct27rX9L4j+/Rp/iwWPv34Nc99+qQPyoh2cb2Du28/TfFrC
U/0NzH37/7uCDHwDc9/+jxzKCqeT3thLQvU/Pn1Ouafhjf0rqPnX+qrUfee9
gblv/4lANW2+PW9g4bcHAJbEnZA=
         "]]}, 
       InsetBox["\<\"V\"\>", {0.8616352201257859, 0.0713443396226415}]}}, {
      LineBox[{{0., -0.15}, {0.09097035040431266, -0.15}}], 
      LineBox[{{0.09097035040431266, -0.15}, {0.18194070080862532`, -0.15}}], 
      LineBox[{{0.18194070080862532`, -0.15}, {0.272911051212938, -0.15}}], 
      LineBox[{{0.37668463611859837`, -0.15}, {0.46765498652291104`, -0.15}}],
       LineBox[{{0.5195417789757412, -0.15}, {0.6105121293800538, -0.15}}], 
      LineBox[{{0.7142857142857142, -0.15}, {0.8052560646900269, -0.15}}], 
      LineBox[{{0.9090296495956871, -0.15}, {0.9999999999999998, -0.15}}], 
      {GrayLevel[0.25], AbsoluteThickness[2], 
       LineBox[{{0.07799865229110511, -0.13702830188679244`}, {
        0.1039420485175202, -0.15}, {
        0.07799865229110511, -0.16297169811320755`}}], 
       InsetBox["\<\"I\"\>", {0.09097035040431266, -0.11108490566037735}]}, 
      {AbsoluteThickness[2], Arrowheads[0.03], 
       ArrowBox[{{0.13005390835579514`, -0.1240566037735849}, {
        0.23382749326145552`, -0.1240566037735849}}], 
       InsetBox["\<\"I\"\>", {0.18194070080862532, -0.08514150943396226}]}, {
       {AbsoluteThickness[2], 
        CircleBox[{0.3247978436657682, -0.15}, 0.051886792452830184]}, 
       InsetBox["\<\"A\"\>", {0.3247978436657682, -0.15}]}, 
      {AbsoluteThickness[2], 
       {AbsoluteThickness[2], 
        LineBox[{{0.5195417789757412, -0.12004314640997224`}, {
         0.5195417789757412, -0.17995685359002775`}}]}, 
       LineBox[{{0.5195417789757412, -0.15}, {
        0.46765498652291104`, -0.12004314640997224`}, {
        0.46765498652291104`, -0.17995685359002775`}, {
        0.5195417789757412, -0.15}}]}, {
       {AbsoluteThickness[2], 
        CircleBox[{0.6623989218328841, -0.15}, 0.051886792452830184], {
         LineBox[{{0.6312668463611859, -0.15}, {0.6935309973045821, -0.15}}], 
         LineBox[{{0.6727762803234502, -0.13443396226415094`}, {
          0.6935309973045821, -0.15}, {
          0.6727762803234502, -0.16556603773584905`}}]}}, 
       InsetBox["\<\"I\"\>", {0.6623989218328841, -0.0786556603773585}]}, 
      {AbsolutePointSize[5], AbsoluteThickness[2], 
       LineBox[{{0.8052560646900269, -0.15}, {
        0.8993068727787358, -0.10614338793256892`}}], 
       PointBox[{0.8052560646900269, -0.15}], 
       PointBox[{0.9090296495956871, -0.15}]}}}, {
     {AbsolutePointSize[5], PointBox[{1., -0.15}], InsetBox[
       StyleBox["\<\"node\"\>",
        StripOnInput->False,
        FontSlant->Plain], {1., -0.09811320754716982}]}, {{
       LineBox[{{1., -0.15}, {1., -0.20188679245283017`}}], 
       {AbsoluteThickness[2], 
        LineBox[{{0.9792452830188679, -0.24339622641509434`}, {
         1.0207547169811322`, -0.24339622641509434`}}], 
        LineBox[{{0.9636792452830188, -0.22264150943396224`}, {
         1.036320754716981, -0.22264150943396224`}}], 
        LineBox[{{0.9481132075471698, -0.20188679245283017`}, {
         1.0518867924528301`, -0.20188679245283017`}}]}}, InsetBox[
       StyleBox["\<\"Ground\"\>",
        StripOnInput->False,
        FontSlant->Plain], {1., -0.2952830188679245}]}}}, {}},
  BaseStyle->{12, Italic, FontFamily -> "Times"},
  ImageSize->400]], "Output",
 CellChangeTimes->{
  3.623166768062974*^9, 3.6234611381486483`*^9, 3.623462825345644*^9, 
   3.623632194847776*^9, 3.623632435764327*^9, 3.6236337577579403`*^9, 
   3.6236385837358522`*^9, 3.623679526968506*^9, 3.6237070129401293`*^9, 
   3.6237127505862427`*^9, 3.623713355652789*^9, 3.623713386681203*^9, {
   3.623713434937317*^9, 3.6237134487214127`*^9}, 3.6237149560159883`*^9, 
   3.62371849822795*^9, 3.623718579798386*^9, 3.623760513098646*^9, 
   3.623789341572605*^9, 3.6237896759352083`*^9, 3.623789907282318*^9, 
   3.623790670841298*^9, 3.6237913537403517`*^9, {3.62379409612488*^9, 
   3.623794118009302*^9}, 3.623798807623914*^9, {3.623798919728506*^9, 
   3.623798942220409*^9}, 3.623799309304007*^9, 3.6238053591285467`*^9, 
   3.8132913546110497`*^9, 3.813291561262024*^9, 3.880665009752965*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"d0acd0d2-60a6-4e22-9104-abbd0be62d49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"DrawCircuit", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"CircuitSwitch", "[", 
        RowBox[{
         RowBox[{"CircuitSwitchPosition", "\[Rule]", "\"\<Open\>\""}], ",", 
         RowBox[{"CircuitSwitchOpenAngle", "\[Rule]", 
          RowBox[{"10", "\[Degree]"}]}], ",", 
         RowBox[{"CircuitSwitchDirectives", "\[Rule]", 
          RowBox[{"AbsolutePointSize", "[", "20", "]"}]}]}], "]"}]}], "}"}], 
     "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.813276616530628*^9, 3.813276702348242*^9}, {
  3.813276898930059*^9, 3.813276901523735*^9}, {3.813277015128937*^9, 
  3.813277018050661*^9}, {3.8132778742761*^9, 3.813278058366493*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"ab2fed3d-718b-41b1-8227-3dc53c6e2f34"],

Cell[BoxData[
 GraphicsBox[{{}, {{
     LineBox[NCache[{{0, 0}, {0, Rational[1, 2]}}, {{0, 0}, {0, 0.5}}]], 
     LineBox[NCache[{{0, Rational[3, 2]}, {0, 2}}, {{0, 1.5}, {0, 2}}]], 
     {AbsolutePointSize[20], AbsoluteThickness[2], 
      LineBox[NCache[{{
         0, Rational[1, 2]}, {-Sin[10 Degree], 
          2 (Rational[1, 4] + Rational[1, 2] Cos[10 Degree])}}, {{
         0, 0.5}, {-0.17364817766693033`, 1.4848077530122081`}}]], 
      PointBox[NCache[{0, Rational[1, 2]}, {0, 0.5}]], 
      PointBox[NCache[{0, Rational[3, 2]}, {0, 1.5}]]}}, {}}, {}}]], "Output",
 CellChangeTimes->{
  3.813277900121266*^9, {3.813277945073614*^9, 3.813277968708252*^9}, {
   3.8132780034703217`*^9, 3.813278029484955*^9}, 3.813278060465673*^9, 
   3.8132787005268*^9, 3.880665030953196*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"94ef26ed-8797-4fab-b9c7-9f30d0ff8936"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic Syntax - Specify nodes with Lists or Association.", "Subsection",
 CellChangeTimes->{{3.623028277843174*^9, 3.623028299990061*^9}, {
  3.623149595941812*^9, 3.62314959752387*^9}, {3.6234958539840307`*^9, 
  3.623495866313224*^9}, {3.623802185981789*^9, 
  3.623802222883396*^9}},ExpressionUUID->"7b66c688-709c-4e09-a355-\
eb14de52a614"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DrawCircuit", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Resistor", "[", "\"\<R\>\"", "]"}], ",", 
          RowBox[{"Capacitor", "[", "\"\<C\>\"", "]"}]}], "}"}]}], "}"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"TextOffsetScale", "\[Rule]", ".75"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", "Italic", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62363194802558*^9, 3.623631955527875*^9}, {
   3.623632009727148*^9, 3.623632016698358*^9}, 3.62363237651339*^9, {
   3.6237605716757193`*^9, 3.6237606970820704`*^9}, {3.623760761039472*^9, 
   3.62376085051584*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"cb6d9e4a-c364-4c48-88f1-bcf72496bdae"],

Cell[BoxData[
 GraphicsBox[{{}, {{
     LineBox[NCache[{{0, 0}, {Rational[8, 45], 0}}, {{0, 0}, {
        0.17777777777777778`, 0}}]], 
     LineBox[NCache[{{Rational[26, 45], 0}, {Rational[34, 45], 0}}, {{
        0.5777777777777777, 0}, {0.7555555555555555, 0}}]], 
     LineBox[NCache[{{Rational[37, 45], 0}, {1, 0}}, {{
        0.8222222222222222, 0}, {1, 0}}]], 
     {AbsoluteThickness[2], 
      LineBox[NCache[{{Rational[8, 45], 0}, {
         Rational[19, 90], Rational[1, 30]}, {
         Rational[5, 18], Rational[-1, 30]}, {
         Rational[31, 90], Rational[1, 30]}, {
         Rational[37, 90], Rational[-1, 30]}, {
         Rational[43, 90], Rational[1, 30]}, {
         Rational[49, 90], Rational[-1, 30]}, {Rational[26, 45], 0}}, {{
         0.17777777777777778`, 0}, {0.2111111111111111, 
         0.03333333333333333}, {0.2777777777777778, -0.03333333333333333}, {
         0.34444444444444444`, 0.03333333333333333}, {
         0.4111111111111111, -0.03333333333333333}, {0.4777777777777778, 
         0.03333333333333333}, {0.5444444444444444, -0.03333333333333333}, {
         0.5777777777777777, 0}}]], 
      InsetBox["\<\"R\"\>", {0.3777777777777777, 0.1}]}, 
     {AbsoluteThickness[2], 
      LineBox[NCache[{{Rational[34, 45], Rational[2, 15]}, {
         Rational[34, 45], Rational[-2, 15]}}, {{0.7555555555555555, 
        0.13333333333333333`}, {0.7555555555555555, -0.13333333333333333`}}]],
       LineBox[NCache[{{Rational[37, 45], Rational[2, 15]}, {
         Rational[37, 45], Rational[-2, 15]}}, {{0.8222222222222222, 
        0.13333333333333333`}, {0.8222222222222222, -0.13333333333333333`}}]],
       InsetBox["\<\"C\"\>", {0.6888888888888889, 0.1}]}}, {
     {AbsolutePointSize[3], PointBox[{0, 0}], 
      InsetBox["\<\"a\"\>", {0, -0.1}]}, 
     {AbsolutePointSize[3], PointBox[{1, 0}], 
      InsetBox["\<\"b\"\>", {1, -0.1}]}}}, {}},
  BaseStyle->{12, Italic, FontFamily -> "Times"},
  ImageSize->{155.59687499999978`, Automatic}]], "Output",
 CellChangeTimes->{
  3.623632450154215*^9, 3.62376059401005*^9, 3.623760669677911*^9, {
   3.62376079620776*^9, 3.623760825960703*^9}, 3.6237994121796103`*^9, 
   3.623805374594273*^9, 3.880665056166774*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"94e01268-59b8-4d73-a48a-1d48b5cb6cb0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DrawCircuit", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}], ",", 
        RowBox[{"Resistor", "[", "\"\<R\>\"", "]"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"TextOffsetScale", "\[Rule]", ".75"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", "Italic", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62363194802558*^9, 3.623631955527875*^9}, {
   3.623632009727148*^9, 3.623632016698358*^9}, 3.62363237651339*^9, {
   3.6237605716757193`*^9, 3.6237606970820704`*^9}, {3.623760761039472*^9, 
   3.62376085051584*^9}, {3.623760880607169*^9, 3.623760974403702*^9}, {
   3.623788932372622*^9, 3.623788941945071*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"97ed8f19-d22f-4eee-9711-638228d9c60c"],

Cell[BoxData[
 GraphicsBox[{{}, {{
     LineBox[NCache[{{0, 0}, {Rational[1, 5], 0}}, {{0, 0}, {0.2, 0}}]], 
     LineBox[NCache[{{Rational[4, 5], 0}, {1, 0}}, {{0.8, 0}, {1, 0}}]], 
     {AbsoluteThickness[2], 
      LineBox[NCache[{{Rational[1, 5], 0}, {
         Rational[1, 4], Rational[1, 20]}, {
         Rational[7, 20], Rational[-1, 20]}, {
         Rational[9, 20], Rational[1, 20]}, {
         Rational[11, 20], Rational[-1, 20]}, {
         Rational[13, 20], Rational[1, 20]}, {
         Rational[3, 4], Rational[-1, 20]}, {Rational[4, 5], 0}}, {{0.2, 0}, {
         0.25, 0.05}, {0.35, -0.05}, {0.45, 0.05}, {0.55, -0.05}, {0.65, 
         0.05}, {0.75, -0.05}, {0.8, 0}}]], 
      InsetBox["\<\"R\"\>", {0.5, 0.15000000000000002}]}}, {
     {AbsolutePointSize[3], PointBox[{0, 0}], 
      InsetBox["\<\"a\"\>", {0, -0.15000000000000002}]}, 
     {AbsolutePointSize[3], PointBox[{1, 0}], 
      InsetBox["\<\"b\"\>", {1, -0.15000000000000002}]}}}, {}},
  BaseStyle->{12, Italic, FontFamily -> "Times"},
  ImageSize->{95.34687500000004, Automatic}]], "Output",
 CellChangeTimes->{{3.623760950167864*^9, 3.6237609766504297`*^9}, 
   3.623788953446356*^9, 3.623799415616324*^9, 3.623805401761126*^9, {
   3.813276962936866*^9, 3.81327698513618*^9}, 3.880665067489888*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"d20a630c-9222-4120-a780-92e07bb929aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DrawCircuit", "[", 
    RowBox[{
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"\"\<a\>\"", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"\"\<b\>\"", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Inductor", "[", "\"\<L\>\"", "]"}], ",", 
          RowBox[{"Capacitor", "[", "\"\<C\>\"", "]"}]}], "}"}]}], "}"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<a\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"Node", "[", 
          RowBox[{"\"\<b\>\"", ",", 
           RowBox[{"TextOffset", "\[Rule]", ".75"}]}], "]"}]}], "}"}]}], 
      "}"}], ",", 
     RowBox[{"TextOffsetScale", "\[Rule]", ".75"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", "Italic", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62363194802558*^9, 3.623631955527875*^9}, {
   3.623632009727148*^9, 3.623632016698358*^9}, 3.62363237651339*^9, {
   3.6237605716757193`*^9, 3.6237606970820704`*^9}, {3.623760761039472*^9, 
   3.62376085051584*^9}, {3.623760880607169*^9, 3.623760974403702*^9}, {
   3.623788932372622*^9, 3.623788941945071*^9}, {3.623789018886819*^9, 
   3.623789115439233*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"3d7a0bdf-1fa7-41fd-9087-f8aa78843f9a"],

Cell[BoxData[
 GraphicsBox[{{}, {{LineBox[{{0., 0.}, {0.17153996101364521`, 0.}}], 
     LineBox[{{0.5925925925925926, 0.}, {0.7641325536062378, 0.}}], 
     LineBox[{{0.8284600389863548, 0.}, {0.9999999999999999, 0.}}], 
     {AbsoluteThickness[2], LineBox[CompressedData["
1:eJxdkXlIk3EYx+fSPCpslWik0DzLqDSMaB0/TW2iHW6pgXlklkUHMzU3y+U5
D4RqlEpg5cLSLCgj0LzetNQ0U99Nd7nXzXmL5TmdlpqBe4S98PL+8eV5ns/3
81IvsZhXyCQSKXDl/f/1D/fgGmkaEGn1icoRGJDfNKLg+Z3soNYstI7GIg3X
NSH3JINFo5l8NFM6XUI/2IySP3B+Lo0XIqf3guqMqRYUGNAynlhbhNgSzI3c
34rEv91vbLMrRsbj1OrMibbV+WJ0el29ION+B+RxlnioFxuH+QfbS4b6AoWw
35g5WvXYXAT3A3YzqtYXiIAvHKUsGs6KgN/f1aO7cUenLseWIlr+bDXv1M1j
qa4cun2XSLcfizzEJ7ziRbr72OE9MR70RaGOD7vpVPbsW7xQx489t5uY95jA
Idfjx4JsRqcvW+GwXz6Wj+70dMD9TBvqxXq8A/g45r3H0uc6gD/NgZKcysCh
H/6XnaQhcOjve7Dy3Kv8NT96/CjHr/ApmdUJfgPOM0K973SBf5tIMjXrnhhy
TzaF8I6TwHxYwnDUAFMK+8VlzkdyN8rgvkM2n2byVAZ8Li/qEtdPy4Cfyk8J
/m4lh35tdWb3LDbKoT+TX9HoIJSBH7d8PORkrAz8meR8/OKzIAW/RzMnrRtj
peCfleaS4PlLArkeP+bIdY6NspDA/tJT0tr4bjHcP8+NUH5tEwOfD4taw5sR
Az+Tx1hOOyOBfi9DKpZm5RLovz13Qfj6yZofPX504a3KyvCmHPzalfMVJ2O6
wf9Y/YnCbI4CcgsJI4R+m4D5fbJdg4Nne2B/MeVGZZ6pEu5rhvHPpnlK4CMt
G/w1nlACf4JWNdZvpoJ+7Y8cuDmGKuhvO6n1dmpXgh/DOYqCHq0Ef/LRKeQ7
1wN+Nw25FjRF94B/975ordcoAbkeP6ZRXJ+6uoWA/QnvrI5zpAq470gIwhp+
KIDPsj1i5RcrgN92gH+f50dAv5hqLVcrIaD/yAyNWcJf86PHj3J5m1tT3VTg
9+6Gkb1F5SrwH8ave9hA64U8dkfzLfvyXphPKvh0IM5RDfurKrqsT6Wp4X6k
fXYBr1kNfNf2C2rSZ9XA/w+ReaaW
       "]], InsetBox["\<\"L\"\>", {0.3820662768031189, 0.09649122807017543}]}, 
     {AbsoluteThickness[2], 
      LineBox[{{0.7641325536062378, 0.1286549707602339}, {
       0.7641325536062378, -0.1286549707602339}}], 
      LineBox[{{0.8284600389863548, 0.1286549707602339}, {
       0.8284600389863548, -0.1286549707602339}}], 
      InsetBox["\<\"C\"\>", {0.6998050682261209, 0.09649122807017543}]}}, {
     {AbsolutePointSize[3], PointBox[{0., 0.}], 
      InsetBox["\<\"a\"\>", {0., -0.09649122807017543}]}, 
     {AbsolutePointSize[3], PointBox[{1., 0.}], 
      InsetBox["\<\"b\"\>", {1., -0.09649122807017543}]}}}, {}},
  BaseStyle->{12, Italic, FontFamily -> "Times"},
  ImageSize->{155.79374999999987`, Automatic}]], "Output",
 CellChangeTimes->{3.623789088448008*^9, 3.62378911882225*^9, 
  3.623799420442658*^9, 3.623805408087088*^9, 3.81327698943604*^9, 
  3.8806650778801126`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"4ca90d92-1e2b-411b-aa99-26974e3c07f9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Some Options (with Code)", "Subsection",
 CellChangeTimes->{{3.6230281825263166`*^9, 3.6230281845524483`*^9}, {
  3.623028215438328*^9, 3.6230282208302727`*^9}, {3.623028267170141*^9, 
  3.623028273705553*^9}, {3.6231496029398737`*^9, 3.623149604228097*^9}, {
  3.623800639789418*^9, 
  3.623800640298661*^9}},ExpressionUUID->"6e2d50f1-a6f3-4250-8b4a-\
54181fc14dc9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{"DrawCircuit", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[LeftAssociation]", 
       RowBox[{
        RowBox[{"\"\<a\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", 
        RowBox[{"\"\<b\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", 
           RowBox[{"-", "3"}]}], "}"}]}], ",", 
        RowBox[{"\"\<d\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"\"\<e\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "3"}]}], "}"}]}], ",", 
        RowBox[{"\"\<f\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"3", ",", "0"}], "}"}]}], ",", 
        RowBox[{"\"\<g\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"-", "3"}]}], "}"}]}]}], "\[RightAssociation]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<b\>\"", ",", "\"\<d\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Resistor", "[", 
            RowBox[{"\"\<24\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
             RowBox[{"ResistorTurnNumber", "\[Rule]", "20"}]}], "]"}], 
           "}"}]}], "}"}], ",", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<b\>\"", ",", "\"\<e\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Resistor", "[", 
            RowBox[{"\"\<6\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
             RowBox[{"ResistorDirectives", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Darker", "[", "Red", "]"}], "}"}]}]}], "]"}], "}"}]}],
          "}"}], ",", "\n", "\t", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<e\>\"", ",", "\"\<g\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Resistor", "[", "\"\<6\[VeryThinSpace]\[CapitalOmega]\>\"", "]"}],
            "}"}]}], "}"}], ",", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<e\>\"", ",", "\"\<d\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"DCVoltage", "[", 
             RowBox[{"\"\<4\[VeryThinSpace]V\>\"", ",", 
              RowBox[{"DCVoltageGap", "\[Rule]", ".075"}], ",", 
              RowBox[{"DCVoltageShowPolarity", "\[Rule]", "True"}], ",", 
              RowBox[{"DCVoltageFlipped", "\[Rule]", "True"}], ",", 
              RowBox[{"DCVoltageNumberCells", "\[Rule]", "5"}], ",", 
              RowBox[{"DCVoltageDirectives", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
                 RowBox[{"Darker", "[", "Red", "]"}]}], "}"}]}]}], "]"}], ",", 
            RowBox[{"CurrentArrow", "[", 
             RowBox[{
             "\"\<\!\(\*StyleBox[\"I\",FontSlant->\"Italic\"]\)\>\"", ",", 
              RowBox[{"TextOffset", "\[Rule]", 
               RowBox[{"-", ".75"}]}], ",", 
              RowBox[{"CurrentArrowType", "\[Rule]", "\"\<Offset Arrow\>\""}],
               ",", 
              RowBox[{"CurrentArrowFlipped", "\[Rule]", "True"}], ",", 
              RowBox[{"OffsetArrowOffset", "\[Rule]", 
               RowBox[{"-", "0.5`"}]}]}], "]"}], ",", 
            RowBox[{"Wire", "[", ".25", "]"}]}], "}"}]}], "}"}], ",", "\n", 
        "\t", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<d\>\"", ",", "\"\<g\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Resistor", "[", 
            RowBox[{"\"\<12\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
             RowBox[{"ResistorTurnNumber", "\[Rule]", "20"}]}], "]"}], 
           "}"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"TextOffsetScale", "\[Rule]", "1."}], ",", 
      RowBox[{"ResistorDirectives", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Darker", "[", "Blue", "]"}], "}"}]}]}], "]"}], ",", 
    RowBox[{"BaseStyle", "->", 
     RowBox[{"{", 
      RowBox[{"12", ",", 
       RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "250"}]}], "]"}], "\n"}]], "Input",
 CellChangeTimes->{{3.4761292490659103`*^9, 3.4761293838992033`*^9}, {
   3.476129698029574*^9, 3.476129782750861*^9}, {3.476129816638576*^9, 
   3.476129910996469*^9}, {3.4761455660663*^9, 3.476145587414956*^9}, 
   3.4761460829040728`*^9, {3.476149521319887*^9, 3.476149533061009*^9}, {
   3.476149575813961*^9, 3.476149576115827*^9}, {3.476150879325314*^9, 
   3.476150895258357*^9}, {3.4761850112777243`*^9, 3.476185014730084*^9}, {
   3.476212953593615*^9, 3.476212956329454*^9}, {3.476214335836153*^9, 
   3.476214336584611*^9}, {3.4763639059736757`*^9, 3.476363936141918*^9}, {
   3.47636407342378*^9, 3.476364092124332*^9}, {3.476364127790429*^9, 
   3.476364144321677*^9}, {3.476364195314004*^9, 3.476364196049848*^9}, 
   3.4763695607250433`*^9, {3.476369635331408*^9, 3.4763696514804697`*^9}, {
   3.4763697629746847`*^9, 3.476369763205612*^9}, {3.4763711198632917`*^9, 
   3.4763711202453337`*^9}, {3.4763785594621277`*^9, 3.476378596108672*^9}, {
   3.4763786323585243`*^9, 3.476378638056254*^9}, {3.4763892636059923`*^9, 
   3.476389264556416*^9}, {3.476389326268113*^9, 3.476389359763085*^9}, {
   3.4764093372903347`*^9, 3.4764093456959257`*^9}, {3.476410477523383*^9, 
   3.47641047823238*^9}, {3.4764407569076843`*^9, 3.476440827582417*^9}, {
   3.476441409129401*^9, 3.47644146016842*^9}, {3.5007244849057293`*^9, 
   3.5007245034178553`*^9}, 3.500724746467609*^9, {3.500725158017663*^9, 
   3.500725232178095*^9}, {3.500728984098486*^9, 3.500729001669846*^9}, {
   3.5007290820084763`*^9, 3.500729118593135*^9}, {3.500810249282589*^9, 
   3.5008102603811407`*^9}, {3.5008108252987127`*^9, 
   3.5008108387852087`*^9}, {3.5008203945632277`*^9, 
   3.5008203962971287`*^9}, {3.500820473711627*^9, 3.50082047545999*^9}, {
   3.500855710086976*^9, 3.500855714146418*^9}, {3.5008557688467503`*^9, 
   3.500855769745311*^9}, {3.5008558578458023`*^9, 3.5008558728075237`*^9}, {
   3.5010795888531218`*^9, 3.5010795967725153`*^9}, {3.501201190777375*^9, 
   3.501201212870926*^9}, {3.501201269289819*^9, 3.501201278696678*^9}, {
   3.5012014489407167`*^9, 3.5012014607984257`*^9}, {3.501202489500186*^9, 
   3.501202539654623*^9}, {3.50120263323245*^9, 3.5012026338381023`*^9}, {
   3.501238042646206*^9, 3.501238110698288*^9}, {3.5012433672888308`*^9, 
   3.501243384300075*^9}, {3.5012473596869183`*^9, 3.501247391794386*^9}, {
   3.501247443021619*^9, 3.501247471346409*^9}, {3.501248163120716*^9, 
   3.501248164117937*^9}, {3.623027180698484*^9, 3.6230273404413767`*^9}, {
   3.623027372623007*^9, 3.623027408618905*^9}, {3.623027539214164*^9, 
   3.623027544612825*^9}, {3.623027610148494*^9, 3.6230276276602488`*^9}, 
   3.623073191277549*^9, 3.623073228268708*^9, {3.623076243060247*^9, 
   3.623076361359077*^9}, {3.6234627998197117`*^9, 3.623462811193783*^9}, {
   3.623497129508973*^9, 3.623497237908058*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"67bd2be1-7272-4305-8ff1-090e72841f3a"],

Cell[BoxData[
 GraphicsBox[{{}, {{{
      LineBox[NCache[{{-3, -3}, {
         Rational[-11, 4], Rational[-11, 4]}}, {{-3, -3}, {-2.75, -2.75}}]], 
      LineBox[NCache[{{Rational[-1, 4], Rational[-1, 4]}, {0, 
         0}}, {{-0.25, -0.25}, {0, 0}}]], 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], AbsoluteThickness[2], 
       LineBox[NCache[{{Rational[-11, 4], Rational[-11, 4]}, {
          Rational[-11, 4], Rational[-21, 8]}, {
          Rational[-5, 2], Rational[-21, 8]}, {
          Rational[-5, 2], Rational[-19, 8]}, {
          Rational[-9, 4], Rational[-19, 8]}, {
          Rational[-9, 4], Rational[-17, 8]}, {-2, Rational[-17, 8]}, {-2, 
           Rational[-15, 8]}, {Rational[-7, 4], Rational[-15, 8]}, {
          Rational[-7, 4], Rational[-13, 8]}, {
          Rational[-3, 2], Rational[-13, 8]}, {
          Rational[-3, 2], Rational[-11, 8]}, {
          Rational[-5, 4], Rational[-11, 8]}, {
          Rational[-5, 4], Rational[-9, 8]}, {-1, Rational[-9, 8]}, {-1, 
           Rational[-7, 8]}, {Rational[-3, 4], Rational[-7, 8]}, {
          Rational[-3, 4], Rational[-5, 8]}, {
          Rational[-1, 2], Rational[-5, 8]}, {
          Rational[-1, 2], Rational[-3, 8]}, {
          Rational[-1, 4], Rational[-3, 8]}, {
          Rational[-1, 4], 
           Rational[-1, 
            4]}}, {{-2.75, -2.75}, {-2.75, -2.625}, {-2.5, -2.625}, {-2.5, \
-2.375}, {-2.25, -2.375}, {-2.25, -2.125}, {-2, -2.125}, {-2, -1.875}, \
{-1.75, -1.875}, {-1.75, -1.625}, {-1.5, -1.625}, {-1.5, -1.375}, {-1.25, \
-1.375}, {-1.25, -1.125}, {-1, -1.125}, {-1, -0.875}, {-0.75, -0.875}, \
{-0.75, -0.625}, {-0.5, -0.625}, {-0.5, -0.375}, {-0.25, -0.375}, {-0.25, \
-0.25}}]], 
       InsetBox["\<\"24\[VeryThinSpace]\[CapitalOmega]\"\>", \
{-1.75, -1.25}]}}, {
      LineBox[NCache[{{-3, -3}, {-3 + 
          2^Rational[-1, 2] (Rational[-3, 4] + 
            3 2^Rational[-1, 
                2]), -3}}, {{-3, -3}, {-2.030330085889911, -3}}]], 
      LineBox[NCache[{{-3 + 
          2^Rational[1, 2] (Rational[3, 4] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3}, {
         0, -3}}, {{-0.9696699141100895, -3}, {0, -3}}]], 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[2], 
       LineBox[NCache[{{-3 + 
           2^Rational[-1, 2] (Rational[-3, 4] + 
             3 2^Rational[-1, 2]), -3}, {-3 + 
           2^Rational[1, 2] (Rational[1, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[3, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[5, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[7, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[9, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[11, 16] + 
             Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {-3 + 
           2^Rational[1, 2] (Rational[3, 4] + 
             Rational[1, 2] (Rational[-3, 4] + 
               3 2^Rational[-1, 
                   2])), -3}}, {{-2.030330085889911, -3}, \
{-1.9419417382415922`, -2.9116116523516817`}, {-1.7651650429449555`, \
-3.0883883476483183`}, {-1.5883883476483185`, -2.9116116523516817`}, \
{-1.4116116523516815`, -3.0883883476483183`}, {-1.2348349570550448`, \
-2.9116116523516817`}, {-1.0580582617584078`, -3.0883883476483183`}, \
{-0.9696699141100895, -3}}]], 
       InsetBox["\<\"6\[VeryThinSpace]\[CapitalOmega]\"\>", \
{-1.5, -2.646446609406726}]}}, {
      LineBox[NCache[{{0, -3}, {
         2^Rational[-1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2]), -3}}, {{
         0, -3}, {0.9696699141100892, -3}}]], 
      LineBox[NCache[{{
         2^Rational[1, 2] (Rational[3, 4] + 
           Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3}, {
         3, -3}}, {{2.0303300858899105`, -3}, {3, -3}}]], 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], AbsoluteThickness[2], 
       LineBox[NCache[{{
          2^Rational[-1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2]), -3}, {
          2^Rational[1, 2] (Rational[1, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[3, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[5, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[7, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[9, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[11, 16] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3 + 
           Rational[-1, 8] 2^Rational[-1, 2]}, {
          2^Rational[1, 2] (Rational[3, 4] + 
            Rational[1, 2] (Rational[-3, 4] + 3 2^Rational[-1, 2])), -3}}, {{
          0.9696699141100892, -3}, {
          1.0580582617584078`, -2.9116116523516817`}, {
          1.2348349570550445`, -3.0883883476483183`}, {
          1.4116116523516815`, -2.9116116523516817`}, {
          1.5883883476483185`, -3.0883883476483183`}, {
          1.7651650429449552`, -2.9116116523516817`}, {
          1.9419417382415922`, -3.0883883476483183`}, {
          2.0303300858899105`, -3}}]], 
       InsetBox["\<\"6\[VeryThinSpace]\[CapitalOmega]\"\>", \
{1.5, -2.646446609406726}]}}, {LineBox[{{0, -3}, {0., -2.436049181731704}}], 
      LineBox[{{0., -1.481455027129865}, {0., -0.9175042088615695}}], 
      LineBox[{{0., -0.9175042088615695}, {0., 0.}}], 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[1.5], {{
         {AbsoluteThickness[3], 
          LineBox[{{-0.11785113019775792`, -2.329983164553722}, {
           0.11785113019775792`, -2.329983164553722}}]}, 
         LineBox[{{-0.3535533905932738, -2.436049181731704}, {
          0.3535533905932738, -2.436049181731704}}]}, {
         {AbsoluteThickness[3], 
          LineBox[{{-0.11785113019775792`, -2.117851130197758}, {
           0.11785113019775792`, -2.117851130197758}}]}, 
         LineBox[{{-0.3535533905932738, -2.22391714737574}, {
          0.3535533905932738, -2.22391714737574}}]}, {
         {AbsoluteThickness[3], 
          LineBox[{{-0.11785113019775792`, -1.9057190958417938`}, {
           0.11785113019775792`, -1.9057190958417938`}}]}, 
         LineBox[{{-0.3535533905932738, -2.011785113019776}, {
          0.3535533905932738, -2.011785113019776}}]}, {
         {AbsoluteThickness[3], 
          LineBox[{{-0.11785113019775792`, -1.6935870614858295`}, {
           0.11785113019775792`, -1.6935870614858295`}}]}, 
         LineBox[{{-0.3535533905932738, -1.7996530786638116`}, {
          0.3535533905932738, -1.7996530786638116`}}]}, {
         {AbsoluteThickness[3], 
          LineBox[{{-0.11785113019775792`, -1.481455027129865}, {
           0.11785113019775792`, -1.481455027129865}}]}, 
         LineBox[{{-0.3535533905932738, -1.5875210443078471`}, {
          0.3535533905932738, -1.5875210443078471`}}]}}, {
        InsetBox["\<\"+\"\>", {-0.1767766952966369, -2.612825877028341}], 
        InsetBox["\<\"-\"\>", {-0.1767766952966369, -1.3046783318332282}]}, 
       InsetBox["\<\"4\[VeryThinSpace]V\"\>", \
{-0.5303300858899107, -1.9587521044307847}]}, 
      {GrayLevel[0.25], AbsoluteThickness[2], 
       ArrowBox[{{0.1767766952966369, -0.5639508182682955}, {
        0.1767766952966369, -1.2710575994548432`}}], 
       InsetBox["\<\"\\!\\(\\*StyleBox[\\\"I\\\",FontSlant->\\\"Italic\\\"]\\)\
\"\>", {0.4419417382415922, -0.9175042088615695}]}}, {
      LineBox[NCache[{{0, 0}, {Rational[1, 4], Rational[-1, 4]}}, {{0, 0}, {
         0.25, -0.25}}]], 
      LineBox[NCache[{{Rational[11, 4], Rational[-11, 4]}, {3, -3}}, {{
         2.75, -2.75}, {3, -3}}]], 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], AbsoluteThickness[2], 
       LineBox[NCache[{{Rational[1, 4], Rational[-1, 4]}, {
          Rational[3, 8], Rational[-1, 4]}, {
          Rational[3, 8], Rational[-1, 2]}, {
          Rational[5, 8], Rational[-1, 2]}, {
          Rational[5, 8], Rational[-3, 4]}, {
          Rational[7, 8], Rational[-3, 4]}, {Rational[7, 8], -1}, {
          Rational[9, 8], -1}, {Rational[9, 8], Rational[-5, 4]}, {
          Rational[11, 8], Rational[-5, 4]}, {
          Rational[11, 8], Rational[-3, 2]}, {
          Rational[13, 8], Rational[-3, 2]}, {
          Rational[13, 8], Rational[-7, 4]}, {
          Rational[15, 8], Rational[-7, 4]}, {Rational[15, 8], -2}, {
          Rational[17, 8], -2}, {Rational[17, 8], Rational[-9, 4]}, {
          Rational[19, 8], Rational[-9, 4]}, {
          Rational[19, 8], Rational[-5, 2]}, {
          Rational[21, 8], Rational[-5, 2]}, {
          Rational[21, 8], Rational[-11, 4]}, {
          Rational[11, 4], Rational[-11, 4]}}, {{0.25, -0.25}, {
          0.375, -0.25}, {0.375, -0.5}, {0.625, -0.5}, {0.625, -0.75}, {
          0.875, -0.75}, {0.875, -1}, {1.125, -1}, {1.125, -1.25}, {
          1.375, -1.25}, {1.375, -1.5}, {1.625, -1.5}, {1.625, -1.75}, {
          1.875, -1.75}, {1.875, -2}, {2.125, -2}, {2.125, -2.25}, {
          2.375, -2.25}, {2.375, -2.5}, {2.625, -2.5}, {2.625, -2.75}, {
          2.75, -2.75}}]], 
       InsetBox["\<\"12\[VeryThinSpace]\[CapitalOmega]\"\>", \
{1.75, -1.25}]}}}, {}}, {}},
  BaseStyle->{12, FontFamily -> "Times"},
  ImageSize->250]], "Output",
 CellChangeTimes->{
  3.623166794093769*^9, {3.62346280575815*^9, 3.623462812028137*^9}, 
   3.623497239202677*^9, 3.6236324629285507`*^9, 3.8806650927258863`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"671922b2-674b-4eda-8604-ec1179554b83"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Current Arrow Styles", "Subsection",
 CellChangeTimes->{
  3.3824524252213373`*^9, {3.514308595622859*^9, 3.514308595844242*^9}, 
   3.514662627149618*^9, 3.514662723834064*^9, {3.614640343117742*^9, 
   3.614640359900044*^9}, {3.61464046603579*^9, 3.614640474370236*^9}, {
   3.614640548453722*^9, 3.6146405492848988`*^9}, {3.614641131517108*^9, 
   3.614641131519636*^9}, {3.614643664517418*^9, 3.614643676925076*^9}, 
   3.6230283218411617`*^9, {3.6230855980843983`*^9, 3.623085608091147*^9}, 
   3.6238012015284452`*^9, {3.623802312361865*^9, 
   3.623802320560309*^9}},ExpressionUUID->"a19cbd0e-6745-4519-9eec-\
80fb83904d37"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DrawCircuit", "[", 
    RowBox[{
     RowBox[{"\[LeftAssociation]", 
      RowBox[{
       RowBox[{"\"\<a\>\"", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"\"\<b\>\"", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}]}]}], "\[RightAssociation]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"CurrentArrow", "[", "\"\<I\>\"", "]"}], ",", 
          RowBox[{"CurrentArrow", "[", 
           RowBox[{"\"\<I\>\"", ",", 
            RowBox[{"CurrentArrowDirectives", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
               RowBox[{"Darker", "[", "Green", "]"}]}], "}"}]}]}], "]"}], ",", 
          RowBox[{"CurrentArrow", "[", 
           RowBox[{"\"\<I\>\"", ",", 
            RowBox[{"CurrentArrowType", "\[Rule]", "\"\<Offset Arrow\>\""}]}],
            "]"}], ",", 
          RowBox[{"Wire", "[", 
           RowBox[{"1", "/", "8"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"CurrentArrow", "[", 
           RowBox[{"\"\<I\>\"", ",", 
            RowBox[{"CurrentArrowType", "\[Rule]", "\"\<Offset Arrow\>\""}], 
            ",", 
            RowBox[{"CurrentArrowFlipped", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"CurrentArrow", "[", 
           RowBox[{"\"\<I\>\"", ",", 
            RowBox[{
            "CurrentArrowType", "\[Rule]", "\"\<Simple Polygon\>\""}]}], 
           "]"}], ",", 
          RowBox[{"CurrentArrow", "[", 
           RowBox[{"\"\<I\>\"", ",", 
            RowBox[{
            "CurrentArrowType", "\[Rule]", "\"\<Inline Polygon\>\""}]}], 
           "]"}]}], "}"}]}], "}"}], "}"}], ",", 
     RowBox[{"TextOffsetScale", "\[Rule]", ".75"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", "Italic", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62363194802558*^9, 3.623631955527875*^9}, {
   3.623632009727148*^9, 3.623632016698358*^9}, 3.62363237651339*^9, {
   3.6237605716757193`*^9, 3.6237606970820704`*^9}, {3.623760761039472*^9, 
   3.62376085051584*^9}, {3.623760880607169*^9, 3.623760974403702*^9}, {
   3.623788932372622*^9, 3.623788941945071*^9}, {3.623789018886819*^9, 
   3.623789115439233*^9}, {3.623802344220859*^9, 3.6238023724094543`*^9}, {
   3.623802451746564*^9, 3.623802539053549*^9}, {3.623802578460582*^9, 
   3.6238026558535757`*^9}, {3.623802701351041*^9, 3.6238027120347137`*^9}, {
   3.6238029546571093`*^9, 3.623803007703063*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"7bf4b89c-c6dc-453a-b889-ba6f02966eb0"],

Cell[BoxData[
 GraphicsBox[{{}, {{
     LineBox[NCache[{{0, 0}, {Rational[24, 175], 0}}, {{0, 0}, {
        0.13714285714285715`, 0}}]], 
     LineBox[NCache[{{Rational[24, 175], 0}, {Rational[48, 175], 0}}, {{
        0.13714285714285715`, 0}, {0.2742857142857143, 0}}]], 
     LineBox[NCache[{{Rational[48, 175], 0}, {Rational[72, 175], 0}}, {{
        0.2742857142857143, 0}, {0.4114285714285714, 0}}]], 
     LineBox[NCache[{{Rational[72, 175], 0}, {Rational[103, 175], 0}}, {{
        0.4114285714285714, 0}, {0.5885714285714285, 0}}]], 
     LineBox[NCache[{{Rational[103, 175], 0}, {Rational[127, 175], 0}}, {{
        0.5885714285714285, 0}, {0.7257142857142858, 0}}]], 
     LineBox[NCache[{{Rational[127, 175], 0}, {Rational[151, 175], 0}}, {{
        0.7257142857142858, 0}, {0.8628571428571429, 0}}]], 
     LineBox[NCache[{{Rational[151, 175], 0}, {1, 0}}, {{
        0.8628571428571429, 0}, {1, 0}}]], 
     {GrayLevel[0.25], AbsoluteThickness[2], 
      LineBox[NCache[{{Rational[41, 350], Rational[1, 50]}, {
         Rational[11, 70], 0}, {Rational[41, 350], Rational[-1, 50]}}, {{
         0.11714285714285715`, 0.02}, {0.15714285714285714`, 0}, {
         0.11714285714285715`, -0.02}}]], 
      InsetBox["\<\"I\"\>", {0.13714285714285715, 0.06}]}, 
     {RGBColor[0, 
       NCache[
        Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[4], 
      LineBox[NCache[{{Rational[89, 350], Rational[1, 50]}, {
         Rational[103, 350], 0}, {Rational[89, 350], Rational[-1, 50]}}, {{
         0.2542857142857143, 0.02}, {0.29428571428571426`, 0}, {
         0.2542857142857143, -0.02}}]], 
      InsetBox["\<\"I\"\>", {0.2742857142857143, 0.06}]}, 
     {GrayLevel[0.25], AbsoluteThickness[2], 
      ArrowBox[{{0.33142857142857146`, 0.04}, {0.4914285714285715, 0.04}}], 
      InsetBox["\<\"I\"\>", {0.4114285714285715, 0.1}]}, 
     {GrayLevel[0.25], AbsoluteThickness[2], 
      ArrowBox[{{0.6685714285714286, 0.04}, {0.5085714285714286, 0.04}}], 
      InsetBox["\<\"I\"\>", {0.5885714285714285, 0.1}]}, 
     {GrayLevel[0.25], AbsoluteThickness[2], 
      PolygonBox[
       NCache[{{Rational[247, 350], Rational[1, 50]}, {
         Rational[261, 350], 0}, {Rational[247, 350], Rational[-1, 50]}}, {{
         0.7057142857142857, 0.02}, {0.7457142857142857, 0}, {
         0.7057142857142857, -0.02}}]], 
      InsetBox["\<\"I\"\>", {0.7257142857142858, 0.06}]}, 
     {GrayLevel[0.25], AbsoluteThickness[2], 
      PolygonBox[{{0.822857142857143, -0.026666666666666665`}, {
       0.862857142857143, -0.026666666666666665`}, {
       0.862857142857143, -0.04}, {0.9028571428571429, 0.}, {
       0.862857142857143, 0.04}, {0.862857142857143, 0.026666666666666665`}, {
       0.822857142857143, 0.026666666666666665`}}], 
      InsetBox["\<\"I\"\>", {0.862857142857143, 0.06}]}}, {}}, {}},
  BaseStyle->{12, Italic, FontFamily -> "Times"},
  ImageSize->{234.715625, Automatic}]], "Output",
 CellChangeTimes->{
  3.623802512373371*^9, 3.623802622469895*^9, 3.6238026566906776`*^9, 
   3.623802713139255*^9, {3.623802974386558*^9, 3.623803008141056*^9}, 
   3.8806651121292877`*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"3d3cdbd4-cb49-4f32-80e6-ff0778625c2b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Meters and Offsets", "Subsection",
 CellChangeTimes->{
  3.3824524252213373`*^9, {3.514308595622859*^9, 3.514308595844242*^9}, 
   3.514662627149618*^9, 3.514662723834064*^9, {3.614640343117742*^9, 
   3.614640359900044*^9}, {3.61464046603579*^9, 3.614640474370236*^9}, {
   3.614640548453722*^9, 3.6146405492848988`*^9}, {3.614641131517108*^9, 
   3.614641131519636*^9}, {3.614643664517418*^9, 3.614643676925076*^9}, 
   3.6230283218411617`*^9, {3.6230855980843983`*^9, 3.623085608091147*^9}, 
   3.6238012015284452`*^9},ExpressionUUID->"093d1d8d-53e7-4759-831f-\
e3ad5f83d7fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "OffsetPoints"}]], "Input",
 CellChangeTimes->{{3.623801940066422*^9, 3.6238019447124863`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"4e6e2046-7667-4450-9694-3215b625dff5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   FrameBox[
    DynamicModuleBox[{System`InformationDump`open$$ = False, 
     System`InformationDump`mouseOver$$ = False}, 
     PaneSelectorBox[{True->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False,
             BaseStyle -> None],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"OffsetPoints[{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"\
lbl\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\)},\\!\\(\\*\\nStyleBox[\\\"gap\\\",\\nFontSlant->\\\"Italic\\\"]\\)\
\\!\\(\\*\\nStyleBox[\\\" \
\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"fraction\\\",\\\
nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\nStyleBox[\\\"offset\\\",\\\
nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\nStyleBox[\\\"opts\\\",\\nFontSlant-\
>\\\"Italic\\\"]\\)] is a circuit element for DrawCircuit. All \
\\!\\(\\*\\nStyleBox[\\\"options\\\",\\nFontSlant->\\\"Italic\\\"]\\) are \
found in Options[DrawCircuit].\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          PaneBox[GridBox[{
             {
              
              DynamicModuleBox[{System`InformationDump`open$$ = {
               False, False, False, False, False, False}}, 
               StyleBox[GridBox[{
                  {
                   TagBox[
                    TooltipBox[
                    StyleBox["\<\" Full Name\"\>", "InformationRowLabel",
                    StripOnInput->False],
                    "\"FullName\"",
                    TooltipStyle->"TextStyling"],
                    
                    Annotation[#, "FullName", 
                    "Tooltip"]& ], "\<\"Circuit`OffsetPoints\"\>"}
                 },
                 AutoDelete->False,
                 GridBoxAlignment->{"Columns" -> {Right, Left}},
                 GridBoxDividers->None,
                 GridBoxItemSize->{"Columns" -> {Automatic, Automatic}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "Rows" -> {
                    Offset[0.2], {
                    Offset[0.8]}, 
                    Offset[0.2]}}], "DialogStyle",
                StripOnInput->False],
               DynamicModuleValues:>{}]}
            },
            DefaultBaseStyle->"Column",
            GridBoxAlignment->{"Columns" -> {{Left}}},
            GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "Rows" -> {
                Offset[0.2], {
                 Offset[3.6]}, 
                Offset[0.2]}}],
           FrameMargins->{{6, 6}, {6, 3}}], ""},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpener"]], True->
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "UpPointerOpenerHot"]]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, False],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], False->
      TagBox[GridBox[{
         {
          ItemBox[
           PaneBox[
            StyleBox["\<\" Symbol\"\>", "InformationTitleText",
             StripOnInput->False],
            FrameMargins->{{4, 0}, {-1, 1}}],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           PaneBox[
            
            StyleBox["\<\"OffsetPoints[{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"\
lbl\\\",\\nFontSlant->\\\"Italic\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"lbl\\\",\\nFontSlant->\\\"\
Italic\\\"], \
\\(2\\)]\\)},\\!\\(\\*\\nStyleBox[\\\"gap\\\",\\nFontSlant->\\\"Italic\\\"]\\)\
\\!\\(\\*\\nStyleBox[\\\" \
\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"fraction\\\",\\\
nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\nStyleBox[\\\"offset\\\",\\\
nFontSlant->\\\"Italic\\\"]\\),\\!\\(\\*\\nStyleBox[\\\"opts\\\",\\nFontSlant-\
>\\\"Italic\\\"]\\)] is a circuit element for DrawCircuit. All \
\\!\\(\\*\\nStyleBox[\\\"options\\\",\\nFontSlant->\\\"Italic\\\"]\\) are \
found in Options[DrawCircuit].\"\>", "InformationUsageText",
             StripOnInput->False,
             LineSpacing->{1.5, 1.5, 3.}],
            FrameMargins->{{10, 10}, {8, 10}}],
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False], 
          ItemBox["\<\"\"\>",
           BaseStyle->"InformationUsageSubtitleBackground",
           StripOnInput->False]},
         {
          ItemBox[
           TagBox[
            ButtonBox[
             PaneSelectorBox[{False->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpener"],
               ImageSizeCache->{13., {2., 11.}}], True->
              
              DynamicBox[FEPrivate`FrontEndResource[
               "FEBitmaps", "DownPointerOpenerHot"],
               ImageSizeCache->{13., {2., 11.}}]}, Dynamic[
              System`InformationDump`mouseOver$$]],
             Alignment->Left,
             Appearance->{"Default" -> None},
             
             ButtonFunction:>FEPrivate`Set[
              System`InformationDump`open$$, True],
             Evaluator->Automatic,
             FrameMargins->{{9, 0}, {0, 0}},
             ImageMargins->0,
             ImageSize->Full,
             Method->"Preemptive"],
            
            EventHandlerTag[{
             "MouseEntered" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, True], 
              "MouseExited" :> 
              FEPrivate`Set[System`InformationDump`mouseOver$$, False], 
              Method -> "Preemptive", PassEventsDown -> Automatic, 
              PassEventsUp -> True}]],
           BaseStyle->"InformationTitleBackground",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        FrameStyle->Directive[
          GrayLevel[0.8], 
          Thickness[Tiny]],
        GridBoxAlignment->{"Columns" -> {Left, Right}, "Rows" -> {{Center}}},
        GridBoxDividers->{
         "Columns" -> {{None}}, "Rows" -> {False, {True}, False}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"]}, Dynamic[System`InformationDump`open$$],
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     DynamicModuleValues:>{}],
    BaseStyle->"InformationGridFrame",
    StripOnInput->False], "InformationGridPlain",
   StripOnInput->False],
  InformationData[<|
   "ObjectType" -> "Symbol", "Usage" -> 
    "OffsetPoints[{\!\(\*SubscriptBox[\nStyleBox[\"lbl\",\n\
FontSlant->\"Italic\"], \(1\)]\),\!\(\*SubscriptBox[\nStyleBox[\"lbl\",\n\
FontSlant->\"Italic\"], \(2\)]\)},\!\(\*\nStyleBox[\"gap\",\n\
FontSlant->\"Italic\"]\)\!\(\*\nStyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\
\*\nStyleBox[\"fraction\",\nFontSlant->\"Italic\"]\),\!\(\*\n\
StyleBox[\"offset\",\nFontSlant->\"Italic\"]\),\!\(\*\nStyleBox[\"opts\",\n\
FontSlant->\"Italic\"]\)] is a circuit element for DrawCircuit. All \!\(\*\n\
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) are found in \
Options[DrawCircuit].", "Documentation" -> None, "OwnValues" -> None, 
    "UpValues" -> None, "DownValues" -> None, "SubValues" -> None, 
    "DefaultValues" -> None, "NValues" -> None, "FormatValues" -> None, 
    "Options" -> None, "Attributes" -> {}, "FullName" -> 
    "Circuit`OffsetPoints"|>, False]]], "Output",
 CellChangeTimes->{3.880665126238575*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"04c55bef-7305-46f0-a1f1-16a56e69766e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "=", ".5"}], ",", 
     RowBox[{"colV", "=", 
      RowBox[{"RGBColor", "[", 
       RowBox[{".3", ",", ".3", ",", ".9"}], "]"}]}], ",", 
     RowBox[{"colA", "=", 
      RowBox[{"RGBColor", "[", 
       RowBox[{".9", ",", ".1", ",", ".1"}], "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"DrawCircuit", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "a"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", 
            RowBox[{"-", "a"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", 
            RowBox[{"-", "a"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", 
            RowBox[{"-", "a"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"7", ",", "8"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"ACVoltage", "[", 
              RowBox[{
              "\"\<\!\(\*SubscriptBox[\(V\), \(rms\)]\), \
\!\(\*StyleBox[\"f\",FontSlant->\"Italic\"]\)\>\"", ",", 
               RowBox[{"TextOffset", "\[Rule]", "1.25"}]}], "]"}], "}"}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "7"}], "}"}], ",", 
            RowBox[{"{", "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "8"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"InlineMeter", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<A\>\"", ",", "14", ",", "Italic", ",", "colA"}], 
                "]"}], ",", 
               RowBox[{"InlineMeterDirectives", "\[Rule]", "colA"}]}], "]"}], 
             "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "6"}], "}"}], ",", 
            RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Resistor", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<R\>\"", ",", "Italic"}], "]"}], ",", 
               RowBox[{"TextOffset", "\[Rule]", 
                RowBox[{"-", "1"}]}]}], "]"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "5"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Inductor", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<L\>\"", ",", "Italic"}], "]"}], ",", 
               RowBox[{"TextOffset", "\[Rule]", 
                RowBox[{"-", "1"}]}]}], "]"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"5", ",", "6"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Capacitor", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<C\>\"", ",", "Italic"}], "]"}], ",", 
               RowBox[{"TextOffset", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"-", "1.625"}]}], "}"}]}]}], "]"}], "}"}]}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"OffsetPoints", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"3", ",", "5"}], "}"}], ",", ".125", ",", ".625", ",", 
              RowBox[{"WireDirectives", "\[Rule]", "colV"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"InlineMeter", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(V\), \(R, L\)]\)\>\"", ",", "14", 
                 ",", "colV"}], "]"}], ",", 
               RowBox[{"InlineMeterDirectives", "\[Rule]", "colV"}]}], "]"}], 
             "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"OffsetPoints", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"5", ",", "6"}], "}"}], ",", ".265", ",", ".625", ",", 
              RowBox[{"WireDirectives", "\[Rule]", "colV"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"InlineMeter", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<\!\(\*SubscriptBox[\(V\), \(C\)]\)\>\"", ",", "14", ",", 
                 "colV"}], "]"}], ",", 
               RowBox[{"InlineMeterDirectives", "\[Rule]", "colV"}]}], "]"}], 
             "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"OffsetPoints", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"3", ",", "6"}], "}"}], ",", ".1", ",", "1.125", ",", 
              RowBox[{"WireDirectives", "\[Rule]", "colV"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"InlineMeter", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"\"\<V\>\"", ",", "14", ",", "Italic", ",", "colV"}], 
                "]"}], ",", 
               RowBox[{"InlineMeterDirectives", "\[Rule]", "colV"}]}], "]"}], 
             "}"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"BaseStyle", "->", 
      RowBox[{"{", 
       RowBox[{"12", ",", 
        RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.511796068493849*^9, 3.511796258654201*^9}, {
   3.511796305677184*^9, 3.5117964387876673`*^9}, {3.5117964800383577`*^9, 
   3.511796527649713*^9}, {3.5117965790376787`*^9, 3.51179683877608*^9}, {
   3.511796881251976*^9, 3.511796882552474*^9}, {3.5117969277665977`*^9, 
   3.511796928237571*^9}, 3.5121424129571733`*^9, {3.512142465232909*^9, 
   3.512142593402792*^9}, {3.512142670648385*^9, 3.512142672784235*^9}, {
   3.512142754249365*^9, 3.512142805123764*^9}, {3.512143086601912*^9, 
   3.512143095073517*^9}, {3.512143169535138*^9, 3.512143270267675*^9}, {
   3.512143390200522*^9, 3.512143529578224*^9}, {3.512143803025765*^9, 
   3.512143824064967*^9}, {3.512143869647544*^9, 3.51214387193626*^9}, {
   3.512143934724909*^9, 3.51214398880409*^9}, {3.512144021348695*^9, 
   3.512144046048148*^9}, {3.512144077567293*^9, 3.512144084375153*^9}, {
   3.512144119935651*^9, 3.512144123373465*^9}, {3.5121441540297823`*^9, 
   3.512144172260829*^9}, {3.512147135286079*^9, 3.512147162946419*^9}, {
   3.512147197011322*^9, 3.5121472626472273`*^9}, {3.5121472927603617`*^9, 
   3.512147506198742*^9}, {3.512147541210927*^9, 3.512147639836637*^9}, {
   3.512147676161377*^9, 3.512147690286345*^9}, {3.512147739237874*^9, 
   3.512147746299119*^9}, {3.512147795600771*^9, 3.512147806549548*^9}, {
   3.5121478369276333`*^9, 3.512147899437608*^9}, 3.51214803503798*^9, {
   3.512148067213686*^9, 3.512148089263197*^9}, 3.51214812939001*^9, {
   3.51215539789008*^9, 3.512155435025278*^9}, {3.512157340515853*^9, 
   3.512157386575614*^9}, {3.623801109427938*^9, 3.6238011161047297`*^9}, {
   3.623801751030306*^9, 3.623801775597348*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"7f0a4f11-37de-405e-bc15-00ac53403a35"],

Cell[BoxData[
 GraphicsBox[{{}, {{{LineBox[{{1., -0.5}, {1.3825, -0.5}}], 
      LineBox[{{1.6175, -0.5}, {2., -0.5}}], {
       {AbsoluteThickness[2], CircleBox[{1.5, -0.5}, 0.11749999999999994], 
        LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQfbJs33yp9d/s/4PB/f3S8+I0T1/4Zm/vPim14c69
/XlH/22q/vTN/pLDkYrOq3f3H3gzz0ZH5Lv9PoUL926w3N0vJGJ/7I7pd/ud
nUZad+ru7E+1vu/fG/7dnmFz9acNAXf2b0+qv2lbiZDn7JJPfjfru/1+qP7o
jfvfzNvz3f4y1Px1N+LL/O99t3eA2s8ABj/sIfSD/UHqCzo3KP6wT7xjdnb/
xAf7l/o5CCc6/7Cffn+us7Xow/3fSx/MEUz9Yb/w/fQJk2sf7vec26B2qO2H
vcruZ68mHni4f84RhQ1FK37Yg0SXX3+4/93rA5bKp37YK0PlgaYdvvwaoX+S
FaNvC+9PuPlPExdeM9H/aZ8Atd+80zHhacBPePgBAC1uwUQ=
         "]]}, 
       InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(rms\\)]\\), \
\\!\\(\\*StyleBox[\\\"f\\\",FontSlant->\\\"Italic\\\"]\\)\"\>", \
{1.5, -0.30906250000000013}]}}, 
     LineBox[{{0., -0.5}, {1., -0.5}}], {
      LineBox[{{3., -0.5}, {2.6174999999999997`, -0.5}}], 
      LineBox[{{2.3825000000000003`, -0.5}, {2., -0.5}}], {
       {RGBColor[0.9, 0.1, 0.1], AbsoluteThickness[2], 
        CircleBox[{2.5, -0.5}, 0.11749999999999972]}, InsetBox[
        StyleBox["\<\"A\"\>",
         StripOnInput->False,
         LineColor->RGBColor[0.9, 0.1, 0.1],
         FrontFaceColor->RGBColor[0.9, 0.1, 0.1],
         BackFaceColor->RGBColor[0.9, 0.1, 0.1],
         GraphicsColor->RGBColor[0.9, 0.1, 0.1],
         FontSize->14,
         FontSlant->Italic,
         FontColor->RGBColor[0.9, 0.1, 0.1]], {2.5, -0.5}]}}, 
     LineBox[{{0., -0.5}, {0., 0.}}], 
     LineBox[{{3., -0.5}, {3., 0.}}], {
      LineBox[{{0., 0.}, {0.3237500000000001, 0.}}], 
      LineBox[{{0.6762499999999999, 0.}, {1., 0.}}], 
      {AbsoluteThickness[2], 
       LineBox[{{0.3237500000000001, 0.}, {0.3531250000000001, 
        0.02937499999999998}, {0.41187500000000005`, -0.02937499999999998}, {
        0.470625, 0.02937499999999998}, {
        0.5293749999999999, -0.02937499999999998}, {0.5881249999999999, 
        0.02937499999999998}, {0.6468749999999999, -0.02937499999999998}, {
        0.6762499999999999, 0.}}], InsetBox[
        StyleBox["\<\"R\"\>",
         StripOnInput->False,
         FontSlant->Italic], {0.5, -0.11749999999999992}]}}, {
      LineBox[{{1., 0.}, {1.3077272727272728`, 0.}}], 
      LineBox[{{1.692272727272727, 0.}, {1.9999999999999998`, 0.}}], 
      {AbsoluteThickness[2], LineBox[CompressedData["
1:eJxdkntIU3Ecxa/aVKzMJU1slk5LKh9JlslEf6UGplEqOM1ISxI1KCPBtpLZ
MGeGkQUtMcoHrVzhI3K91H4WDrMCnz2M+SgfqJSaud2Hj5WU3x/swuX+cTjn
fL6HK0rJjE21pCgq7u+79P0Z0Ho668csov4/E65Td0yUAX3Z8SJrTK1EW/uC
KL7IgPpu8pIOD95Ep8I1xdlRBlSmujIjmL6L5I+HnaLkBjTLb81YOVOJcmuS
ggXPDIhX4q/KF6nRb9n2Mnpm2a9Gafsoi15fI+jpoec976UZwS+r1VZLS42Q
3yTwCOlvMUL/fHdm+dSwEfjYxlvtF1gj8DsrQ9+st6SXdUyff6vYaQI/7tD5
OHK/IB/r7XTV0Xroxyze8LCuGfhw5X3Xk1zFsl+No66KtoXnEd2MH2cV8F9z
MST/QFd2bHM46fdqned/3Qv8OKr4wQpZJOGPkLX785LJfQUBLipBLrn//Z1C
zxwN2ceMH+ltULdwHQ37xnSv2bUQTcP+uruDqv4ioutuJzZqdDT4P9uqwuQM
DfnCM1Y9Q+4M9Cf6RAcYQhngSxBIUxXxDPCfG3BPcDsGOo7rqXISHwU/9nW1
15gOMbCP+IQ6TCJmYD+J8yJ6upGBff+lMrC/ZtSief834Mdm/Lhz8JeEqgN+
/MgrfkxXSUP/Zbe+BwNl5P+oGi8olVfRwK/uqm2zawIdjVyb93LpAz/aQmc0
KmyAH5nxI/Fx1wxRFvCjGu/pd5a1wI88mGbv4QmibzKIY2s9WPDvSsnuzZOw
kC9tG8oYv8hC/3Ol3weunAU+bWbCnFLLAn9PoNXk5leg4yc+hdWoAfy4SDoZ
wquBfFzSlN97pAT6sfZs/8eGHBb2XTLxkljY33rP97hDiOhm/NhX3PWDZ0/y
bfN3y99TpH9U1hQ8skD+D+uwdL9L1oTfyrs42UFI7gsb178WBZH7ldGRsQWp
ZB8zflTy0rTo2Ql8aJWy45jtag72V8RUvBmP4EBXHBSO1Ss48N9okGQW1nOQ
/8m9xTTZz0G/YNAhhTJxwLe2LfB6keMc8P8BtYqoeA==
        "]], InsetBox[
        StyleBox["\<\"L\"\>",
         StripOnInput->False,
         FontSlant->Italic], {1.5, -0.11749999999999992}]}}, {
      LineBox[{{2., 0.}, {2.470625, 0.}}], 
      LineBox[{{2.529375, 0.}, {3., 0.}}], 
      {AbsoluteThickness[2], 
       LineBox[{{2.470625, 0.11749999999999992`}, {
        2.470625, -0.11749999999999992`}}], 
       LineBox[{{2.529375, 0.11749999999999992`}, {
        2.529375, -0.11749999999999992`}}], InsetBox[
        StyleBox["\<\"C\"\>",
         StripOnInput->False,
         FontSlant->Italic], {2.5, -0.19093749999999987}]}}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{0., 0.}, {0.25, 0.2937499999999998}}]}, {
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{0.25, 0.2937499999999998}, {0.8825000000000001, 
        0.2937499999999998}}]}, 
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{1.1175, 0.2937499999999998}, {1.75, 0.2937499999999998}}]}, {
       {RGBColor[0.3, 0.3, 0.9], AbsoluteThickness[2], 
        CircleBox[{1., 0.2937499999999998}, 0.11749999999999994]}, InsetBox[
        StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(R, L\\)]\\)\"\>",
         StripOnInput->False,
         LineColor->RGBColor[0.3, 0.3, 0.9],
         FrontFaceColor->RGBColor[0.3, 0.3, 0.9],
         BackFaceColor->RGBColor[0.3, 0.3, 0.9],
         GraphicsColor->RGBColor[0.3, 0.3, 0.9],
         FontSize->14,
         FontColor->RGBColor[0.3, 0.3, 0.9]], {1., 0.2937499999999998}]}}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{1.75, 0.2937499999999998}, {2., 0.}}]}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{2., 0.}, {2.265, 0.2937499999999998}}]}, {
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{2.265, 0.2937499999999998}, {2.3825000000000003`, 
        0.2937499999999998}}]}, 
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{2.6174999999999997`, 0.2937499999999998}, {2.735, 
        0.2937499999999998}}]}, {
       {RGBColor[0.3, 0.3, 0.9], AbsoluteThickness[2], 
        CircleBox[{2.5, 0.2937499999999998}, 0.11750000000000016]}, InsetBox[
        StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(C\\)]\\)\"\>",
         StripOnInput->False,
         LineColor->RGBColor[0.3, 0.3, 0.9],
         FrontFaceColor->RGBColor[0.3, 0.3, 0.9],
         BackFaceColor->RGBColor[0.3, 0.3, 0.9],
         GraphicsColor->RGBColor[0.3, 0.3, 0.9],
         FontSize->14,
         FontColor->RGBColor[0.3, 0.3, 0.9]], {2.5, 0.2937499999999998}]}}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{2.735, 0.2937499999999998}, {3., 0.}}]}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{0., 0.}, {0.30000000000000004`, 0.5287499999999996}}]}, {
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{0.30000000000000004`, 0.5287499999999996}, {
        1.3825000000000003`, 0.5287499999999996}}]}, 
      {RGBColor[0.3, 0.3, 0.9], 
       LineBox[{{1.6175000000000002`, 0.5287499999999996}, {2.7, 
        0.5287499999999996}}]}, {
       {RGBColor[0.3, 0.3, 0.9], AbsoluteThickness[2], 
        CircleBox[{1.5000000000000002, 0.5287499999999996}, 
         0.11749999999999994]}, InsetBox[
        StyleBox["\<\"V\"\>",
         StripOnInput->False,
         LineColor->RGBColor[0.3, 0.3, 0.9],
         FrontFaceColor->RGBColor[0.3, 0.3, 0.9],
         BackFaceColor->RGBColor[0.3, 0.3, 0.9],
         GraphicsColor->RGBColor[0.3, 0.3, 0.9],
         FontSize->14,
         FontSlant->Italic,
         FontColor->RGBColor[
          0.3, 0.3, 0.9]], {1.5000000000000002, 0.5287499999999996}]}}, 
     {RGBColor[0.3, 0.3, 0.9], 
      LineBox[{{2.7, 0.5287499999999996}, {3., 0.}}]}}, {}}, {}},
  BaseStyle->{12, FontFamily -> "Times"},
  ImageSize->{384.93437499999936`, Automatic}]], "Output",
 CellChangeTimes->{
  3.512169685778267*^9, 3.512169763175117*^9, {3.512171542134265*^9, 
   3.5121715613171587`*^9}, 3.512172294100864*^9, 3.5595214672183657`*^9, 
   3.559521502895323*^9, 3.6238011181530437`*^9, 3.623801383296118*^9, {
   3.6238017655021667`*^9, 3.623801776698118*^9}, 3.88066514781819*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"945d9413-095d-4005-bfbf-408b2c2c4ae9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "=", ".35"}], ",", 
     RowBox[{"b", "=", ".5"}], ",", 
     RowBox[{"c", "=", ".5"}], ",", 
     RowBox[{"d", "=", ".75"}], ",", 
     RowBox[{"e", "=", ".25"}], ",", 
     RowBox[{"f", "=", ".1"}], ",", 
     RowBox[{"g", "=", ".15"}], ",", 
     RowBox[{"col1", "=", 
      RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
     RowBox[{"col2", "=", 
      RowBox[{"Darker", "[", 
       RowBox[{"Red", ",", ".2"}], "]"}]}], ",", 
     RowBox[{"col3", "=", 
      RowBox[{"Darker", "[", 
       RowBox[{"Blue", ",", ".3"}], "]"}]}], ",", 
     RowBox[{"col4", "=", 
      RowBox[{"Darker", "[", 
       RowBox[{"Orange", ",", ".3"}], "]"}]}], ",", 
     RowBox[{"xDiag", "=", 
      RowBox[{
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "=", ".03"}], ",", 
           RowBox[{"y", "=", ".02"}]}], "}"}], ",", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"#", "+", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "x"}], ",", 
                 RowBox[{"-", "y"}]}], "}"}]}], ",", 
              RowBox[{"#", "+", 
               RowBox[{"{", 
                RowBox[{"x", ",", "y"}], "}"}]}]}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"#", "+", 
               RowBox[{"{", 
                RowBox[{"x", ",", 
                 RowBox[{"-", "y"}]}], "}"}]}], ",", 
              RowBox[{"#", "+", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "x"}], ",", "y"}], "}"}]}]}], "}"}], "]"}]}], 
          "}"}]}], "]"}], "&"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"DrawCircuit", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"7", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "+", "b"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"8", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "+", "b"}], ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"9", ",", 
             RowBox[{"{", 
              RowBox[{"c", ",", "0"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"10", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "c"}], ",", "0"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"11", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "+", "b"}], ",", 
               RowBox[{"-", "d"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"12", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "+", "b"}], ",", "d"}], "}"}]}], "}"}]}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"12", ",", "11"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"ACVoltage", "[", 
               RowBox[{"\"\<\!\(\*SubscriptBox[\(V\), \(rms\)]\)\>\"", ",", 
                RowBox[{"ACVoltageRadius", "\[Rule]", "R"}], ",", 
                RowBox[{"TextOffset", "\[Rule]", 
                 RowBox[{"-", "2.25"}]}]}], "]"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"7", ",", "11"}], "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"12", ",", "8"}], "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"7", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}], ",", 
                 RowBox[{"CurrentArrowFlipped", "\[Rule]", "True"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "8"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}], ",", 
                 RowBox[{"CurrentArrowFlipped", "\[Rule]", "True"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "4"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}], ",", 
               RowBox[{"Diode", "[", "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}]}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2", ",", "4"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Wire", "[", "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}], ",", 
               RowBox[{"Diode", "[", "]"}], ",", 
               RowBox[{"Wire", "[", "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"3", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}], ",", 
               RowBox[{"Diode", "[", "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}]}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"3", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}], ",", 
               RowBox[{"Diode", "[", "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}], ",", 
               RowBox[{"Wire", "[", "]"}]}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"4", ",", "9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"9", ",", "10"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"Resistor", "[", 
               RowBox[{"\"\<Load Resistance\>\"", ",", 
                RowBox[{"ResistorTurnNumber", "\[Rule]", "14"}], ",", 
                RowBox[{"TextOffset", "\[Rule]", 
                 RowBox[{"-", "1"}]}]}], "]"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"10", ",", "3"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col1"}]}], 
                "]"}], ",", 
               RowBox[{"CurrentArrow", "[", 
                RowBox[{"\"\<\>\"", ",", 
                 RowBox[{"CurrentArrowDirectives", "\[Rule]", "col2"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OffsetPoints", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"9", ",", "10"}], "}"}], ",", ".15", ",", ".875", ",", 
               RowBox[{"WireDirectives", "\[Rule]", "col3"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"InlineMeter", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<\!\(\*SubscriptBox[\(V\), \(L\)]\)\>\"", ",", "14", ",",
                   "col3"}], "]"}], ",", 
                RowBox[{"InlineMeterRadius", "\[Rule]", "R"}], ",", 
                RowBox[{"InlineMeterDirectives", "\[Rule]", "col3"}]}], "]"}],
               "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"OffsetPoints", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"11", ",", "12"}], "}"}], ",", ".15", ",", 
               RowBox[{"-", "1.25"}], ",", 
               RowBox[{"WireDirectives", "\[Rule]", "col4"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"InlineMeter", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                 "\"\<\!\(\*SubscriptBox[\(V\), \(S\)]\)\>\"", ",", "14", ",",
                   "col4"}], "]"}], ",", 
                RowBox[{"InlineMeterRadius", "\[Rule]", "R"}], ",", 
                RowBox[{"InlineMeterDirectives", "\[Rule]", "col4"}]}], "]"}],
               "}"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BaseElementDirectives", "\[Rule]", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
         RowBox[{"CurrentArrowScale", "\[Rule]", "1.5"}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"col1", ",", 
               RowBox[{"Text", "[", 
                RowBox[{"\"\<+\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "+", "b", "+", "f"}], ",", 
                   RowBox[{"-", "e"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{"\"\<-\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "+", "b", "+", "f"}], ",", "e"}], "}"}]}], 
                "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"col2", ",", 
               RowBox[{"Text", "[", 
                RowBox[{"\"\<-\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "+", "b", "-", "f"}], ",", 
                   RowBox[{"-", "e"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Text", "[", 
                RowBox[{"\"\<+\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "+", "b", "-", "f"}], ",", "e"}], "}"}]}], 
                "]"}]}], "}"}]}], "}"}], ",", "14", ",", "Bold"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"col1", ",", 
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"xDiag", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "g"}], ",", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", "g"}]}], "}"}], "]"}], ",", 
             RowBox[{"\[Pi]", "/", "4"}]}], "]"}], ",", 
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"xDiag", "[", 
              RowBox[{"{", 
               RowBox[{"g", ",", 
                RowBox[{"1", "-", "g"}]}], "}"}], "]"}], ",", 
             RowBox[{"\[Pi]", "/", "4"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"col2", ",", 
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"xDiag", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "-", "g"}], ",", 
                RowBox[{"-", "g"}]}], "}"}], "]"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Pi]"}], "/", "4"}]}], "]"}], ",", 
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"xDiag", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "g"}], ",", 
                RowBox[{"1", "-", "g"}]}], "}"}], "]"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Pi]"}], "/", "4"}]}], "]"}]}], "}"}]}], "}"}]}],
       "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"12", ",", 
        RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.501455800126884*^9, 3.501455934351892*^9}, {
   3.501455967001689*^9, 3.501456057852016*^9}, {3.501456092078274*^9, 
   3.5014562005936823`*^9}, {3.501456261604765*^9, 3.50145628210623*^9}, {
   3.5014565596686697`*^9, 3.5014565990806303`*^9}, 3.501456668593566*^9, {
   3.501456699295576*^9, 3.5014568005676517`*^9}, {3.501456852342991*^9, 
   3.501457025184317*^9}, {3.5014570909226427`*^9, 3.501457093037841*^9}, {
   3.501457165558546*^9, 3.5014572109996853`*^9}, {3.5014573761136303`*^9, 
   3.5014573795975113`*^9}, {3.5014574116628637`*^9, 3.501457435665409*^9}, {
   3.5014579752531223`*^9, 3.501457997599842*^9}, {3.5014580595531273`*^9, 
   3.5014581216549*^9}, {3.501458588277985*^9, 3.501458668176735*^9}, {
   3.501462985219613*^9, 3.501463052620573*^9}, {3.501463209470989*^9, 
   3.501463283494524*^9}, 3.501463331685339*^9, {3.501463364422061*^9, 
   3.501463372745681*^9}, {3.501463404895712*^9, 3.501463845688402*^9}, {
   3.5014638792244463`*^9, 3.501463880310524*^9}, 3.5014639348880587`*^9, 
   3.501464252588252*^9, {3.501464448753503*^9, 3.501464603128459*^9}, {
   3.50146463871632*^9, 3.501464673739758*^9}, {3.501464773465218*^9, 
   3.501464795246337*^9}, {3.5014648295050707`*^9, 3.501464867527792*^9}, {
   3.501464958530431*^9, 3.501465160876548*^9}, {3.501465300993885*^9, 
   3.5014653161644163`*^9}, {3.501465572353591*^9, 3.5014656109418383`*^9}, {
   3.501466586570953*^9, 3.501466740779848*^9}, {3.501466815068907*^9, 
   3.5014668157185717`*^9}, {3.501466957959978*^9, 3.501466966645318*^9}, {
   3.501467100123405*^9, 3.501467150603011*^9}, {3.50146718481392*^9, 
   3.501467222511697*^9}, 3.5014672538622227`*^9, {3.501467323021945*^9, 
   3.5014673363978577`*^9}, {3.5014673787686567`*^9, 
   3.5014673803173733`*^9}, {3.5014674224996357`*^9, 3.501467435251746*^9}, {
   3.501467497725245*^9, 3.501467505002767*^9}, {3.501467710608551*^9, 
   3.501467724338711*^9}, {3.501467767193739*^9, 3.50146784816842*^9}, {
   3.501468569017363*^9, 3.501468633339931*^9}, {3.5014686634599667`*^9, 
   3.501468668657467*^9}, {3.501468736164506*^9, 3.501468794778945*^9}, {
   3.501468922347633*^9, 3.501468929335374*^9}, {3.5014689658079357`*^9, 
   3.5014689723083143`*^9}, 3.501469181322563*^9, {3.501469504639277*^9, 
   3.50146953980578*^9}, {3.501469665977847*^9, 3.501469707035687*^9}, {
   3.501469996245099*^9, 3.501470007390634*^9}, {3.5015009951779013`*^9, 
   3.501501013076084*^9}, {3.5015010572314873`*^9, 3.5015013626662407`*^9}, 
   3.501501404948608*^9, {3.501510212604677*^9, 3.501510534686717*^9}, {
   3.5015105678533278`*^9, 3.50151058630436*^9}, {3.501510616473302*^9, 
   3.501510635910365*^9}, {3.501515915745329*^9, 3.501515927967362*^9}, {
   3.501515991893092*^9, 3.501516001560598*^9}, 3.501516040683218*^9, {
   3.501516147520474*^9, 3.501516320558173*^9}, {3.501516357433091*^9, 
   3.501516365013363*^9}, {3.5015164091987543`*^9, 3.501516450107375*^9}, 
   3.501516489825592*^9, {3.501516525958124*^9, 3.50151661548668*^9}, {
   3.50151665088505*^9, 3.5015166536608753`*^9}, {3.501516685014677*^9, 
   3.501516730726861*^9}, {3.5015167615898323`*^9, 3.501516851851344*^9}, 
   3.5015170058708344`*^9, {3.501517048666018*^9, 3.5015170799633627`*^9}, {
   3.501517149781971*^9, 3.501517199876495*^9}, 3.501517230673376*^9, {
   3.501521191863102*^9, 3.501521473948238*^9}, {3.5015215157078*^9, 
   3.501521524656598*^9}, {3.50152156591101*^9, 3.50152163076053*^9}, {
   3.501521992636033*^9, 3.501522015382895*^9}, {3.5015220629427977`*^9, 
   3.501522160124763*^9}, {3.501530555077176*^9, 3.501530592435059*^9}, {
   3.501550794908553*^9, 3.501551041289551*^9}, {3.501551077199561*^9, 
   3.501551087077058*^9}, {3.501551627235957*^9, 3.501551668566638*^9}, {
   3.501551747189793*^9, 3.501551826025195*^9}, {3.501551866038575*^9, 
   3.501551868187696*^9}, {3.501551911284636*^9, 3.5015519338985662`*^9}, {
   3.501551977946059*^9, 3.5015519988810787`*^9}, {3.501552523163299*^9, 
   3.501552537205332*^9}, {3.501552662366192*^9, 3.501552822558292*^9}, {
   3.501552875667858*^9, 3.501552903941103*^9}, 3.5015532601970167`*^9, {
   3.501554032670596*^9, 3.501554058230803*^9}, {3.501554136674752*^9, 
   3.501554188088296*^9}, 3.501554263428441*^9, {3.501554387752193*^9, 
   3.5015545414120417`*^9}, {3.501554573135714*^9, 3.501554644710248*^9}, {
   3.501554688146098*^9, 3.5015546906787*^9}, {3.501554736435996*^9, 
   3.5015547457197104`*^9}, {3.501554781263516*^9, 3.501554798780013*^9}, {
   3.501554840731248*^9, 3.5015548688353157`*^9}, {3.5015553623001747`*^9, 
   3.501555386633589*^9}, {3.501555432948563*^9, 3.50155552470295*^9}, 
   3.5015557044187403`*^9, {3.501601874811491*^9, 3.5016018780811996`*^9}, {
   3.5016039711095037`*^9, 3.501603981568891*^9}, {3.501637571946257*^9, 
   3.501637605479301*^9}, {3.5016376393152122`*^9, 3.501637669354549*^9}, {
   3.501787124229434*^9, 3.501787129553833*^9}, {3.501787302800564*^9, 
   3.501787311613555*^9}, {3.512171639896558*^9, 3.5121716894130497`*^9}, 
   3.5121755084912853`*^9, {3.559608509188733*^9, 3.559608531346902*^9}, 
   3.559608607879446*^9, {3.559608664285307*^9, 3.5596087544730663`*^9}, {
   3.559608951901968*^9, 3.559608954604775*^9}, {3.559609009945033*^9, 
   3.559609104699037*^9}, {3.559609150803815*^9, 3.55960923872507*^9}, {
   3.559609273127079*^9, 3.559609298632012*^9}, {3.5596098861262074`*^9, 
   3.559609902974819*^9}, {3.5596099882129793`*^9, 3.559609991637535*^9}, {
   3.5596100233059797`*^9, 3.559610063657855*^9}, {3.559610326763619*^9, 
   3.55961039283348*^9}, {3.623019365274742*^9, 3.623019366790578*^9}, {
   3.623019397721787*^9, 3.623019401096326*^9}, {3.6230732001111526`*^9, 
   3.623073214759232*^9}, {3.623076388724504*^9, 3.623076410750784*^9}, {
   3.6230910526958017`*^9, 3.6230910567985086`*^9}, {3.6234627596701097`*^9, 
   3.6234627876467457`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"02c441d3-94e1-42a9-9c84-06f5b8a4d72f"],

Cell[BoxData[
 GraphicsBox[{{{}, {{{LineBox[{{1.5, 0.75}, {1.5, 0.15555555555555567`}}], 
       LineBox[{{1.5, -0.15555555555555534`}, {1.5, -0.7499999999999998}}], {
        {AbsoluteThickness[2], CircleBox[{1.5, 0.}, 0.15555555555555556], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQ/dagdOdfx2/2qZzHnK4+6bCxue/fOz3vm/3sE4aL
2uVm2Hf1aiUazv5mr+6YtSr4wzL7m9aspqePf7Pfq3a0YcKk9fYar+5zpH75
Zs/D+eT1+b5N9mUzdt35p/DdvtBpzXqf5s32R92mbpjh+92eGyov8jW/xajq
u/0OqP7kxV4RZ5Z9t1eBmr8xUFUn7fJ3+y6o/Qxg8ANKMzD4r7t1eabOD/tJ
EPn982K2LjeO/AFz3/43XBOqz7b+sN8DMX+/9c4s//RNP2D27+9Kd1VmvP8D
5r79N0QVvs/i/glz/371I79OmVj8tN8J1V9WdHXeuZSf9kpQ848obCjKmPgT
Fj77hc93uTHt+wkLvz0ARcmqYQ==
          "]]}, 
        InsetBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(rms\\)]\\)\"\>", \
{1.2194444444444446, 0.}]}}, LineBox[{{1.5, -1.}, {1.5, -0.75}}], 
      LineBox[{{1.5, 0.75}, {1.5, 1.}}], {LineBox[{{1.5, -1.}, {1., -1.}}], 
       LineBox[{{1., -1.}, {0.5, -1.}}], LineBox[{{0.5, -1.}, {0., -1.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{1.0416666666666667`, -1.0416666666666667`}, {
         0.9583333333333334, -1.}, {
         1.0416666666666667`, -0.9583333333333334}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{0.4583333333333335, -1.0416666666666667`}, {
         0.5416666666666667, -1.}, {
         0.4583333333333335, -0.9583333333333334}}]}}, {
       LineBox[{{0., 1.}, {0.5, 1.}}], LineBox[{{0.5, 1.}, {1., 1.}}], 
       LineBox[{{1., 1.}, {1.5, 1.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{0.4583333333333333, 1.0416666666666667`}, {
         0.5416666666666666, 1.}, {0.4583333333333333, 0.9583333333333334}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{1.0416666666666665`, 1.0416666666666667`}, {
         0.9583333333333333, 1.}, {1.0416666666666665`, 
         0.9583333333333334}}]}}, {
       LineBox[{{0., -1.}, {0.15179072483520176`, -0.8482092751647983}}], 
       LineBox[{{0.15179072483520176`, -0.8482092751647983}, {
        0.4607162899340807, -0.5392837100659194}}], 
       LineBox[{{0.5392837100659194, -0.46071628993408065`}, {
        0.6910744349011211, -0.3089255650988789}}], 
       LineBox[{{0.6910744349011211, -0.3089255650988789}, {1., 0.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{0.09286515973632278, -0.8482092751647983}, {
         0.18125350738464124`, -0.8187464926153587}, {
         0.15179072483520176`, -0.9071348402636772}}]}, 
       {AbsoluteThickness[2], 
        {AbsoluteThickness[2], 
         LineBox[{{0.4939227889032679, -0.4153553687714292}, {
          0.5846446312285708, -0.5060772110967321}}]}, 
        LineBox[{{0.5392837100659194, -0.46071628993408065`}, {
         0.41535536877142926`, -0.4939227889032678}, {
         0.5060772110967322, -0.5846446312285707}, {
         0.5392837100659194, -0.46071628993408065`}}]}, 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{0.6321488698022422, -0.3089255650988789}, {
         0.7205372174505605, -0.27946278254943946`}, {
         0.6910744349011211, -0.36785113019775784`}}]}}, {
       LineBox[{{0., 1.}, {0.308925565098879, 0.6910744349011211}}], 
       LineBox[{{0.308925565098879, 0.6910744349011211}, {0.4607162899340807, 
        0.5392837100659194}}], 
       LineBox[{{0.5392837100659194, 0.46071628993408065`}, {
        0.8482092751647983, 0.15179072483520173`}}], 
       LineBox[{{0.8482092751647983, 0.15179072483520173`}, {1., 0.}}], 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{0.308925565098879, 0.75}, {0.3383883476483185, 
         0.6616116523516815}, {0.25000000000000006`, 0.6910744349011211}}]}, 
       {AbsoluteThickness[2], 
        {AbsoluteThickness[2], 
         LineBox[{{0.5846446312285708, 0.5060772110967321}, {
          0.4939227889032679, 0.4153553687714292}}]}, 
        LineBox[{{0.5392837100659194, 0.46071628993408065`}, {
         0.5060772110967322, 0.5846446312285707}, {0.41535536877142926`, 
         0.4939227889032678}, {0.5392837100659194, 0.46071628993408065`}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{0.8482092751647983, 0.21071628993408065`}, {
         0.8776720577142377, 0.12232794228576227`}, {0.7892837100659194, 
         0.15179072483520173`}}]}}, {
       LineBox[{{-1., 0.}, {-0.8482092751647983, 0.15179072483520176`}}], 
       LineBox[{{-0.8482092751647983, 
        0.15179072483520176`}, {-0.5392837100659194, 0.4607162899340807}}], 
       LineBox[{{-0.46071628993408065`, 
        0.5392837100659194}, {-0.3089255650988789, 0.6910744349011211}}], 
       LineBox[{{-0.3089255650988789, 0.6910744349011211}, {0., 1.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{-0.9071348402636772, 
         0.15179072483520176`}, {-0.8187464926153587, 
         0.18125350738464124`}, {-0.8482092751647983, 0.09286515973632278}}]}, 
       {AbsoluteThickness[2], 
        {AbsoluteThickness[2], 
         LineBox[{{-0.5060772110967321, 
          0.5846446312285708}, {-0.4153553687714292, 0.4939227889032679}}]}, 
        LineBox[{{-0.46071628993408065`, 
         0.5392837100659194}, {-0.5846446312285707, 
         0.5060772110967322}, {-0.4939227889032678, 
         0.41535536877142926`}, {-0.46071628993408065`, 
         0.5392837100659194}}]}, 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{-0.36785113019775784`, 
         0.6910744349011211}, {-0.27946278254943946`, 
         0.7205372174505605}, {-0.3089255650988789, 0.6321488698022422}}]}}, {
       LineBox[{{-1., 0.}, {-0.8482092751647983, -0.15179072483520176`}}], 
       LineBox[{{-0.8482092751647983, -0.15179072483520176`}, \
{-0.5392837100659194, -0.4607162899340807}}], 
       LineBox[{{-0.46071628993408065`, -0.5392837100659194}, \
{-0.3089255650988789, -0.6910744349011211}}], 
       LineBox[{{-0.3089255650988789, -0.6910744349011211}, {0., -1.}}], 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{-0.8482092751647983, -0.09286515973632278}, \
{-0.8187464926153587, -0.18125350738464124`}, {-0.9071348402636772, \
-0.15179072483520176`}}]}, 
       {AbsoluteThickness[2], 
        {AbsoluteThickness[2], 
         LineBox[{{-0.4153553687714292, -0.4939227889032679}, \
{-0.5060772110967321, -0.5846446312285708}}]}, 
        LineBox[{{-0.46071628993408065`, -0.5392837100659194}, \
{-0.4939227889032678, -0.41535536877142926`}, {-0.5846446312285707, \
-0.5060772110967322}, {-0.46071628993408065`, -0.5392837100659194}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{-0.3089255650988789, -0.6321488698022422}, \
{-0.27946278254943946`, -0.7205372174505605}, {-0.36785113019775784`, \
-0.6910744349011211}}]}}, {LineBox[{{1., 0.}, {0.8333333333333334, 0.}}], 
       LineBox[{{0.8333333333333334, 0.}, {0.6666666666666667, 0.}}], 
       LineBox[{{0.6666666666666667, 0.}, {0.5, 0.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{0.875, -0.041666666666666664`}, {0.7916666666666667, 0.}, {
         0.875, 0.041666666666666664`}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{0.7083333333333334, -0.041666666666666664`}, {0.625, 0.}, {
         0.7083333333333334, 0.041666666666666664`}}]}}, {
       LineBox[{{0.5, 0.}, {0.3888888888888889, 0.}}], 
       LineBox[{{-0.38888888888888884`, 0.}, {-0.5, 0.}}], 
       {AbsoluteThickness[2], 
        LineBox[{{0.3888888888888889, 0.}, {
         0.3611111111111111, -0.027777777777777776`}, {0.3055555555555556, 
         0.027777777777777776`}, {0.25, -0.027777777777777776`}, {
         0.19444444444444448`, 0.027777777777777776`}, {
         0.1388888888888889, -0.027777777777777776`}, {0.08333333333333337, 
         0.027777777777777776`}, {
         0.02777777777777779, -0.027777777777777776`}, {-0.02777777777777779, 
         0.027777777777777776`}, {-0.08333333333333326, \
-0.027777777777777776`}, {-0.13888888888888884`, 
         0.027777777777777776`}, {-0.19444444444444442`, \
-0.027777777777777776`}, {-0.25, 
         0.027777777777777776`}, {-0.30555555555555547`, \
-0.027777777777777776`}, {-0.36111111111111105`, 
         0.027777777777777776`}, {-0.38888888888888884`, 0.}}], 
        InsetBox["\<\"Load Resistance\"\>", {0., 0.1111111111111111}]}}, {
       LineBox[{{-0.5, 0.}, {-0.6666666666666666, 0.}}], 
       LineBox[{{-0.6666666666666666, 0.}, {-0.8333333333333333, 0.}}], 
       LineBox[{{-0.8333333333333333, 0.}, {-1., 0.}}], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[2], 
        LineBox[{{-0.625, -0.041666666666666664`}, {-0.7083333333333333, 
         0.}, {-0.625, 0.041666666666666664`}}]}, 
       {RGBColor[0.8, 0., 0.], AbsoluteThickness[2], 
        LineBox[{{-0.7916666666666666, -0.041666666666666664`}, {-0.875, 
         0.}, {-0.7916666666666666, 0.041666666666666664`}}]}}, 
      {RGBColor[0., 0., 0.7], 
       LineBox[{{0.5, 0.}, {0.35, -0.38888888888888884`}}]}, {
       {RGBColor[0., 0., 0.7], 
        LineBox[{{0.35, -0.38888888888888884`}, {
         0.15555555555555556`, -0.38888888888888884`}}]}, 
       {RGBColor[0., 0., 0.7], 
        LineBox[{{-0.15555555555555545`, -0.38888888888888884`}, \
{-0.34999999999999987`, -0.38888888888888884`}}]}, {
        {RGBColor[0., 0., 0.7], AbsoluteThickness[2], 
         CircleBox[{5.551115123125783*^-17, -0.38888888888888884}, 
          0.15555555555555553]}, InsetBox[
         StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(L\\)]\\)\"\>",
          StripOnInput->False,
          LineColor->RGBColor[0., 0., 0.7],
          FrontFaceColor->RGBColor[0., 0., 0.7],
          BackFaceColor->RGBColor[0., 0., 0.7],
          GraphicsColor->RGBColor[0., 0., 0.7],
          FontSize->14,
          
          FontColor->RGBColor[
           0., 0., 0.7]], {5.551115123125783*^-17, -0.38888888888888884}]}}, 
      {RGBColor[0., 0., 0.7], 
       LineBox[{{-0.35, -0.38888888888888884`}, {-0.5, 0.}}]}, 
      {RGBColor[0.7, 0.35, 0.], 
       LineBox[{{1.5, -0.75}, {2.0555555555555554`, -0.525}}]}, {
       {RGBColor[0.7, 0.35, 0.], 
        LineBox[{{2.0555555555555554`, -0.525}, {
         2.0555555555555554`, -0.1555555555555555}}]}, 
       {RGBColor[0.7, 0.35, 0.], 
        LineBox[{{2.0555555555555554`, 0.15555555555555545`}, {
         2.0555555555555554`, 0.525}}]}, {
        {RGBColor[0.7, 0.35, 0.], AbsoluteThickness[2], 
         CircleBox[{2.0555555555555554, 0.}, 0.15555555555555556]}, InsetBox[
         StyleBox["\<\"\\!\\(\\*SubscriptBox[\\(V\\), \\(S\\)]\\)\"\>",
          StripOnInput->False,
          LineColor->RGBColor[0.7, 0.35, 0.],
          FrontFaceColor->RGBColor[0.7, 0.35, 0.],
          BackFaceColor->RGBColor[0.7, 0.35, 0.],
          GraphicsColor->RGBColor[0.7, 0.35, 0.],
          FontSize->14,
          FontColor->RGBColor[0.7, 0.35, 0.]], {2.0555555555555554, 0.}]}}, 
      {RGBColor[0.7, 0.35, 0.], 
       LineBox[{{2.0555555555555554`, 0.525}, {1.5, 0.75}}]}}, {}}, {}}, {
    StyleBox[{
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], 
       InsetBox["\<\"+\"\>", {1.6, -0.25}], 
       InsetBox["\<\"-\"\>", {1.6, 0.25}]}, 
      {RGBColor[0.8, 0., 0.], InsetBox["\<\"-\"\>", {1.4, -0.25}], 
       InsetBox["\<\"+\"\>", {1.4, 0.25}]}},
     StripOnInput->False,
     FontSize->14,
     FontWeight->Bold], 
    {RGBColor[0, 
      NCache[
       Rational[2, 3], 0.6666666666666666], 0], GeometricTransformationBox[
      {AbsoluteThickness[2], LineBox[{{-0.18, -0.87}, {-0.12, -0.83}}], 
       LineBox[{{-0.12, -0.87}, {-0.18, -0.83}}]}, {{{
       0.7071067811865475, -0.7071067811865475}, {0.7071067811865475, 
       0.7071067811865475}}, Center}], GeometricTransformationBox[
      {AbsoluteThickness[2], LineBox[{{0.12, 0.83}, {0.18, 0.87}}], 
       LineBox[{{0.18, 0.83}, {0.12, 0.87}}]}, {{{
       0.7071067811865475, -0.7071067811865475}, {0.7071067811865475, 
       0.7071067811865475}}, Center}]}, 
    {RGBColor[0.8, 0., 0.], GeometricTransformationBox[
      {AbsoluteThickness[2], 
       LineBox[{{0.82, -0.16999999999999998`}, {0.88, -0.13}}], 
       LineBox[{{0.88, -0.16999999999999998`}, {0.82, -0.13}}]}, {{{
       0.7071067811865475, 0.7071067811865475}, {-0.7071067811865475, 
       0.7071067811865475}}, Center}], GeometricTransformationBox[
      {AbsoluteThickness[2], LineBox[{{-0.18, 0.83}, {-0.12, 0.87}}], 
       LineBox[{{-0.12, 0.83}, {-0.18, 0.87}}]}, {{{0.7071067811865475, 
       0.7071067811865475}, {-0.7071067811865475, 0.7071067811865475}}, 
       Center}]}}},
  BaseStyle->{12, FontFamily -> "Times"},
  ImageSize->300]], "Output",
 CellChangeTimes->{
  3.623166841498167*^9, {3.623462765313425*^9, 3.62346278871957*^9}, 
   3.6236324671032877`*^9, 3.62363368345162*^9, 3.6236337637697563`*^9, 
   3.880665155641748*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"ae203d0f-34e1-48a1-8a04-ddb84e0911b3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Under Shading and Offsets  (with Code)", "Subsection",
 CellChangeTimes->{
  3.3824524252213373`*^9, {3.514308595622859*^9, 3.514308595844242*^9}, 
   3.514662627149618*^9, 3.514662723834064*^9, {3.614640343117742*^9, 
   3.614640359900044*^9}, {3.61464046603579*^9, 3.614640474370236*^9}, {
   3.614640548453722*^9, 3.6146405492848988`*^9}, {3.614641131517108*^9, 
   3.614641131519636*^9}, {3.614643664517418*^9, 3.614643676925076*^9}, 
   3.6230283218411617`*^9, {3.6230855980843983`*^9, 3.623085608091147*^9}, {
   3.623112330892098*^9, 3.6231123328745813`*^9}, 3.623157958362627*^9, {
   3.6238028654004107`*^9, 
   3.623802867037763*^9}},ExpressionUUID->"8b35fabb-549e-4d32-8382-\
0080ef64c2fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"col1", "=", 
      RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
     RowBox[{"col2", "=", 
      RowBox[{"Darker", "[", "Red", "]"}]}]}], "}"}], ",", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "=", ".5"}], ",", 
       RowBox[{"tOS", "=", "1.5"}], ",", 
       RowBox[{"b", "=", "1.75"}], ",", 
       RowBox[{"c", "=", "2.25"}], ",", 
       RowBox[{"d", "=", "1.2"}], ",", 
       RowBox[{"USW1", "=", 
        RowBox[{"UnderShadeWrapper", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", 
           RowBox[{"Opacity", "[", ".5", "]"}], ",", "col1", ",", 
           RowBox[{"CapForm", "[", "\"\<Butt\>\"", "]"}]}], "}"}], "]"}]}], 
       ",", 
       RowBox[{"USW2", "=", 
        RowBox[{"UnderShadeWrapper", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", 
           RowBox[{"Opacity", "[", ".5", "]"}], ",", "col2", ",", 
           RowBox[{"CapForm", "[", "\"\<Butt\>\"", "]"}]}], "}"}], "]"}]}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cir2", "=", 
          RowBox[{"DrawCircuit", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "d"}], ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"d", ",", "0"}], "}"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"OffsetPoints", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], ",", ".3", ",", ".875"}], 
                 "]"}], ",", 
                RowBox[{
                "Resistor", "[", 
                 "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\"]\
, \"1\"]\)\>\"", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], ",", 
                RowBox[{
                "Resistor", "[", 
                 "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\"]\
, \"2\"]\)\>\"", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"OffsetPoints", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}], ",", ".3", ",", 
                  RowBox[{"-", ".875"}]}], "]"}], ",", 
                RowBox[{
                "Resistor", "[", 
                 "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\"]\
, \"3\"]\)\>\"", "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"TextOffsetScale", "\[Rule]", "tOS"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"cir1", "=", 
          RowBox[{"DrawCircuit", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "b"}], ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1.5"}], ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"3", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", ".5"}], ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"6", ",", 
                RowBox[{"{", 
                 RowBox[{"b", ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"5", ",", 
                RowBox[{"{", 
                 RowBox[{"1.5", ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"4", ",", 
                RowBox[{"{", 
                 RowBox[{".5", ",", "0"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"7", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1.5"}], ",", 
                  RowBox[{"-", "a"}]}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"8", ",", 
                RowBox[{"{", 
                 RowBox[{".5", ",", 
                  RowBox[{"-", "a"}]}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"10", ",", 
                RowBox[{"{", 
                 RowBox[{"1.5", ",", "a"}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"9", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", ".5"}], ",", "a"}], "}"}]}], "}"}]}], "}"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"5", ",", "6"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"2", ",", "7"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"4", ",", "8"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"3", ",", "9"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"5", ",", "10"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"9", ",", "10"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"7", ",", "8"}], "}"}], ",", 
                RowBox[{"Wire", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}]}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"2", ",", "3"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}], 
                  ",", 
                  RowBox[{"Resistor", "[", 
                   RowBox[{
                   "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\
\"], \"1\"]\)\>\"", ",", 
                    RowBox[{"TextOffset", "\[Rule]", 
                    RowBox[{"-", "tOS"}]}]}], "]"}], ",", 
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}],
                  "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"3", ",", "4"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}], 
                  ",", 
                  RowBox[{"Resistor", "[", 
                   RowBox[{
                   "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\
\"], \"2\"]\)\>\"", ",", 
                    RowBox[{"TextOffset", "\[Rule]", 
                    RowBox[{"-", "tOS"}]}]}], "]"}], ",", 
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}]}],
                  "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"4", ",", "5"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW1"}]}], "]"}], 
                  ",", 
                  RowBox[{"Resistor", "[", 
                   RowBox[{
                   "\"\<\!\(\*SubscriptBox[StyleBox[\"R\",FontSlant->\"Italic\
\"], \"3\"]\)\>\"", ",", 
                    RowBox[{"TextOffset", "\[Rule]", 
                    RowBox[{"-", "tOS"}]}]}], "]"}], ",", 
                  RowBox[{"Wire", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"WrapperFunction", "\[Rule]", "USW2"}]}], "]"}]}],
                  "}"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"TextOffsetScale", "\[Rule]", "1.1"}]}], "]"}]}]}], "}"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"cir1", ",", 
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"AbsolutePointSize", "[", "10", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"col1", ",", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "b"}], ",", "0"}], "}"}], "]"}], ",", 
                   RowBox[{"Text", "[", 
                    RowBox[{"\"\<1\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "b"}], ",", 
                    RowBox[{"-", ".33"}]}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"col2", ",", 
                   RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"b", ",", "0"}], "}"}], "]"}], ",", 
                   RowBox[{"Text", "[", 
                    RowBox[{"\"\<2\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"b", ",", 
                    RowBox[{"-", ".33"}]}], "}"}]}], "]"}]}], "}"}]}], "}"}], 
               ",", "14", ",", "Bold"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Text", "[", "\"\<\[DoubleLongRightArrow]\>\"", "]"}], 
              ",", "18"}], "]"}], "//", 
            RowBox[{
             RowBox[{"Translate", "[", 
              RowBox[{"#", ",", 
               RowBox[{"{", 
                RowBox[{"c", ",", "0"}], "}"}]}], "]"}], "&"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"AbsolutePointSize", "[", "12", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"col1", ",", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "d"}], ",", "0"}], "}"}], "]"}], ",", 
                    RowBox[{"Text", "[", 
                    RowBox[{"\"\<1\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "d"}], ",", 
                    RowBox[{"-", ".35"}]}], "}"}]}], "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"col2", ",", 
                    RowBox[{"Point", "[", 
                    RowBox[{"{", 
                    RowBox[{"d", ",", "0"}], "}"}], "]"}], ",", 
                    RowBox[{"Text", "[", 
                    RowBox[{"\"\<2\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"d", ",", 
                    RowBox[{"-", ".35"}]}], "}"}]}], "]"}]}], "}"}]}], "}"}], 
                ",", "14", ",", "Bold"}], "]"}], ",", "cir2"}], "}"}], "//", 
            RowBox[{
             RowBox[{"Translate", "[", 
              RowBox[{"#", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"2", "c"}], "-", ".5"}], ",", "0"}], "}"}]}], "]"}],
              "&"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
         RowBox[{"BaseStyle", "->", 
          RowBox[{"{", 
           RowBox[{"12", ",", 
            RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4459839122254133`*^9, 3.4459839191902933`*^9}, {
   3.5402206809683533`*^9, 3.5402208670522633`*^9}, {3.540221363886578*^9, 
   3.540221392057741*^9}, {3.5402215247954187`*^9, 3.540221923739012*^9}, {
   3.5402220228646183`*^9, 3.5402220644883127`*^9}, {3.540222106429492*^9, 
   3.5402221956192627`*^9}, {3.540229917103417*^9, 3.540230000969558*^9}, {
   3.540230087318263*^9, 3.540230090742174*^9}, {3.5402301233886223`*^9, 
   3.540230185290674*^9}, {3.540230229387293*^9, 3.540230249424526*^9}, {
   3.540230371485157*^9, 3.540230493118559*^9}, 3.5402305557292833`*^9, {
   3.540230691994713*^9, 3.5402307673287783`*^9}, 3.54023080792239*^9, {
   3.540230850849782*^9, 3.540230906390469*^9}, {3.540231017946349*^9, 
   3.540231113375018*^9}, 3.540231156462583*^9, {3.540231342847001*^9, 
   3.5402313540816593`*^9}, {3.540246965214381*^9, 3.540246990984063*^9}, {
   3.540247143600514*^9, 3.540247191895075*^9}, {3.5402472219235*^9, 
   3.540247339948132*^9}, {3.540947437743802*^9, 3.540947463526163*^9}, {
   3.5409475097168417`*^9, 3.540947510698008*^9}, {3.5409475940988503`*^9, 
   3.540947649493478*^9}, 3.541112264755221*^9, {3.541112299244982*^9, 
   3.5411123066219482`*^9}, {3.5411123510688677`*^9, 
   3.5411125844231873`*^9}, {3.5835035758519297`*^9, 3.583503682545272*^9}, {
   3.5835037362851973`*^9, 3.583503744542756*^9}, {3.5835038141822863`*^9, 
   3.583503817376923*^9}, {3.583504000838662*^9, 3.583504005970738*^9}, 
   3.583504053324847*^9, {3.5835049402517233`*^9, 3.5835050969522047`*^9}, {
   3.5835051429544497`*^9, 3.5835052827879868`*^9}, {3.58350545224009*^9, 
   3.583505494326024*^9}, {3.583505533734254*^9, 3.583505570084372*^9}, {
   3.583505605082556*^9, 3.583505609889883*^9}, {3.583505642602515*^9, 
   3.583505659749153*^9}, {3.583505755687511*^9, 3.583505771278768*^9}, {
   3.583505807517623*^9, 3.583505912142049*^9}, {3.583506009725512*^9, 
   3.5835060619241953`*^9}, {3.5836753064744997`*^9, 
   3.5836753416015453`*^9}, {3.5836754176382847`*^9, 3.583675525566654*^9}, {
   3.583675587971455*^9, 3.583675605794607*^9}, {3.5836756587817802`*^9, 
   3.58367579689275*^9}, {3.583675905683687*^9, 3.583675911182728*^9}, {
   3.583675951082445*^9, 3.583676100408504*^9}, {3.58367675237046*^9, 
   3.5836767579623404`*^9}, {3.583677601366181*^9, 3.5836776297584953`*^9}, {
   3.583677689341235*^9, 3.583677696393572*^9}, {3.583688088938158*^9, 
   3.583688093673893*^9}, {3.583707764480423*^9, 3.583707802819125*^9}, 
   3.583708010529396*^9, {3.5837089350999317`*^9, 3.583708936028783*^9}, 
   3.583712736326149*^9, {3.583712768361457*^9, 3.583712769969742*^9}, {
   3.583862750148386*^9, 3.583862750484356*^9}, {3.6230851086664877`*^9, 
   3.623085375792729*^9}, {3.62314969039434*^9, 3.62314969219101*^9}, {
   3.623149739798668*^9, 3.623149747538454*^9}, {3.623149777843968*^9, 
   3.6231497780982857`*^9}, {3.623462703237241*^9, 3.623462749691649*^9}, {
   3.62363290211417*^9, 3.623632990768339*^9}, 3.62363309829701*^9, {
   3.623633776632935*^9, 3.623633790930298*^9}, {3.810074326252966*^9, 
   3.810074331179145*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"98156dd1-2708-4548-abe3-6219feae3d4a"],

Cell[BoxData[
 GraphicsBox[{{{{
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{1.3, 0.}, {1.5, 0.}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{0.5, 0.}, {0.7, 0.}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], 
       LineBox[{{0.30000000000000004`, 0.}, {0.5, 0.}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-0.5, 0.}, {-0.3, 0.}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-0.7, 0.}, {-0.5, 0.}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-1.5, 0.}, {-1.3, 0.}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-1.5, -0.5}, {0.5, -0.5}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-0.5, 0.5}, {1.5, 0.5}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{1.5, 0.}, {1.5, 0.5}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-0.5, 0.}, {-0.5, 0.5}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{0.5, 0.}, {0.5, -0.5}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-1.5, 0.}, {-1.5, -0.5}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{1.5, 0.}, {1.75, 0.}}]}, 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], AbsoluteThickness[6], 
       Opacity[0.5], CapForm["Butt"], LineBox[{{-1.75, 0.}, {-1.5, 0.}}]}}, {{
       LineBox[{{-1.75, 0.}, {-1.5, 0.}}], LineBox[{{1.5, 0.}, {1.75, 0.}}], 
       LineBox[{{-1.5, 0.}, {-1.5, -0.5}}], LineBox[{{0.5, 0.}, {0.5, -0.5}}],
        LineBox[{{-0.5, 0.}, {-0.5, 0.5}}], LineBox[{{1.5, 0.}, {1.5, 0.5}}], 
       LineBox[{{-0.5, 0.5}, {1.5, 0.5}}], 
       LineBox[{{-1.5, -0.5}, {0.5, -0.5}}], {
        LineBox[{{-1.5, 0.}, {-1.3, 0.}}], LineBox[{{-0.7, 0.}, {-0.5, 0.}}], 
        {AbsoluteThickness[2], 
         LineBox[{{-1.3, 0.}, {-1.25, 0.05}, {-1.15, -0.05}, {-1.05, 
          0.05}, {-0.95, -0.05}, {-0.85, 0.05}, {-0.75, -0.05}, {-0.7, 0.}}], 
         InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"1\\\"]\\)\"\>", {-1., -0.33000000000000007}]}}, {
        LineBox[{{-0.5, 0.}, {-0.3, 0.}}], 
        LineBox[{{0.30000000000000004`, 0.}, {0.5, 0.}}], 
        {AbsoluteThickness[2], 
         LineBox[{{-0.3, 0.}, {-0.25, 
          0.05}, {-0.14999999999999997`, -0.05}, {-0.04999999999999999, 
          0.05}, {0.050000000000000044`, -0.05}, {0.15000000000000002`, 
          0.05}, {0.25, -0.05}, {0.30000000000000004`, 0.}}], 
         InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"2\\\"]\\)\"\>", {0., -0.33000000000000007}]}}, {
        LineBox[{{0.5, 0.}, {0.7, 0.}}], LineBox[{{1.3, 0.}, {1.5, 0.}}], 
        {AbsoluteThickness[2], 
         LineBox[{{0.7, 0.}, {0.75, 0.05}, {0.8500000000000001, -0.05}, {0.95,
           0.05}, {1.05, -0.05}, {1.15, 0.05}, {1.25, -0.05}, {1.3, 0.}}], 
         InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"3\\\"]\\)\"\>", {1., -0.33000000000000007}]}}}, {}}, {}}, 
    StyleBox[
     {AbsolutePointSize[10], 
      {RGBColor[0, 
        NCache[
         Rational[2, 3], 0.6666666666666666], 0], PointBox[{-1.75, 0}], 
       InsetBox["\<\"1\"\>", {-1.75, -0.33}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], PointBox[{1.75, 0}], 
       InsetBox["\<\"2\"\>", {1.75, -0.33}]}},
     StripOnInput->False,
     FontSize->14,
     FontWeight->Bold]}, GeometricTransformationBox[
    StyleBox[InsetBox["\<\"\[DoubleLongRightArrow]\"\>", {0, 0}],
     StripOnInput->False,
     FontSize->18], {2.25, 0}], GeometricTransformationBox[{
     StyleBox[
      {AbsolutePointSize[12], 
       {RGBColor[0, 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], PointBox[{-1.2, 0}], 
        InsetBox["\<\"1\"\>", {-1.2, -0.35}]}, 
       {RGBColor[
         NCache[
          Rational[2, 3], 0.6666666666666666], 0, 0], PointBox[{1.2, 0}], 
        InsetBox["\<\"2\"\>", {1.2, -0.35}]}},
      StripOnInput->False,
      FontSize->14,
      FontWeight->
       Bold], {{}, {{
        LineBox[{{-1.2, 0.}, {-0.48, 0.6719999999999999}}], {
         LineBox[{{-0.48, 0.6719999999999999}, {-0.288, 0.6719999999999999}}],
          LineBox[{{0.28800000000000003`, 0.6719999999999999}, {0.48, 
          0.6719999999999999}}], 
         {AbsoluteThickness[2], 
          LineBox[{{-0.288, 0.6719999999999999}, {-0.24, 
           0.72}, {-0.14399999999999996`, 
           0.6239999999999999}, {-0.04799999999999999, 0.72}, {
           0.04800000000000004, 0.6239999999999999}, {0.14400000000000002`, 
           0.72}, {0.24, 0.6239999999999999}, {0.28800000000000003`, 
           0.6719999999999999}}], 
          InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"1\\\"]\\)\"\>", {0., 0.96}]}}, 
        LineBox[{{0.48, 0.6719999999999999}, {1.2, 0.}}], {
         LineBox[{{-1.2, 0.}, {-0.2879999999999999, 0.}}], 
         LineBox[{{0.28800000000000003`, 0.}, {1.2, 0.}}], 
         {AbsoluteThickness[2], 
          LineBox[{{-0.2879999999999999, 0.}, {-0.23999999999999988`, 
           0.047999999999999994`}, {-0.1439999999999999, \
-0.047999999999999994`}, {-0.04799999999999982, 0.047999999999999994`}, {
           0.04800000000000004, -0.047999999999999994`}, {
           0.14400000000000013`, 0.047999999999999994`}, {
           0.24, -0.047999999999999994`}, {0.28800000000000003`, 0.}}], 
          InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"2\\\"]\\)\"\>", {0., 0.288}]}}, 
        LineBox[{{-1.2, 0.}, {-0.48, -0.6719999999999999}}], {
         LineBox[{{-0.48, -0.6719999999999999}, {-0.288, \
-0.6719999999999999}}], 
         LineBox[{{0.28800000000000003`, -0.6719999999999999}, {
          0.48, -0.6719999999999999}}], 
         {AbsoluteThickness[2], 
          LineBox[{{-0.288, -0.6719999999999999}, {-0.24, \
-0.6239999999999999}, {-0.14399999999999996`, -0.72}, {-0.04799999999999999, \
-0.6239999999999999}, {0.04800000000000004, -0.72}, {
           0.14400000000000002`, -0.6239999999999999}, {0.24, -0.72}, {
           0.28800000000000003`, -0.6719999999999999}}], 
          InsetBox["\<\"\\!\\(\\*SubscriptBox[StyleBox[\\\"R\\\",FontSlant->\\\
\"Italic\\\"], \\\"3\\\"]\\)\"\>", {0., -0.3839999999999999}]}}, 
        LineBox[{{0.48, -0.6719999999999999}, {1.2, 0.}}]}, {}}, {}}}, {
    4., 0}]},
  BaseStyle->{12, FontFamily -> "Times"},
  ImageSize->450]], "Output",
 CellChangeTimes->{
  3.6236329583481417`*^9, {3.623633080283968*^9, 3.6236330998760843`*^9}, 
   3.623633345227809*^9, {3.6236337696560926`*^9, 3.623633792833354*^9}, 
   3.810074331779159*^9, 3.8806651634461927`*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"b5e4292c-6182-4467-a696-51034d80b0c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"cir", "=", 
   RowBox[{"DrawCircuit", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<b\>\"", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", 
           RowBox[{"-", "3"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<c\>\"", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "3"}], ",", 
           RowBox[{"-", "4"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<d\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"\"\<e\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "3"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<f\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<g\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"-", "3"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<h\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"-", "4"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<b\>\"", ",", "\"\<c\>\""}], "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<h\>\"", ",", "\"\<g\>\""}], "}"}], ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<b\>\"", ",", "\"\<d\>\""}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Resistor", "[", 
           RowBox[{"\"\<24\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
            RowBox[{"ResistorTurnNumber", "\[Rule]", "20"}], ",", 
            RowBox[{"WrapperFunction", "\[Rule]", 
             RowBox[{"UnderRectangleWrapper", "[", 
              RowBox[{"LightRed", ",", 
               RowBox[{"OverWidth", "\[Rule]", ".2"}]}], "]"}]}]}], "]"}], 
          "}"}]}], "}"}], ",", "\n", "\t", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<b\>\"", ",", "\"\<e\>\""}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Resistor", "[", 
           RowBox[{"\"\<6\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
            RowBox[{"ResistorDirectives", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Thickness", "[", ".005", "]"}], ",", 
               RowBox[{"Darker", "[", "Red", "]"}]}], "}"}]}]}], "]"}], 
          "}"}]}], "}"}], ",", "\n", "\t", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<e\>\"", ",", "\"\<g\>\""}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Resistor", "[", 
           RowBox[{"\"\<6\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
            RowBox[{"TextOffset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<e\>\"", ",", "\"\<d\>\""}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Wire", "[", 
            RowBox[{".15", ",", 
             RowBox[{"WrapperFunction", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Line", "[", 
                    RowBox[{"{", "r__", "}"}], "]"}], "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Thickness", "[", ".02", "]"}], ",", 
                    RowBox[{"Opacity", "[", ".4", "]"}], ",", 
                    RowBox[{"Darker", "[", "Yellow", "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", "r", "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", "r", "}"}], "]"}]}], "}"}]}], "}"}]}], "&"}],
                ")"}]}]}], "]"}], ",", 
           RowBox[{
           "Resistor", "[", "\"\<4\[VeryThinSpace]\[CapitalOmega]\>\"", "]"}],
            ",", 
           RowBox[{"Resistor", "[", "\"\<\>\"", "]"}]}], "}"}]}], "}"}], ",", 
       "\n", "\t", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<d\>\"", ",", "\"\<g\>\""}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Resistor", "[", 
           RowBox[{"\"\<12\[VeryThinSpace]\[CapitalOmega]\>\"", ",", 
            RowBox[{"ResistorTurnNumber", "\[Rule]", "20"}]}], "]"}], "}"}]}],
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TextOffsetScale", "\[Rule]", "1.5"}], ",", 
     RowBox[{"ResistorDirectives", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Thickness", "[", ".01", "]"}], ",", 
        RowBox[{"Darker", "[", "Blue", "]"}]}], "}"}]}], ",", 
     RowBox[{"WireDirectives", "\[Rule]", 
      RowBox[{"{", "Black", "}"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"Graphics", "[", 
  RowBox[{"cir", ",", 
   RowBox[{"BaseStyle", "->", 
    RowBox[{"{", 
     RowBox[{"12", ",", 
      RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "}"}]}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.4761292490659103`*^9, 3.4761293838992033`*^9}, {
   3.476129698029574*^9, 3.476129782750861*^9}, {3.476129816638576*^9, 
   3.476129910996469*^9}, {3.4761455660663*^9, 3.476145587414956*^9}, 
   3.4761460829040728`*^9, {3.476149521319887*^9, 3.476149533061009*^9}, {
   3.476149575813961*^9, 3.476149576115827*^9}, {3.476150879325314*^9, 
   3.476150895258357*^9}, {3.4761850112777243`*^9, 3.476185014730084*^9}, {
   3.476212953593615*^9, 3.476212956329454*^9}, {3.476214335836153*^9, 
   3.476214336584611*^9}, {3.4763639059736757`*^9, 3.476363936141918*^9}, {
   3.47636407342378*^9, 3.476364092124332*^9}, {3.476364127790429*^9, 
   3.476364144321677*^9}, {3.476364195314004*^9, 3.476364196049848*^9}, 
   3.4763695607250433`*^9, {3.476369635331408*^9, 3.4763696514804697`*^9}, {
   3.4763697629746847`*^9, 3.476369763205612*^9}, {3.4763711198632917`*^9, 
   3.4763711202453337`*^9}, {3.4763785594621277`*^9, 3.476378596108672*^9}, {
   3.4763786323585243`*^9, 3.476378638056254*^9}, {3.4763892636059923`*^9, 
   3.476389264556416*^9}, {3.476389326268113*^9, 3.476389359763085*^9}, {
   3.4764093372903347`*^9, 3.4764093456959257`*^9}, {3.476410477523383*^9, 
   3.47641047823238*^9}, {3.4764407569076843`*^9, 3.476440827582417*^9}, {
   3.476461953560154*^9, 3.476462066860132*^9}, {3.476462100517898*^9, 
   3.4764621546865788`*^9}, 3.4764630979890347`*^9, {3.476580753626052*^9, 
   3.476580801838385*^9}, {3.4765817092312317`*^9, 3.476581717217906*^9}, {
   3.476582992310255*^9, 3.476583005154969*^9}, {3.476583124224646*^9, 
   3.4765831308252077`*^9}, {3.476584152104972*^9, 3.476584152588331*^9}, 
   3.476612264565506*^9, {3.4766124497587767`*^9, 3.476612465698515*^9}, {
   3.4766144525463743`*^9, 3.47661446554644*^9}, {3.4766357173803263`*^9, 
   3.47663572751635*^9}, {3.4766357583654127`*^9, 3.476635770589525*^9}, {
   3.476635919313911*^9, 3.476635920064396*^9}, 3.4766372396470537`*^9, {
   3.476641126718026*^9, 3.476641142446607*^9}, {3.4766417875306063`*^9, 
   3.476641791816256*^9}, 3.4766433863239*^9, {3.476643418713928*^9, 
   3.476643473326172*^9}, {3.497365270239484*^9, 3.49736527589874*^9}, {
   3.49739851947309*^9, 3.497398528691375*^9}, {3.4973989078925*^9, 
   3.4973990159270163`*^9}, {3.4973990523171177`*^9, 3.497399222318288*^9}, {
   3.500657980366239*^9, 3.500658014614861*^9}, {3.5006580548547487`*^9, 
   3.500658064978984*^9}, {3.500658107518825*^9, 3.500658200688919*^9}, 
   3.500658234480276*^9, {3.6232490942003937`*^9, 3.6232492212868757`*^9}, {
   3.623249251678933*^9, 3.6232492535734863`*^9}, 3.623249578565042*^9, 
   3.623249613887805*^9, 3.623249747730557*^9},
 CellLabel->"In[17]:=",ExpressionUUID->"b3f24074-def8-40c3-b5b8-a8744ac27134"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0.85, 0.85], 
    PolygonBox[{{-2.290492014817037, -2.7107535923147017`}, \
{-0.28924640768529875`, -0.7095079851829635}, {-0.7095079851829635, \
-0.28924640768529875`}, {-2.7107535923147017`, -2.290492014817037}}]}, {{
     {GrayLevel[0], LineBox[{{-3., -3.}, {-3., -4.}}]}, 
     {GrayLevel[0], LineBox[{{3., -4.}, {3., -3.}}]}, {
      {GrayLevel[0], 
       LineBox[{{-3., -3.}, {-2.5006228035658693`, -2.5006228035658693`}}]}, 
      {GrayLevel[0], 
       LineBox[{{-0.49937719643413114`, -0.49937719643413114`}, \
{-4.440892098500626*^-16, -4.440892098500626*^-16}}]}, 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], Thickness[0.01], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/Xmye7sbI8sBdFqdNUo40oT5QExZzvzsdCYM/oTn
ddp1sxgPHI2YuH3CWQYM/q+Ti50XMzBA1f/b/xONfwys7s9+fett57ca/95/
FMrXg/JnyN5+fmvmz/2MDCDwY/90KJ8Bys96pCKhmvZt/5UjngZeZ77A+Zeh
fNvleR75Rp/3L+ucnDBlxsf9NlD+Uihf5kbBx6K/7/d/mLNLce/JN/sV0PgH
ElmC2Ke93D9Fza8pMOnZ/iNo/JTX0zfN1nu8vyDh8NHTX+/vz0Djw2gAS4G+
4w==
        "]], 
       InsetBox["\<\"24\[VeryThinSpace]\[CapitalOmega]\"\>", \
{-1.8001868410697606, -1.1998131589302394}]}}, {
      {GrayLevel[0], LineBox[{{-3., -3.}, {-1.9245283018867922`, -3.}}]}, 
      {GrayLevel[0], 
       LineBox[{{-1.0754716981132073`, -3.}, {4.440892098500626*^-16, -3.}}]}, 
      {RGBColor[
        NCache[
         Rational[2, 3], 0.6666666666666666], 0, 0], Thickness[0.005], 
       LineBox[{{-1.9245283018867922`, -3.}, {-1.8537735849056602`, \
-2.9292452830188678`}, {-1.712264150943396, -3.0707547169811322`}, \
{-1.5707547169811318`, -2.9292452830188678`}, {-1.4292452830188678`, \
-3.0707547169811322`}, {-1.2877358490566035`, -2.9292452830188678`}, \
{-1.1462264150943393`, -3.0707547169811322`}, {-1.0754716981132073`, -3.}}], 
       InsetBox["\<\"6\[VeryThinSpace]\[CapitalOmega]\"\>", \
{-1.4999999999999998, -2.5754716981132075}]}}, {
      {GrayLevel[0], LineBox[{{0., -3.}, {1.0754716981132078`, -3.}}]}, 
      {GrayLevel[0], 
       LineBox[{{1.9245283018867927`, -3.}, {3.0000000000000004`, -3.}}]}, 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], Thickness[0.01], 
       LineBox[{{1.0754716981132078`, -3.}, {
        1.1462264150943398`, -2.9292452830188678`}, {
        1.287735849056604, -3.0707547169811322`}, {
        1.4292452830188682`, -2.9292452830188678`}, {
        1.5707547169811322`, -3.0707547169811322`}, {
        1.7122641509433965`, -2.9292452830188678`}, {
        1.8537735849056607`, -3.0707547169811322`}, {
        1.9245283018867927`, -3.}}], 
       InsetBox["\<\"6\[VeryThinSpace]\[CapitalOmega]\"\>", \
{1.9245283018867927, -2.5754716981132075}]}}, {
      {GrayLevel[0], 
       {RGBColor[
         NCache[
          Rational[2, 3], 0.6666666666666666], 
         NCache[
          Rational[2, 3], 0.6666666666666666], 0], Thickness[0.02], Opacity[
        0.4], LineBox[{{0., -3.}, {0., -2.452830188679245}}]}, 
       LineBox[{{0., -3.}, {0., -2.452830188679245}}]}, 
      {GrayLevel[0], 
       LineBox[{{0., -1.60377358490566}, {0., -1.2264150943396224`}}]}, 
      {GrayLevel[0], 
       LineBox[{{0., -0.37735849056603765`}, {0., 4.440892098500626*^-16}}]}, 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], Thickness[0.01], 
       LineBox[{{
        0., -2.452830188679245}, {-0.07075471698113209, -2.382075471698113}, {
        0.07075471698113209, -2.240566037735849}, {-0.07075471698113209, \
-2.099056603773585}, {
        0.07075471698113209, -1.9575471698113207`}, {-0.07075471698113209, \
-1.8160377358490563`}, {0.07075471698113209, -1.6745283018867922`}, {
        0., -1.60377358490566}}], 
       InsetBox["\<\"4\[VeryThinSpace]\[CapitalOmega]\"\>", \
{-0.4245283018867925, -2.0283018867924527}]}, 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], Thickness[0.01], 
       LineBox[{{
        0., -1.2264150943396224`}, {-0.07075471698113209, \
-1.1556603773584904`}, {
        0.07075471698113209, -1.0141509433962261`}, {-0.07075471698113209, \
-0.8726415094339619}, {
        0.07075471698113209, -0.7311320754716979}, {-0.07075471698113209, \
-0.5896226415094339}, {0.07075471698113209, -0.44811320754716943`}, {
        0., -0.37735849056603765`}}], {}}}, {
      {GrayLevel[0], 
       LineBox[{{0., 0.}, {0.49937719643413087`, -0.49937719643413087`}}]}, 
      {GrayLevel[0], 
       LineBox[{{2.500622803565869, -2.500622803565869}, {
        2.9999999999999996`, -2.9999999999999996`}}]}, 
      {RGBColor[0, 0, 
        NCache[
         Rational[2, 3], 0.6666666666666666]], Thickness[0.01], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQnZ1w+Ojpr/ftofT+5NfTN83We2yfhcafqObXFJj0
bP/+RJYg9mkvMfhv5+xS3HvyzX6pGwUfi/6+t38D5UtD+Us6JydMmfFxv9Xy
PI98o89wvjWUf/GIp4HXmS/7Mx6pSKimfbO/BOVnQvn/weD7/mmyt5/fmvnT
ngEMfsD5Otbbzm81/r3/cMTE7RPO/rHXhfKPQPlRZTnzs9P/7f95crHzYgYG
h2go/weUD1HHcGDC8zrtulmMcH4/lA9Rz3RAnTVKONKEGc5Xg/I/TXZvd2Nk
OQCl4XwAgD+5hA==
        "]], 
       InsetBox["\<\"12\[VeryThinSpace]\[CapitalOmega]\"\>", \
{1.8001868410697606, -1.1998131589302394}]}}}, {}}, {}},
  BaseStyle->{12, FontFamily -> "Times"}]], "Output",
 CellChangeTimes->{3.623249615742379*^9, 3.623249749861768*^9, 
  3.623274299243762*^9, 3.623460370291745*^9, 3.623800935105454*^9, 
  3.880665174247781*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"bc814b19-25a6-4afe-8934-e1989e412762"]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{994, 638},
WindowMargins->{{Automatic, 765}, {Automatic, -294}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
ScriptSizeMultipliers->{0.9},
FrontEndVersion->"13.2 for Mac OS X x86 (64-bit) (November 18, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"181b5e7c-1074-4c19-8f93-20b011af01ce"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 315, 5, 37, "Input",ExpressionUUID->"ceabb2dd-a544-4b44-b965-2ef051224719"],
Cell[CellGroupData[{
Cell[885, 29, 198, 3, 37, "Input",ExpressionUUID->"599ed61a-d255-4608-b5cd-57bacfb6375f"],
Cell[1086, 34, 90402, 1889, 384, "Output",ExpressionUUID->"2f848f44-6ce6-41a6-bb31-b88327a7f9d5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91525, 1928, 216, 3, 37, "Input",ExpressionUUID->"d576547a-6d9c-4d8b-a6eb-077a7955079d"],
Cell[91744, 1933, 5859, 128, 1012, "Output",ExpressionUUID->"77a1d490-f690-4492-be25-3955b9ce44fb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97640, 2066, 500, 9, 101, "Subsection",ExpressionUUID->"95527c75-13c7-49a4-97ae-daa15e7a6f3e"],
Cell[CellGroupData[{
Cell[98165, 2079, 4280, 92, 272, "Input",ExpressionUUID->"9cf7a07d-efe3-43a0-98a9-7d6fd16dec29"],
Cell[102448, 2173, 7542, 130, 208, "Output",ExpressionUUID->"d0acd0d2-60a6-4e22-9104-abbd0be62d49"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110027, 2308, 1065, 26, 90, "Input",ExpressionUUID->"ab2fed3d-718b-41b1-8227-3dc53c6e2f34"],
Cell[111095, 2336, 865, 15, 561, "Output",ExpressionUUID->"94ef26ed-8797-4fab-b9c7-9f30d0ff8936"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[112009, 2357, 348, 5, 67, "Subsection",ExpressionUUID->"7b66c688-709c-4e09-a355-eb14de52a614"],
Cell[CellGroupData[{
Cell[112382, 2366, 1633, 44, 142, "Input",ExpressionUUID->"cb6d9e4a-c364-4c48-88f1-bcf72496bdae"],
Cell[114018, 2412, 2277, 41, 79, "Output",ExpressionUUID->"94e01268-59b8-4d73-a48a-1d48b5cb6cb0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116332, 2458, 1785, 46, 142, "Input",ExpressionUUID->"97ed8f19-d22f-4eee-9711-638228d9c60c"],
Cell[118120, 2506, 1358, 24, 71, "Output",ExpressionUUID->"d20a630c-9222-4120-a780-92e07bb929aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[119515, 2535, 1941, 49, 142, "Input",ExpressionUUID->"3d7a0bdf-1fa7-41fd-9087-f8aa78843f9a"],
Cell[121459, 2586, 2378, 40, 77, "Output",ExpressionUUID->"4ca90d92-1e2b-411b-aa99-26974e3c07f9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[123886, 2632, 373, 6, 67, "Subsection",ExpressionUUID->"6e2d50f1-a6f3-4250-8b4a-54181fc14dc9"],
Cell[CellGroupData[{
Cell[124284, 2642, 7362, 148, 376, "Input",ExpressionUUID->"67bd2be1-7272-4305-8ff1-090e72841f3a"],
Cell[131649, 2792, 10627, 198, 188, "Output",ExpressionUUID->"671922b2-674b-4eda-8604-ec1179554b83"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[142325, 2996, 637, 10, 67, "Subsection",ExpressionUUID->"a19cbd0e-6745-4519-9eec-80fb83904d37"],
Cell[CellGroupData[{
Cell[142987, 3010, 2940, 65, 246, "Input",ExpressionUUID->"7bf4b89c-c6dc-453a-b889-ba6f02966eb0"],
Cell[145930, 3077, 3193, 56, 75, "Output",ExpressionUUID->"3d3cdbd4-cb49-4f32-80e6-ff0778625c2b"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[149172, 3139, 585, 9, 67, "Subsection",ExpressionUUID->"093d1d8d-53e7-4759-831f-e3ad5f83d7fe"],
Cell[CellGroupData[{
Cell[149782, 3152, 202, 3, 37, "Input",ExpressionUUID->"4e6e2046-7667-4450-9694-3215b625dff5"],
Cell[149987, 3157, 10044, 236, 149, "Output",ExpressionUUID->"04c55bef-7305-46f0-a1f1-16a56e69766e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[160068, 3398, 8325, 194, 557, "Input",ExpressionUUID->"7f0a4f11-37de-405e-bc15-00ac53403a35"],
Cell[168396, 3594, 7521, 148, 235, "Output",ExpressionUUID->"945d9413-095d-4005-bfbf-408b2c2c4ae9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175954, 3747, 21614, 474, 1106, "Input",ExpressionUUID->"02c441d3-94e1-42a9-9c84-06f5b8a4d72f"],
Cell[197571, 4223, 13434, 252, 269, "Output",ExpressionUUID->"ae203d0f-34e1-48a1-8a04-ddb84e0911b3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[211054, 4481, 707, 11, 67, "Subsection",ExpressionUUID->"8b35fabb-549e-4d32-8382-0080ef64c2fb"],
Cell[CellGroupData[{
Cell[211786, 4496, 17538, 398, 924, "Input",ExpressionUUID->"98156dd1-2708-4548-abe3-6219feae3d4a"],
Cell[229327, 4896, 8085, 161, 174, "Output",ExpressionUUID->"b5e4292c-6182-4467-a696-51034d80b0c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[237449, 5062, 8458, 189, 480, "Input",ExpressionUUID->"b3f24074-def8-40c3-b5b8-a8744ac27134"],
Cell[245910, 5253, 5465, 112, 347, "Output",ExpressionUUID->"bc814b19-25a6-4afe-8934-e1989e412762"]
}, Open  ]]
}, Open  ]]
}
]
*)

